package se;
import org.jgrapht.*;
import org.jgrapht.graph.*;

public class ActionEdge extends DefaultEdge implements Annotable {

		private Formula annotation;
		private Action action;

        public ActionEdge(Action action){
            super();
            this.action = action;
            this.annotation = new FalseFormula();
        }
        
        public Action getAction(){
        	return action;
        }
        
        public Location getSource(){
        	return (Location)super.getSource();
        }
        
        public Location getTarget(){
        	return (Location)super.getTarget();
        }
        
    	public Formula getAnnotation(){ 
    		return annotation;
    	}

    	public void setAnnotation(Formula formula){ 
    		this.annotation = formula;
    	}
    	
    	public String print(){
    		return "("+this.getSource().print()+","+this.action.print()+","+this.getTarget().print()+")";
    	}

}
