package se;

import java.util.ArrayList;

public class AgentConstant extends Agent implements Constant {
	private ParametricAgentConstant constant;
	private PublicKeyConstant publicKey;
	private PrivateKeyConstant privateKey;	
	
	public AgentConstant(){
		this.constant = new ParametricAgentConstant();
		this.publicKey=new PublicKeyConstant(this);
		this.privateKey=new PrivateKeyConstant(this);
	}
	
	public AgentConstant(String messageString){
		this();
		this.messageString = messageString;
	}

	public ParametricAgentConstant getParametricAgentConstant(){
		return constant;
	}
	
	public PublicKeyConstant getPublicKeyConstant(){
		return publicKey;
	}
	
	public PrivateKeyConstant getPrivateKeyConstant(){
		return privateKey;
	}
		
	public ParametricAgentConstant eval(Environment env) {
		return constant;
	}
	public ParametricMessage eval4Domain(){return this.constant;}
	
	public String print() {
		return "AgentConstant "+this.hashCode()+" (with "+this.constant.print()+")";
	}	

	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){return list;}
	
	public Message getAnotherOfTheSameType(String name){
		return new AgentConstant(name);
	}
	
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
//		System.out.print("subs in AgentConstant "+this.messageString+ "-> ");
		for(int i=0;i<mex_newMex.size();i++){
			if(mex_newMex.get(i).getElement0().equals(this)){
//				System.out.println(mex_newMex.get(i).getElement1().toString()+" FOUND! :) ");
				return mex_newMex.get(i).getElement1();
			}
		}
		return this;
	}
	
	//interpolantString
	public String interpolantString(Environment env){
		return this.constant.satString();
	}
	
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		return this.constant.satString();
	}
	
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment){
		return this.constant.satString();
	}
	
	public String toString(){
		return this.messageString;
	}
}
