package se;

import java.util.ArrayList;


public class ConcatenatedMessage extends Message{
	
	private Message message1;
	private Message message2;
	
	public ConcatenatedMessage(Message m1, Message m2){
		this.message1 = m1;
		this.message2 = m2;
	}
	
	public Message getAnotherOfTheSameType(String name){
		return new ConcatenatedMessage(this.message1.getAnotherOfTheSameType(name),this.message2.getAnotherOfTheSameType(name));
	}
	
	public ConcatenatedMessage(Message m1, Message m2, String messageString){
		this(m1, m2);
		this.messageString = messageString;
	}
	
	public ParametricConcatenatedMessage eval(Environment env){
		ParametricConcatenatedMessage cmp = new ParametricConcatenatedMessage(this.message1.eval(env),this.message2.eval(env));
		return cmp;
	}

	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
//		System.out.println("subs in concMsg "+this.messageString+" -> ");
		Message m1=(Message)this.message1.substitute(mex_newMex);
		Message m2=(Message)this.message2.substitute(mex_newMex);
//		System.out.println("{"+m1.toString()+","+m2.toString()+"}");
		return new ConcatenatedMessage(m1,m2,"{"+m1.toString()+","+m2.toString()+"}");
	}
	
//	public String interpolantString(Domain dom,Environment env,int RPD){
//		return "(IK"+RPD+" (pair "+this.message1.interpolantString()+" "+this.message2.interpolantString()+"))";
//	}

	
	public String print() {
		return "ConcatenatedMessage "+this.hashCode()+" : {"+this.message1.print()+ "}{" + this.message2.print()+"}";
	}
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){		
		list=this.message1.getVars(list);
		list=this.message1.getVars(list);
		return list;
	}
	public ParametricMessage eval4Domain(Environment env){
		return new ParametricConcatenatedMessage(this.message1.eval4Domain(env),this.message2.eval4Domain(env)); 
	}
	
	public String interpolantString(Environment env){
		return "(pair "+this.message1.interpolantString(env)+" "+this.message2.interpolantString(env)+")";
	}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		return "(pair "+this.message1.interpolantString(env,assignment)+" "+this.message2.interpolantString(env,assignment)+")";
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message,ParametricMessage>> assignment){		
		return "(pair "+this.message1.interpolantString(env,assignment)+" "+this.message2.interpolantString(env,assignment)+")";
	}
	
	public String toString(){
		return this.messageString;
	}
}
