package se;

import java.util.HashSet;
import java.util.Iterator;

public class ConstraintSet extends HashSet<Constraint> {
	
	public boolean addConstraint(Constraint constraint){
				boolean exitStatus;				
				exitStatus=this.add(constraint);
				
				if(!exitStatus)
					System.out.println("DEBUG cannot add constraint: "+constraint.print()+"\n to constraintSet");
				
				return exitStatus;
	}

	
	// returns a set of StdConstraints by converting each IKConstraint into a standard one
	public StdConstraintSet standardize() {
		StdConstraintSet returnSet = new StdConstraintSet();
//		System.out.println("ConstraintSet");
//		Iterator<Constraint> iterD=this.iterator();			
//		while(iterD.hasNext()){
//			System.out.println(iterD.next().print());
//		}
		
		Iterator<Constraint> iter=this.iterator();			
		while(iter.hasNext()){
			Constraint current=iter.next();
			if(current instanceof StdConstraint)
				returnSet.add((StdConstraint)current);
			else{				
				returnSet.add(((IKConstraint)current).standardize());
				//System.out.println("IKCons"+((IKConstraint)current).print());
			}
		}
		
//		System.out.println("STDConstraintSet");
//		Iterator<StdConstraint> iterD2=returnSet.iterator();			
//		while(iterD2.hasNext()){
//			System.out.println(iterD2.next().print());
//		}
		
		return returnSet;
	}

	// a method used just for testing	
	public ConstraintSet StdConstraintSet2ConstraintSet(StdConstraintSet std_cs){
		ConstraintSet cs=new ConstraintSet();
		
		Iterator<StdConstraint> iter=std_cs.iterator();				
		while (iter.hasNext()){
			cs.addConstraint(iter.next());
		}
		return cs;
	}
	
	// a method used just for testing	
	public void printElements(){
		/*
		Constraint current;
        Iterator<Constraint> iter=this.iterator();			
		System.out.println("Elements of the ConstraintSet " + this.hashCode());
		while (iter.hasNext()){
			current = iter.next();
			System.out.println(current.toString()+"  "+current.hashCode()+"  "+current.fociPrint());
		}*/
	}
	
	public ConstraintSet getCopy() {
		ConstraintSet returnSet = new ConstraintSet();
		Iterator<Constraint> iter=this.iterator();			
		while(iter.hasNext()){
			Constraint current=iter.next();
			returnSet.add(current);
		}
		return returnSet;
	}
	
	public void print(){
		int i=0;
		Constraint current;
        Iterator<Constraint> iter=this.iterator();			
		System.out.println("Elements of the ConstraintSet " + this.hashCode());
		while (iter.hasNext()){
			i++;
			current = iter.next();
			System.out.println(i+"- "+current.print());
		}
		System.out.println("------------end of ConstraintSet "+ this.hashCode()+" -------------");
		System.out.println();
	}
	
}