package se;

import java.util.ArrayList;

public class DisjunctiveConstraint extends StdConstraint{
	private StdConstraint constraint1;
	private StdConstraint constraint2;
	
	public DisjunctiveConstraint(StdConstraint constraint1,StdConstraint constraint2){
		this.constraint1 = constraint1;
		this.constraint2 = constraint2;
	}
	
	public String getConstantsFromConstraint(){
		return this.getLhs().getConstantsFromConstraint()+" "+this.getRhs().getConstantsFromConstraint();
	} 
//	public String getFunctionNameFromConstraint(){
//		return this.getLhs().getFunctionNameFromConstraint()+" "+this.getRhs().getFunctionNameFromConstraint();
//	}
	
	public StdConstraint getLhs(){return this.constraint1;}
	public StdConstraint getRhs(){return this.constraint2;}

	public boolean equalTo(StdConstraint stdConstraint){
		 if(stdConstraint instanceof DisjunctiveConstraint &&
					this.getLhs().equalTo(((DisjunctiveConstraint)stdConstraint).getLhs()) && 
					this.getRhs().equalTo(((DisjunctiveConstraint)stdConstraint).getRhs())) 
					{return true;}
		 return false;
	}
	
	
//	public String print() {
//		return "DisjunctiveConstraint "+this.hashCode()+" : ("+this.constraint1.print()+ ") OR (" + this.constraint2.print()+")";
//	}
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		params=this.constraint1.getParameters(params);
		return this.constraint2.getParameters(params);
	}
	public String print() {
		return "("+this.constraint1.print()+ ") OR (" + this.constraint2.print()+")";
	}
	
	public String print(int i) {
		int j;
		String string="";
		string = string+this.constraint1.print(i+1)+System.getProperty("line.separator");
		for (j=0;j<i;j++){
			string = string + "\t";
		}		
		string = string + "OR"+System.getProperty("line.separator");
		string = string+this.constraint2.print(i+1);
		return string;
	}
	public void createDomain(Domain domain){
//		this.constraint1.createDomain(domain);
//		this.constraint2.createDomain(domain);
	}
	
	//satprint
	public String satPrint(Domain dom){
		return " (or "+this.getLhs().satPrint(dom)+" "+this.getRhs().satPrint(dom)+" ) \n";
	}
	public String satPrint(Pair<ParametricMessage, ParametricMessage> assignment,Domain dom){
		return " (or "+this.getLhs().satPrint(assignment,dom)+" "+this.getRhs().satPrint(assignment,dom)+" ) \n";
	}
	public String satPrint(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment,Domain dom){
		return " (or "+this.getLhs().satPrint(assignment,dom)+" "+this.getRhs().satPrint(assignment,dom)+" ) \n";
	}
}