package se;

import java.util.*;


public class Domain{ //generic type: parametricMessage+Value

	private HashSet<Variable> domainVars=new HashSet<Variable>();
	private HashSet<InputVariable> domainInputVars=new HashSet<InputVariable>();
	private DomainValue domainvalue=new DomainValue();
	private DomainParametricMessage domainpm= new DomainParametricMessage();
	//one row for each different type 
	//inside the row there's a constant for each column
	private ArrayList<ArrayList<ParametricMessage>> domainPMconstants;
	private ArrayList<ParametricMessage> domainPMparams=new ArrayList<ParametricMessage>();

	//domain set of Parametric Tuples
	private HashSet<ParametricTuple> domainPTuple=new HashSet<ParametricTuple>();
	//domain set of Parametric Tuples Constantized
	private HashSet<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>> domainPTupleConstantized=new HashSet<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>>();
	//list of fact variable strings used for benchkmark initialization
	private String domainFactsVars4benchmark="";
	//list of factVar,tuple
	private HashSet<Pair<FactVariable,ParametricTuple>> domainFacts=new HashSet<Pair<FactVariable,ParametricTuple>>();

	//TODO mancano i value, non li hai mai considerati
	private ArrayList<ArrayList<Value>> domainVconstants;
	protected ParametricConcatenatedMessage pair=new ParametricConcatenatedMessage();
	protected ParametricEncryptedMessage enc=new ParametricEncryptedMessage();
	protected ParametricSymEncryptedMessage scrypt=new ParametricSymEncryptedMessage();
	private ArrayList<ParametricMessage> toRemove=new ArrayList<ParametricMessage>();
	private ArrayList<Pair<IKStdConstraint,ParametricMessage>> subs=new ArrayList<Pair<IKStdConstraint,ParametricMessage>>();
	//list of param,constant
	private ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> assignments=new ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>>();
	private ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> ass_perm;
	
	//list of vars used for functions
	private ArrayList<Message> functionVars=new ArrayList<Message>();
	//list of assignments used for functions
	//it is identical to the getAssignments but it returns a list of Var,Const instead of Param,Const
	private ArrayList<ArrayList<Pair<Message,ParametricMessage>>> funAss=new ArrayList<ArrayList<Pair<Message,ParametricMessage>>>();
	private HashSet<ParametricFunction> pfunList=new HashSet<ParametricFunction>();
	//list of 
	// [ [assignment, parametricTuple(assignment)], Function_name, constant ]
	// so we have a tuple with an assignment,a parametricTuple over this assignment, the function name and the associated new constant
	private ArrayList<Pair<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,String>,ParametricConstant>> ass_ptuple_fname_const=
			new ArrayList<Pair<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,String>,ParametricConstant>>();
	public ArrayList<Pair<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,String>,ParametricConstant>> getAss_ptuple_fname_const(){
		return this.ass_ptuple_fname_const;
	}
	public void addAss_ptuple_fname_const(Pair<ArrayList<ParametricMessage[]>,ParametricTuple> ass_pTuple,String fname,ParametricConstant constant){
		Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,String> ass_pTuple_fname=new 
				Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,String>(ass_pTuple,fname);
		Pair<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,String>,ParametricConstant> ass_pTuple_fname_constant=new
		Pair<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,String>,ParametricConstant>(ass_pTuple_fname,constant);
		this.ass_ptuple_fname_const.add(ass_pTuple_fname_constant);
	}

//	ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> ass_perm_trans;
	
	
	public Domain(ParametricMessageSet pmset,ArrayList<ParametricMessage> params){
//		System.out.println("DEBUG method1");
		Iterator<ParametricMessage> iter=pmset.iterator();
		// ParametricMessage current=iter.next();
		// System.out.println(current.satString());
		
		while(iter.hasNext()){
			ParametricMessage current=iter.next();
//			System.out.println("DEBUG add2dom "+current.satString());
			//the following method is deprecated
			//because it does not link messages with IK constraints
			current.add2Domain(this);
		}

		// create the constants set
		// the name has param because in a first 
		// version of the method there were also parameters
		this.domainPMconstants=this.domainpm.param_cons_array();		
		this.domainVconstants=this.domainvalue.param_cons_array();

		// remove every constant from the domain set
		for(int del=0;del<toRemove.size();del++)
			this.domainpm.remove(toRemove.get(del));
		toRemove.clear();
		this.domainPMparams=params;
		for(int p=0;p<params.size();p++)
			if(params.get(p).getClass().equals(AgentParameter.class)){
				this.domainPMparams.add(((AgentParameter)params.get(p)).getPublicKey());
				this.domainPMparams.add(((AgentParameter)params.get(p)).getPrivateKey());
			}
		this.CreateAssignments();
		// constantize every parametric message
		this.constantize();
		// this.constantize_PTupleSet();
	}

//	public Domain(ParametricMessageSet pmset){
////		System.out.println("DEBUG method2");
//		Iterator<ParametricMessage> iter=pmset.iterator();
//		while(iter.hasNext()){
//			// the following method is deprecated
//			// because it does not link messages with IK constraints
//			iter.next().add2Domain(this);
//		}
//
//		//create the constants set
//		//the name has param because in a first version of the method there were also parameters
//		this.domainPMconstants=this.domainpm.param_cons_array();		
//		this.domainVconstants=this.domainvalue.param_cons_array();
//
//		//remove every constant from the domain set
//		for(int del=0;del<toRemove.size();del++)
//			this.domainpm.remove(toRemove.get(del));
//		toRemove.clear();
//		this.CreateAssignments();
//		//constantize every parametric message
//		this.constantize();
//		//		this.constantize_PTupleSet();
//	}

//	public Domain(StdConstraintSet stdconstraintset){
////		System.out.println("DEBUG method3");
//		Iterator<StdConstraint> iter=stdconstraintset.iterator();
//		while(iter.hasNext()){
//			iter.next().createDomain(this);
//		}
//
//		//create the constants set
//		//the name has param because in a first version of the method there were also parameters
//		this.domainPMconstants=this.domainpm.param_cons_array();		
//		this.domainVconstants=this.domainvalue.param_cons_array();
//		//		System.out.println(this.printParamAL(this.domainPMconstants));
//
//		//remove every constant from the domain set
//		for(int del=0;del<toRemove.size();del++)
//			this.domainpm.remove(toRemove.get(del));
//		toRemove.clear();
//		this.CreateAssignments();
//		//constantize every parametric message
//		this.constantize();
//		this.constantize_PTupleSet();
//	}

	//forall func(args). 
	// if(isPublic(func)) DY(arg1,...,argn)=>DY(f(arg1,...,argn)
	// if(isInvertible(func)) DY(f(arg1,...,argn)=>DY(arg1)/\.../\DY(argn)
	public String publicInvertibleFunctions(int rpd,Environment env){
//		System.out.println("DEBUG_DOM publicInvertibleFunction method");
		String ret="(and true";		
		ArrayList<ParametricFunction> publicfuns=new ArrayList<ParametricFunction>();
		ArrayList<ParametricFunction> invertiblefuns=new ArrayList<ParametricFunction>();
		
		//forall rpd
		for(int i=0;i<rpd;i++){

			if(i==0){

				//forall functions 
				Iterator<ParametricFunction> iterPF=this.pfunList.iterator();
				while(iterPF.hasNext()){
					ParametricFunction currentFun=iterPF.next();

					//if currentFun is a public function we add it to publicFuns
					//and we print the DYrpd of that function
					if(currentFun.isPublic()){
						publicfuns.add(currentFun);

						//forall assignment 
						ArrayList<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,ParametricConstant>> constantiz=currentFun.getContantiz();
						if(constantiz.size()!=0){
							ret+="(or \n";


							for(int ass=0;ass<constantiz.size();ass++){
								ArrayList<ParametricMessage[]> assignment=currentFun.getContantiz().get(ass).getElement0().getElement0();
								ret+="(implies (and "+currentFun.getArgs(env).satWithDYString(assignment, "DY_"+rpd)+")";
								ret+=constantiz.get(ass).getElement1().satString()+")";
							}


							ret+=")";
						}

					}


					//if currentFun is an invertible function than we add it to publicFuns
					//and we print the DYrpd of that fun
					if(currentFun.isInvertible()){
						invertiblefuns.add(currentFun);
						
						//forall assignment 
						ArrayList<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,ParametricConstant>> constantiz=currentFun.getContantiz();
						if(constantiz.size()!=0){
							ret+="(or \n";
							for(int ass=0;ass<constantiz.size();ass++){
								ArrayList<ParametricMessage[]> assignment=currentFun.getContantiz().get(ass).getElement0().getElement0();
								ret+="(implies "+constantiz.get(ass).getElement1().satString();
								ret+="(and "+currentFun.getArgs(env).satWithDYString(assignment, "DY_"+rpd)+"))";
							}
							ret+=")";
						}

					}

				}
			}else{
				for(int pub=0;pub<publicfuns.size();pub++){
					
					ParametricFunction currentFun=publicfuns.get(pub);
//				for(int pub=1;pub<=publicfuns.size();pub++){
//					
//					ParametricFunction currentFun=publicfuns.get(pub);
					
					//forall assignment 
					ArrayList<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,ParametricConstant>> constantiz=currentFun.getContantiz();
					if(constantiz.size()!=0){
						ret+="(or \n";
						for(int ass=0;ass<constantiz.size();ass++){
							ArrayList<ParametricMessage[]> assignment=currentFun.getContantiz().get(ass).getElement0().getElement0();
							ret+="(implies (and "+currentFun.getArgs(env).satWithDYString(assignment, "DY_"+rpd)+")";
							ret+=constantiz.get(ass).getElement1().satString()+")";
						}
						ret+=")";
					}
					
				}
				for(int inv=1;inv<=invertiblefuns.size();inv++){
					ParametricFunction currentFun=invertiblefuns.get(inv);
					//forall assignment 
					ArrayList<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,ParametricConstant>> constantiz=currentFun.getContantiz();
					if(constantiz.size()!=0){
						ret+="(or \n";
						for(int ass=0;ass<constantiz.size();ass++){
							ArrayList<ParametricMessage[]> assignment=currentFun.getContantiz().get(ass).getElement0().getElement0();
							ret+="(implies "+constantiz.get(ass).getElement1().satString();
							ret+="(and "+currentFun.getArgs(env).satWithDYString(assignment, "DY_"+rpd)+"))";
						}
						ret+=")";
					}
				}
				
			}
		}

		return ret+")";
	}

	public ArrayList<ParametricMessage> getAgentsConstants(){
		for(int i=0;i<this.getDomainPMConstans().size();i++){
			if(this.getDomainPMConstans().get(i).getClass().equals(ParametricAgentConstant.class))
				return this.getDomainPMConstans().get(i);
		}
		return new ArrayList<ParametricMessage>();
	}
	
	public HashSet<Variable> getDomainVars(){return domainVars;}
	public HashSet<InputVariable> getDomainInputVars() {return domainInputVars;}

	public void add(Value val){
		this.domainvalue.add(val);
	}
	public void add(ParametricMessage pm){
		this.domainpm.add(pm);
	}

	public ArrayList<ParametricMessage> getDomainPMparams(){
		return this.domainPMparams;
	}
	public void add2DomainPMparams(ParametricMessage param){
		if(!this.getDomainParametricMessage().contains(param))
			this.getDomainPMparams().add(param);
	}	

	//returns the domain obtained from parametric messages
	public DomainParametricMessage getDomain(){
		return this.domainpm;
	}

	//returns a matrix with all the constants
	//each row has a different type of constants
	public ArrayList<ArrayList<ParametricMessage>> getPMConstants(){
		return this.domainPMconstants;
	}


	//tuple stuff
	public HashSet<ParametricTuple> getPTuple(){return this.domainPTuple;}
	public boolean addPTuple(ParametricTuple tuple){
		boolean ret;
		
		Iterator<ParametricTuple> iter=this.getPTuple().iterator();
		while(iter.hasNext()){
			if(iter.next().satString().equals(tuple.satString())){
				return true;
			}
		}
		
		ret=this.getPTuple().add(tuple);
		return ret;
	}
	public boolean removePTuple(ParametricTuple tuple){
		boolean ret;
		ret=this.getPTuple().remove(tuple);
		return ret;
	}
	
	

	
	public HashSet<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>> getPTupleConstantized(ParametricTuple pt){
//		questo metodo ha un errore se gli viene passata una costante ritorna un insieme di costanti
		
		
		//the tuple pt cannot contain parameters
		for(int check=0;check<pt.getArgs().length;check++)
			if(pt.getArgs()[check] instanceof Parameter){
				System.out.println("the argument of Domain.getPTupleConstantized(ParametricTuple pt) CANNOT contain parameters");
				System.exit(0);
			}

		HashSet<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>> ret= new HashSet<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>>();
		boolean theyAREequal=true;
		
		
		if(pt.getArgs()==null){
			return ret;
		}	
		
		Iterator<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>> iter=this.domainPTupleConstantized.iterator();
		while(iter.hasNext()){
			Pair<ArrayList<ParametricMessage[]>,ParametricTuple> current=iter.next();
			
			//if the number of argument is the same
			if(current.getElement1().getArgs().length == pt.getArgs().length){
				//we check the type of each argument
				for(int arg=0;arg<pt.getArgs().length;arg++){
					if(!(current.getElement1().getArgs()[arg].getClass().equals(pt.getArgs()[arg].getClass()))){
						//the two have different types
						//then we search for another tuple
						theyAREequal=false;
						break;
					}else if(current.getElement1().getArgs()[arg] instanceof ParametricConstant && 
							!(current.getElement1().getArgs()[arg].satString().equals(pt.getArgs()[arg].satString()))){
						theyAREequal=false;
						break;
					}
				}
				
				if(theyAREequal){
					ret.add(current);
				}
				
				theyAREequal=true;
			}
		
		}
		return ret;
	}
	
	public HashSet<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>> getPTupleConstantized(Tuple pt,Environment env){
		return this.getPTupleConstantized(pt.eval(env));
	}	
	
	
	//minimal assignment matrix
	public Pair<Boolean[],Integer[]> getAssPerm_matrix(ArrayList<ArrayList<ParametricMessage>> params){
		ArrayList<ParametricMessage> temp=new ArrayList<ParametricMessage>();
		for(int i=0;i<params.size();i++)
			for(int j=0;j<params.get(i).size();j++)
				temp.add(params.get(i).get(j));
		
		return this.getAssPerm(temp);		
	}
	
	public Pair<Boolean[],Integer[]> getAssPerm(ArrayList<ParametricMessage> params){
		boolean eq=false;
//		System.out.println("DEBUG different params="+params.size());
		ArrayList<ParametricMessage> params2remove=new ArrayList<ParametricMessage>();
		
//		System.out.println("DEBUG assignments in domain :"+this.getAssignments().size());
//		this.printAss();
		
		for(int i=0;i<this.getAssignments().size();i++){
			for(int j=0;j<params.size();j++){
				if(this.getAssignments().get(i).get(0).getElement0().satString().equals(params.get(j).satString())){
					eq=true;
					break;
				}
			}
			if(!eq){
				params2remove.add(this.getAssignments().get(i).get(0).getElement0());
			}
			eq=false;
		}
		
		Integer[] columns=new Integer[params.size()];

//		System.out.println("DEBUG assperm size="+this.getAssPerm().get(0).size());
		for(int par=0;par<params.size();par++)
			for(int gap=0;gap<this.getAssPerm().get(0).size();gap++)
				if(this.getAssPerm().get(0).get(gap).getElement0().satString().equals(params.get(par).satString()))
					columns[par]=gap;
		
//		System.out.println()"";
		return new Pair<Boolean[],Integer[]>(getRemovedAssPerm(params2remove),columns);
	}
	
	public Boolean[] getRemovedAssPerm(ArrayList<ParametricMessage> params2remove){
//		System.out.println("DEBUG getRemovedAssPer with these params to remove: "+params2remove.size()+" over "+this.getAssignments().size());
//		System.out.println("DEBUG getAssPerm size="+this.getAssPerm().size());
		Boolean[] removedAssPerm=new Boolean[this.getAssPerm().size()];
		Boolean[] temp=new Boolean[this.getAssPerm().size()];
		int ci=0,ki=1;
		
		//init to false
		for(int i=0;i<removedAssPerm.length;i++){
			removedAssPerm[i]=true;
			temp[i]=false;
		}
		
		for(int p=0;p<params2remove.size();p++){
			if(!(params2remove.get(p).getClass().equals(PublicKeyParameter.class)) && !(params2remove.get(p).getClass().equals(PrivateKeyParameter.class)))
				ci=this.getAssignments().get(this.indexOfParamInAssignments(params2remove.get(p))).size();
			else
				ci=1;
			
//			System.out.println("DEBUG indexOf("+params2remove.get(p).satString()+") = "+this.indexOfParamInAssignments(params2remove.get(p))+" (in assignments "+this.getAssignments().get(this.indexOfParamInAssignments(params2remove.get(p))).get(0).getElement0().satString()+")");
//			System.out.println("DEBUG ci="+ci);
			
			for(int k=0;k<this.getAssPerm().get(0).size();k++){
//				System.out.println("DEBUG param "+this.getAssPerm().get(0).get(k).getElement0().satString()+" has "+this.getAssignments().get(this.indexOfParamInAssignments(this.getAssPerm().get(0).get(k).getElement0())).size()+" constants");
				if(!(this.getAssPerm().get(0).get(k).getElement0().getClass().equals(PublicKeyParameter.class)) && !(this.getAssPerm().get(0).get(k).getElement0().getClass().equals(PrivateKeyParameter.class)))
					ki*=this.getAssignments().get(this.indexOfParamInAssignments(this.getAssPerm().get(0).get(k).getElement0())).size();
					
//				System.out.println("DEBUG temp ki="+ki+" "+this.getAssPerm().get(0).get(k).getElement0().getClass()+" = "+PublicKeyParameter.class);
				if(this.getAssPerm().get(0).get(k).getElement0().satString().equals(params2remove.get(p).satString()))
					break;
			}
				
//			System.out.println("DEBUG ki="+ki);
			
//			System.out.println("\n DEBUG deleting param "+params2remove.get(p).satString());
			for(int n=0;n<this.getAssPerm().size()/ki;n++){
				for(int m=0;m<ki/ci;m++){
					temp[n+m*((this.getAssPerm().size()/ki)*ci)]=true;
//					System.out.println("DEBUG R="+this.getAssPerm().size()+" ci="+ci+" ki="+ki+" n="+n+" m="+m);
//					System.out.println("DEBUG we keep line "+(n+m*((this.getAssPerm().size()/ki)*ci)));
				}
			}
			
			for(int i=0;i<removedAssPerm.length;i++){
				removedAssPerm[i]=(temp[i] & removedAssPerm[i]);
				temp[i]=false;
			}
			ki=1;
		}
		
		//DEBUG print array
//		System.out.println("DEBUG print array");
//		for(int i=0;i<removedAssPerm.length;i++)
//			System.out.println("removedAssPerm["+i+"]="+removedAssPerm[i]);	
//		System.out.println();
		
		return removedAssPerm;
	}

	private int indexOfParamInAssignments(ParametricMessage param){
		for(int i=0;i<this.getAssignments().size();i++)
			if(param.satString().equals(this.getAssignments().get(i).get(0).getElement0().satString()))
				return i; 
		
		return -1;
	}
	
	
	public void constantize_PTupleSet(){
		//Idebug
//		System.out.println("BEFORE constantize");
//		int deb=0;
//		Iterator<ParametricTuple> iterDebTuple=this.getPTuple().iterator();
//		while(iterDebTuple.hasNext()){
//			System.out.println("DEBUG loop");
//			System.out.println("["+deb+"] "+iterDebTuple.next().satString());
//			deb++;
//		}
//		System.out.println("DEBUG end");
		//Edebug
		
		
		ArrayList<ParametricMessage[]> assignment=new ArrayList<ParametricMessage[]>();

		ParametricTuple temp_tuple=new ParametricTuple(new ParametricMessage[0]); //make the compiler happy, otherwise this could be not initialized 

		Iterator<ParametricTuple> iterTuple=this.getPTuple().iterator();
		while(iterTuple.hasNext()){

			ParametricTuple currentTuple=iterTuple.next();
			ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> assignments=this.getAssPermTrans();
			ArrayList<ArrayList<Pair<ArrayList<ParametricMessage[]>,ParametricMessage>>> tuplePM=
					new ArrayList<ArrayList<Pair<ArrayList<ParametricMessage[]>,ParametricMessage>>>();

			//for each message in the current tuple
			for(int tupleM=0;tupleM<currentTuple.getArgs().length;tupleM++){
//				System.out.println("DEBUGD "+currentTuple.satString());
//				System.out.println("DEBUGD "+currentTuple.getArgs().length);
//				System.out.println("DEBUGD "+currentTuple.getArgs().toString());
//				System.out.println("DEBUGD "+currentTuple.getArgs()[0].getClass());
				ParametricMessage currentM=currentTuple.getArgs()[tupleM];

				
//				System.out.println("DEBUG "+currentM.satString());
//				System.out.println("DEBUG DOM "+this.getPMConstants().size());
//				for(int deb=0;deb<this.getPMConstants().size();deb++)
//					for(int deb2=0;deb2<this.getPMConstants().get(deb).size();deb2++)	
//					System.out.println("DEBUG CONST "+this.getPMConstants().get(deb).get(deb2).satString());
					
				ArrayList<Pair<ArrayList<ParametricMessage[]>,ParametricMessage>> msgConst=this.findConstantized(currentM);

				//if it is not a constant or it has assignments we add to tuplePM
				if(msgConst.size()!=1 && msgConst.get(0).getElement0().size()!=0)
					tuplePM.add(msgConst);
			}



			if(tuplePM.size()==0){
				Pair<ArrayList<ParametricMessage[]>,ParametricTuple> tuple_constantized=
						new Pair<ArrayList<ParametricMessage[]>,ParametricTuple>(assignment,currentTuple);
//				this.getPTupleConstantized().add(tuple_constantized);
				this.domainPTupleConstantized.add(tuple_constantized);

				//there are no parameters in the tuple
				//and then nothing to be done


			}else{
				
				
				//remove params that are not in a message in a tuple
//				boolean isIn=false;
//				for(int k=0;k<assignments.get(0).size();k++){
//					for(int i=0;i<tuplePM.size();i++){
//						for(int j=0;j<tuplePM.get(i).get(0).getElement0().size();j++){
//							//Idebug
////							System.out.println(assignments.get(k).get(0).getElement0().satString()+" ?= "+tuplePM.get(i).get(0).getElement0().get(j)[0].satString());
//							//Edebug
//							if(assignments.get(k).get(0).getElement0().equals(tuplePM.get(i).get(0).getElement0().get(j)[0])){
//								isIn=true;
//								break;
//							}
//						}
//						if(isIn)
//							break;
//					}
//					if(isIn){
////						System.out.println(" YES");
//						isIn=false;
//					}else{
////						System.out.println(" NO");
//						for(int r1=0;r1<assignments.size();r1++){
//							assignments.get(r1).remove(k);
//						}	
//					}
//				}
				//now we have assignments containing meaningful assignments only
				
				ArrayList<ParametricMessage> params=new ArrayList<ParametricMessage>();
				for(int j=0; j<tuplePM.size();j++)
					for(int p=0;p<tuplePM.get(j).get(0).getElement0().size();p++){
						if(tuplePM.get(j).get(0).getElement0().get(p)[0].getClass().equals(PublicKeyParameter.class)){
							params.add(((ParametricPublicKey)(tuplePM.get(j).get(0).getElement0().get(p)[0])).getParametricAgent());
							params.add(((ParametricPublicKey)(tuplePM.get(j).get(0).getElement0().get(p)[0])).getParametricAgent().getPrivateKey());
						}
						if(tuplePM.get(j).get(0).getElement0().get(p)[0].getClass().equals(PrivateKeyParameter.class)){
							params.add(((PrivateKeyParameter)(tuplePM.get(j).get(0).getElement0().get(p)[0])).getParametricAgent());
							params.add(((ParametricPublicKey)(tuplePM.get(j).get(0).getElement0().get(p)[0])).getParametricAgent().getPublicKey());
						}
						params.add(tuplePM.get(j).get(0).getElement0().get(p)[0]);
					}
				
				Pair<Boolean[],Integer[]> assignments_bool_pair=this.getAssPerm(params);
				Boolean[] assignments_bool=assignments_bool_pair.getElement0();
				Integer[] assignments_cols=assignments_bool_pair.getElement1();
				
//				for(int ass=0;ass<assignments.size();ass++){
				for(int ass=0;ass<assignments_bool.length;ass++){
					if(assignments_bool[ass]){
					//we add the assignment 

//					for(int ass_i=0;ass_i<assignments.get(ass).size();ass_i++){
					for(int ass_i=0;ass_i<assignments_cols.length;ass_i++){
						ParametricMessage[] temp_assignment=new ParametricMessage[2];
//						temp_assignment[0]=assignments.get(ass).get(ass_i).getElement0();
//						temp_assignment[1]=assignments.get(ass).get(ass_i).getElement1();
						temp_assignment[0]=assignments.get(ass).get(assignments_cols[ass_i]).getElement0();
						temp_assignment[1]=assignments.get(ass).get(assignments_cols[ass_i]).getElement1();
						assignment.add(temp_assignment);					
					}

					//for each message in the current tuple
					ArrayList<ParametricMessage> msgs=new ArrayList<ParametricMessage>();

					//Idebug
//					System.out.println("tuple before constantization: "+currentTuple.satString());
					//Edebug
					for(int tupleM=0;tupleM<currentTuple.getArgs().length;tupleM++){
						ParametricMessage currentTuple_m=currentTuple.getArgs()[tupleM];
						//Idebug
//						System.out.println("mex before constantization: "+currentTuple_m.satString()+""//);
//						+" with ass="+assignments.get(ass).size());//.get(0).getElement0().satString()+"="+assignments.get(ass).get(0).getElement1().satString());
						//Edebug
						Pair<ArrayList<ParametricMessage[]>,ParametricMessage> constantM=
								this.findConstantizedWrtAss(currentTuple_m, assignments.get(ass));
						//Idebug
//						System.out.println("assignment: \n");
//						for(int debn=0;debn<constantM.getElement0().size();debn++){
//							System.out.println(constantM.getElement0().get(debn)[0].satString()+" = "+constantM.getElement0().get(debn)[1].satString());							
//						}
//
//						System.out.println("mex after constantization: "+constantM.getElement1().satString()+"\n");
						//Edebug
						
						
						msgs.add(constantM.getElement1());
					}

					
					temp_tuple=new ParametricTuple(msgs.toArray(new ParametricMessage[msgs.size()]));
					//Idebug
//					System.out.println("tuple after constantization: "+temp_tuple.satString()+"\n");
					//Edebug
					Pair<ArrayList<ParametricMessage[]>,ParametricTuple> tuple_constantized=
							new Pair<ArrayList<ParametricMessage[]>,ParametricTuple>(assignment,temp_tuple);
					//this.getPTupleConstantized().add(tuple_constantized);
					this.domainPTupleConstantized.add(tuple_constantized);
					}
				}

				
			}

		}

		//Idebug
//		System.out.println("\nAFTER constantize");
//		int deb2=0;
//		Iterator<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>> iterDebTuple2=this.getPTupleConstantized().iterator();
//		while(iterDebTuple2.hasNext()){
//			System.out.println("["+deb2+"] "+iterDebTuple2.next().getElement1().satString());
//			deb2++;
//		}
		//Edebug
	}
	//end tuple stuff

	//Facts stuff
	public void addFactVar(FactVariable factvar, int argsNum){
		this.domainFactsVars4benchmark+=factvar.interpolantString4Benchmark(argsNum);
	}
	public String getFactVars4benchmark(){
		return this.domainFactsVars4benchmark;
	}
	public boolean addFact(Pair<FactVariable,ParametricTuple> fact_tuple){
		boolean ret;
		ret=this.getFacts().add(fact_tuple);
		return ret;
	}
	public boolean removeFact(Pair<FactVariable,ParametricTuple> fact_tuple){
		boolean ret;
		ret=this.getFacts().remove(fact_tuple);
		return ret;
	}
	public HashSet<Pair<FactVariable,ParametricTuple>> getFacts(){
		return this.domainFacts;
	}
	

	public String f_eq_fp(Environment env){
		return this.f_eq_fp(env,"","");
	}
	
	public String f_eq_fp(Environment env,String fact,String tuple){
		
		String ret="(and true ;domfeqfp\n";
		//obtain all the pair <Fact, Tuple>
		Iterator<Pair<FactVariable,ParametricTuple>> iterPair=this.getFacts().iterator();

		//for each pair
		while(iterPair.hasNext()){
			Pair<FactVariable,ParametricTuple> currentPair=iterPair.next();
			FactVariable currentFact=currentPair.getElement0();
			ParametricTuple currentTuple=currentPair.getElement1();

			ArrayList<ArrayList<ParametricMessage>> params=new ArrayList<ArrayList<ParametricMessage>>();
			ArrayList<ParametricMessage> unsortedParams=new ArrayList<ParametricMessage>();

//			ret+="(and ";
			

			//for each message in the tuple we collect all the params
			for(int tuple_i=0;tuple_i<currentTuple.getArgs().length;tuple_i++){
				ParametricMessage currentMessage=currentTuple.getArgs()[tuple_i];

				//1. get all the params
				params=currentMessage.getParams(params);
				for(int o=0;o<params.size();o++)
					for(int p=0;p<params.get(o).size();p++)
						if(!(unsortedParams.contains(params.get(o).get(p)))){
							if(params.get(o).get(p).getClass().equals(PublicKeyParameter.class)){
								unsortedParams.add(((ParametricPublicKey)(params.get(o).get(p))).getParametricAgent());
								unsortedParams.add(((ParametricPublicKey)(params.get(o).get(p))).getParametricAgent().getPrivateKey());
							}
							if(params.get(o).get(p).getClass().equals(PrivateKeyParameter.class)){
								unsortedParams.add(((PrivateKeyParameter)(params.get(o).get(p))).getParametricAgent());
								unsortedParams.add(((ParametricPublicKey)(params.get(o).get(p))).getParametricAgent().getPublicKey());
							}
							unsortedParams.add(params.get(o).get(p));
						}
			}

			//2. create all assignments
			ArrayList<String[][]> assignmentMatrix=new ArrayList<String[][]>();
			String[] paramsArray;
			//forall variables
			for(int paramType=0;paramType<params.size();paramType++){
				paramsArray=new String[params.get(paramType).size()];
				for(int d=0;d<params.get(paramType).size();d++){
					paramsArray[d]=params.get(paramType).get(d).satString();
				}


				//search the constant row in domain constant list 
				for(int conType=0;conType<this.getDomainPMConstans().size();conType++){
					//check if types are correct
					if(this.getPMConstants().get(conType).get(0).getClass().equals(ParametricAgentConstant.class) && params.get(paramType).get(0).getClass().equals(AgentParameter.class) ||
							this.getPMConstants().get(conType).get(0).getClass().equals(ParametricNonceConstant.class) && params.get(paramType).get(0).getClass().equals(NonceParameter.class) ||
							this.getPMConstants().get(conType).get(0).getClass().equals(ParametricSymKeyConstant.class) && params.get(paramType).get(0).getClass().equals(SymKeyParameter.class) ||
							this.getPMConstants().get(conType).get(0).getClass().equals(ParametricGenericConstant.class) && params.get(paramType).get(0).getClass().equals(GenericParameter.class) ||
							this.getPMConstants().get(conType).get(0).getClass().equals(ParametricPublicKeyConstant.class) && params.get(paramType).get(0).getClass().equals(PublicKeyParameter.class) ||
							this.getPMConstants().get(conType).get(0).getClass().equals(ParametricPrivateKeyConstant.class) && params.get(paramType).get(0).getClass().equals(PrivateKeyParameter.class)
							){

						//convert getPMConstant Arraylist to Array to call combine
						ParametricMessage[] constArrayP=this.getPMConstants().get(conType).toArray(new ParametricMessage[this.getPMConstants().get(conType).size()]);
						String[] constArray=new String[constArrayP.length];
						for(int c=0;c<constArrayP.length;c++)
							constArray[c]=constArrayP[c].satString();

						assignmentMatrix.add(this.createAssignments(constArray,paramsArray));

					}
				}
			}

			//we now have assignmentMatrix that contains in each field a matrix with all the combination of a type
			//we need a matrix instead of a list of matrix and we have to combine matrixes
			//
			//forall Matrix
			// forall row1 in Matrix1
			//  forall row2 in Matrix2
			//   new Matrix3 <- row1.row2
			//   substitute Matrix1 and Matrix2 with Matrix3

			String[][] tempMatrix;
			while(assignmentMatrix.size()>1){
				String[][] toRemove0=assignmentMatrix.get(0);
				String[][] toRemove1=assignmentMatrix.get(1);
				tempMatrix=matrixCombine(toRemove0,toRemove1);
				assignmentMatrix.remove(toRemove0);
				assignmentMatrix.remove(toRemove1);

				assignmentMatrix.add(0,tempMatrix);
			}


			if(assignmentMatrix.size()!=0){
				String[][] finalAssignmentMatrix=assignmentMatrix.get(0);

				//3. constantize wrt assignment (forall assignment)
				//4. write 
				//(or
				// (and ass1 (fact' constantized(m,ass1)) 
				//     forall m' in Ground
				//      if(m' != m) (=(IK' m')(IK m)) 
				// )
				// ...
				// )

				//search constant row in constant
				//we save the row of agentConstant,publickeyconstant and privatekeyconstant
				//				int constPKRow=0,constPVTRow=0;
				//				boolean constPKRowExist=false,constPVTRowExist=false;
				//
				//				for(int k=0;k<dom.getPMConstants().size();k++){
				//					if(dom.getPMConstants().get(k).get(0).getClass().equals(ParametricPublicKeyConstant.class)){
				//						constPKRow=k;
				//						constPKRowExist=true;
				//					}
				//					if(dom.getPMConstants().get(k).get(0).getClass().equals(ParametricPrivateKeyConstant.class)){
				//						constPVTRow=k;
				//						constPVTRowExist=true;
				//					}
				//				}

				String tempCurrent=currentTuple.satString();
				
//				ret+="(or \n";
				
				for(int asRow=0;asRow<finalAssignmentMatrix.length;asRow++){

//					ret+="(and ";
					for(int asCol=0;asCol<finalAssignmentMatrix[asRow].length;asCol++){
//						ret+="(= "+unsortedParams.get(asCol).satString()+" "+finalAssignmentMatrix[asRow][asCol]+") ";
						tempCurrent=tempCurrent.replaceAll(unsortedParams.get(asCol).satString(),finalAssignmentMatrix[asRow][asCol]);

						//						//we search for the public key of the agent (constant)
						//						if(constPKRowExist)
						//							for(int pvt=0;pvt<dom.getPMConstants().get(constPKRow).size();pvt++)
						//								if(((ParametricPublicKeyConstant)dom.getPMConstants().get(constPKRow).get(pvt)).getParametricAgent().satString().
						//										equals(finalAssignmentMatrix[asRow][asCol]))
						//									tempCurrent=tempCurrent.replaceAll("\\(\\s*pk\\s*"+finalAssignmentMatrix[asRow][asCol]+"\\s*\\)",((ParametricPublicKeyConstant)dom.getPMConstants().get(constPKRow).get(pvt)).satString());	
						//						//we search for the private key of the agent (constant)
						//						if(constPVTRowExist)
						//							for(int pvt=0;pvt<dom.getPMConstants().get(constPVTRow).size();pvt++)
						//								if(((ParametricPrivateKeyConstant)dom.getPMConstants().get(constPVTRow).get(pvt)).getParametricAgent().satString().
						//										equals(finalAssignmentMatrix[asRow][asCol]))
						//									tempCurrent=tempCurrent.replaceAll("\\(\\s*pvt\\s*"+finalAssignmentMatrix[asRow][asCol]+"\\s*\\)",((ParametricPrivateKeyConstant)dom.getPMConstants().get(constPVTRow).get(pvt)).satString());	
					}
					if(!currentFact.getName().equals(fact) || !tempCurrent.equals(tuple))
						ret+="("+currentFact.prime()+" "+tempCurrent+") ";

					//we now add (= (fact' m')(fact m))
					//forall m in groundMsgs fact'(m)=fact(m)
//					Iterator<ParametricMessage> iterGR=this.getDomain().iterator();
//					while(iterGR.hasNext()){
//						ParametricMessage currentGR=iterGR.next();
//						ret+="(= ("+currentFact.prime()+" "+currentGR.satString()+") ("+currentFact.getName()+" "+currentGR.satString()+") )\n";			
//					}
//
//					ret+=")\n";
				}
//				ret+=")\n";

				//				ArrayList<ArrayList<ParametricMessage>> C=dom.getDomainPMConstans();
				//				for(int find=0;find<C.size();find++)
				//					if(C.get(find).getClass().equals(ParametricAgentConstant.class)){
				//						for(int col=0;col<C.get(find).size();col++){
				//							ret.replaceAll("\\(\\s*pk\\s"+C.get(find).get(col).satString()+"\\s*\\)",((ParametricAgentConstant)C.get(find).get(col)).getPublicKey().satString());
				//							ret.replaceAll("\\(\\s*pvt\\s"+C.get(find).get(col).satString()+"\\s*\\)",((ParametricAgentConstant)C.get(find).get(col)).getPrivateKey().satString());
				//						}
				//						break;
				//					}

			}else{
//				ret+="(and ";
				ret+="("+currentFact.prime()+" "+currentTuple.satString()+") ";
				//we now add (= (fact' m')(fact m)) 
//				Iterator<ParametricMessage> iterGR=this.getDomain().iterator();
//				while(iterGR.hasNext()){
//					ParametricMessage currentGR=iterGR.next();
//					if(!currentGR.satString().equals(currentGR.satString()))
//					ret+="(= ("+currentFact.prime()+" "+currentGR.satString()+") ("+currentFact.getName()+" "+currentGR.satString()+") )\n";			
//				}
//				ret+=")";
			}

		}
		ret+=")";
		return ret;
	}
	//end facts stuff


	public void CreateAssignments(){
		boolean already=false;
		int pos=0; 

		for(int i=0;i<this.getDomainPMparams().size();i++){
			for(int j=0;j<this.getDomainPMConstans().size();j++)
				if( (this.getDomainPMparams().get(i).getClass().equals(AgentParameter.class) && 
						this.getDomainPMConstans().get(j).get(0).getClass().equals(ParametricAgentConstant.class)) 
						||(this.getDomainPMparams().get(i).getClass().equals(NonceParameter.class) && 
								this.getDomainPMConstans().get(j).get(0).getClass().equals(ParametricNonceConstant.class))
						||(this.getDomainPMparams().get(i).getClass().equals(GenericParameter.class) && 
								this.getDomainPMConstans().get(j).get(0).getClass().equals(ParametricGenericConstant.class))
						||(this.getDomainPMparams().get(i).getClass().equals(PublicKeyParameter.class) && 
								this.getDomainPMConstans().get(j).get(0).getClass().equals(ParametricPublicKeyConstant.class))
						||(this.getDomainPMparams().get(i).getClass().equals(PrivateKeyParameter.class) && 
								this.getDomainPMConstans().get(j).get(0).getClass().equals(ParametricPrivateKeyConstant.class))
						||(this.getDomainPMparams().get(i).getClass().equals(SymKeyParameter.class) && 
								this.getDomainPMConstans().get(j).get(0).getClass().equals(ParametricSymKeyConstant.class))
						)
				{

					for(int k=0;k<this.getDomainPMConstans().get(j).size();k++){

						//search for similar
						if(!already)
							for(int h=0;h<this.getAssignments().size();h++){
								if(this.getDomainPMparams().get(i).equals(this.getAssignments().get(h).get(0).getElement0())){							
									already=true;	
									pos=h;
									break;
								}
							}

						if(already){
							Pair<ParametricMessage,ParametricMessage> temp=new Pair<ParametricMessage,ParametricMessage>(this.getDomainPMparams().get(i),this.getDomainPMConstans().get(j).get(k));
							this.getAssignments().get(pos).add(temp);							
						}
						if(!already){
							Pair<ParametricMessage,ParametricMessage> temp=new Pair<ParametricMessage,ParametricMessage>(this.getDomainPMparams().get(i),this.getDomainPMConstans().get(j).get(k));
							ArrayList<Pair<ParametricMessage,ParametricMessage>> tempARL=new ArrayList<Pair<ParametricMessage,ParametricMessage>>();
							tempARL.add(temp);
							this.getAssignments().add(tempARL);
						}
					}
					already=false;
				}
		}
		
		
		int[] keysToRemove=new int[this.getAssignments().size()];
		for(int i=0;i<keysToRemove.length;i++)
			keysToRemove[i]=-1;
		
		for(int i=0;i<this.getAssignments().size();i++){
			if(this.getAssignments().get(i).get(0).getElement0().getClass().equals(AgentParameter.class)){
				for(int j=0;j<this.getAssignments().size();j++){
					if((this.getAssignments().get(j).get(0).getElement0().getClass().equals(PublicKeyParameter.class)) && 
							(((AgentParameter)(this.getAssignments().get(i).get(0).getElement0())).getPublicKey().satString().equals(
									((PublicKeyParameter)(this.getAssignments().get(j).get(0).getElement0())).satString()))){
						keysToRemove[j]=i;
					}else if((this.getAssignments().get(j).get(0).getElement0().getClass().equals(PrivateKeyParameter.class)) && 
							(((AgentParameter)(this.getAssignments().get(i).get(0).getElement0())).getPrivateKey().satString().equals(
									((PrivateKeyParameter)(this.getAssignments().get(j).get(0).getElement0())).satString()))){
						keysToRemove[j]=i;
					}
				}
			}
		}
		
		ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> temp_ass=new ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>>();
		for(int i=0;i<this.getAssignments().size();i++){
			if(keysToRemove[i]==-1){
				temp_ass.add(this.getAssignments().get(i));
			}
//			else
//				System.out.println("DEBUG removed "+this.getAssignments().get(i).get(0).getElement0().satString());
		}
		
		//calculate the height and width
		int columns=temp_ass.size();
		int rows=1;
		temp_ass.trimToSize();
		for(int row=0;row<temp_ass.size();row++){
			temp_ass.get(row).trimToSize();
			rows*=temp_ass.get(row).size();			
		}		
		
		//create the ass_perm structure
		int combinations=rows;
		int params=columns;
		
		ass_perm=new ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>>(combinations);
		for(int i=0;i<combinations;i++){
			ass_perm.add(new ArrayList<Pair<ParametricMessage,ParametricMessage>>(params));
		}
		
				
		int z=rows;
		int k=1;
		int index=0;
		for(int j=1;j<=params;j++){
			z=z/temp_ass.get(j-1).size();
			index=0;
			k=1;
			for(int i=1;i<=combinations;i++){

				if(k<=z)
					k++;
				else{
					if(index<temp_ass.get(j-1).size()-1)
						index++;
					else
						index=0;
					k=2;
				}
				ass_perm.get(i-1).add(temp_ass.get(j-1).get(index));
				
			}
		}

//		this.getAssPerm().trimToSize();		
//		//OLD create the ass_perm structure
//		ass_perm=new ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>>(columns);
//
//		int z=rows;
//		int k=1;
//		int index=0;
//		for(int j=1;j<=columns;j++){
//			z=z/temp_ass.get(j-1).size();
//			index=0;
//			k=1;
//			ArrayList<Pair<ParametricMessage,ParametricMessage>> ass_perm_row=new ArrayList<Pair<ParametricMessage,ParametricMessage>>(rows);
//			for(int i=1;i<=rows;i++){
//
//				if(k<=z)
//					k++;
//				else{
//					if(index<temp_ass.get(j-1).size()-1)
//						index++;
//					else
//						index=0;
//					k=2;
//				}
//
//				ass_perm_row.add(temp_ass.get(j-1).get(index));				
//			}
//			ass_perm_row.trimToSize();
//
//			this.getAssPerm().add(ass_perm_row);
//			this.getAssPerm().get(j-1).trimToSize();
//		}
//		this.getAssPerm().trimToSize();

		
//		this.printAssPermMatrix();
//		int debug_pre_col=this.getAssPerm().size();
//		int debug_pre_row=this.getAssPerm().get(0).size();
		//MR
//		int agent_index=-1,pk_index=-1,pvt_index=-1;
//		boolean speed=false;
//		ArrayList<Integer> toRemove=new ArrayList<Integer>();
//		
//		for(int row=0;row<this.getAssPerm().get(0).size();row++){
//			for(int col=0;col<this.getAssPerm().size();col++){
////				System.out.println("DEBUG ["+row+" "+col+"] "+this.getAssPerm().get(col).get(row).getElement0().satString());
//				if(this.getAssPerm().get(col).get(row).getElement0().getClass().equals(AgentParameter.class))
//					agent_index=col;
//				if(this.getAssPerm().get(col).get(row).getElement0().getClass().equals(PublicKeyParameter.class))
//					pk_index=col;
//				if(this.getAssPerm().get(col).get(row).getElement0().getClass().equals(PrivateKeyParameter.class))
//					pvt_index=col;
//				if(agent_index!=-1 && pk_index!=-1){
//					if(!((ParametricAgentConstant)this.getAssPerm().get(agent_index).get(row).getElement1()).getPublicKey().satString().equals(
//							((ParametricPublicKeyConstant)this.getAssPerm().get(pk_index).get(row).getElement1()).satString())){
////						System.out.println("DB1 ");//"+((ParametricAgentConstant)this.getAssPerm().get(col).get(agent_index).getElement1()).getPublicKey().satString()+" != \nDB1 "+((ParametricPublicKeyConstant)this.getAssPerm().get(pk_index).get(j).getElement1()).satString());
//						toRemove.add(row);
//						speed=true;
//						break;
//					}
//				}
//				if(!speed)
//					if(agent_index!=-1 && pvt_index!=-1){
//						if(!((ParametricAgentConstant)this.getAssPerm().get(agent_index).get(row).getElement1()).getPrivateKey().satString().equals(
//								((ParametricPrivateKeyConstant)this.getAssPerm().get(pvt_index).get(row).getElement1()).satString())){
////							System.out.println("DB2 ");// "+((ParametricAgentConstant)this.getAssPerm().get(agent_index).get(j).getElement1()).getPrivateKey().satString()+" != \nDB2 "+((ParametricPrivateKeyConstant)this.getAssPerm().get(pvt_index).get(j).getElement1()).satString());
//							toRemove.add(row);
//							break;
//						}
//					}
//				speed=false;
//			}
//			
//		}
//		System.out.println();
//		this.printAssPermMatrix();
		
		
//		
//		Collections.sort(toRemove);
//		for(int rem=toRemove.size()-1;rem>-1;rem--)
//			for(int col=0;col<this.getAssPerm().size();col++){
////				System.out.println("DEBUG remove row:"+toRemove.get(rem)+" in column:"+col+" that is:" +
////						"("+this.getAssPerm().get(col).get(toRemove.get(rem)).getElement0().satString()+", "+this.getAssPerm().get(col).get(toRemove.get(rem)).getElement0().satString()+")");
//				this.getAssPerm().get(col).remove((int)(toRemove.get(rem).intValue()));
//				//System.out.println("DEBUG remove="+retu);
//			}
//		toRemove.trimToSize();
//		System.out.println();
//		System.out.println("DEBUG pre:"+debug_pre_col+" post:"+this.getAssPerm().size());
//		System.out.println("DEBUG pre:"+debug_pre_row+" post:"+this.getAssPerm().get(0).size());

		
//		//MR


		
//		this.instantiateAssPermTrans();
//		else if(this.getAssignments().get(k).get(0).getElement0().getClass().equals(PrivateKeyParameter.class)){
//			if(this.ass_perm.get(i).get(j).getElement0().satString().equals(
//					((PrivateKeyParameter)(this.getAssignments().get(k).get(0).getElement0())).getParametricAgent().satString())){
//				System.out.println("DEBUG ADDED ("+this.getAssignments().get(k).get(0).getElement0().satString()+", "+((ParametricAgentConstant)(this.ass_perm.get(i).get(j).getElement1())).getPrivateKey().satString()+")");
//				this.ass_perm.get(i).add(this.ass_perm.size(),new Pair<ParametricMessage,ParametricMessage>(
//						this.getAssignments().get(k).get(0).getElement0(),
//						((ParametricAgentConstant)(this.ass_perm.get(i).get(j).getElement1())).getPrivateKey()));
//				break;
//			}
//		}
//		this.printAssPerm_trans();
		
		for(k=0;k<keysToRemove.length;k++)
			if(keysToRemove[k]!=-1){
//				System.out.println("DEBUG -1 FOUND");
				if(this.getAssignments().get(k).get(0).getElement0().getClass().equals(PublicKeyParameter.class)){
//					System.out.println("DEBUG PK");
					for(int i=0;i<this.ass_perm.size();i++){
						for(int j=0;j<this.ass_perm.get(i).size();j++)
							if(this.ass_perm.get(i).get(j).getElement0().satString().equals(
									((PublicKeyParameter)(this.getAssignments().get(k).get(0).getElement0())).getParametricAgent().satString())){
//								System.out.println("DEBUG ADDED ("+this.getAssignments().get(k).get(0).getElement0().satString()+", "+((ParametricAgentConstant)(this.ass_perm.get(i).get(j).getElement1())).getPublicKey().satString()+")");
								this.ass_perm.get(i).add(new Pair<ParametricMessage,ParametricMessage>(
										this.getAssignments().get(k).get(0).getElement0(),
										((ParametricAgentConstant)(this.ass_perm.get(i).get(j).getElement1())).getPublicKey()));
								break;
							}
					}		
				}
				else if(this.getAssignments().get(k).get(0).getElement0().getClass().equals(PrivateKeyParameter.class)){
//					System.out.println("DEBUG PVT");
					for(int i=0;i<this.ass_perm.size();i++){
						for(int j=0;j<this.ass_perm.get(i).size();j++)
							if(this.ass_perm.get(i).get(j).getElement0().satString().equals(
									((PrivateKeyParameter)(this.getAssignments().get(k).get(0).getElement0())).getParametricAgent().satString())){
//								System.out.println("DEBUG ADDED ("+this.getAssignments().get(k).get(0).getElement0().satString()+", "+((ParametricAgentConstant)(this.ass_perm.get(i).get(j).getElement1())).getPrivateKey().satString()+")");
								this.ass_perm.get(i).add(new Pair<ParametricMessage,ParametricMessage>(
										this.getAssignments().get(k).get(0).getElement0(),
										((ParametricAgentConstant)(this.ass_perm.get(i).get(j).getElement1())).getPrivateKey()));
								break;
							}
					}		
				}
			}
//		System.out.println("\n\n\n AFTER instantiateasspermtrans: \n\n");
		
//		this.printAssPermMatrix();
//		this.printAss();
//		this.printAssPerm_trans();
//		this.printAssPermTrans();
		//DEBUG
//		this.printAssPermMatrix();
//		this.printAssPerm();
	}

	

	

	//obtain a matrix with all possible assignemnts
	//in each line there's an assignment on all parameters
	public ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> getAssPermTrans(){
//		System.out.println("DEBUG_Domain getasspermtrans is called");
//		StackTraceElement[] stackTraceElements = Thread.currentThread().getStackTrace();
//		for(int i=0;i<stackTraceElements.length;i++){
//			System.out.println(stackTraceElements[i].getClassName());
//			System.out.println(stackTraceElements[i].getLineNumber());
//		}
//		return this.ass_perm_trans;
		return this.getAssPerm();
	}
//	public void setAssPermTrans(ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> asspermtrans){this.ass_perm_trans=asspermtrans;}
	
	//this method now only rotate the matrix of getAssignment and calls it ass_perm_trans
	public void instantiateAssPermTrans(){
//		System.out.println("DEBUG_Domain instantiate is called");
//		StackTraceElement[] stackTraceElements = Thread.currentThread().getStackTrace();
//		for(int i=0;i<stackTraceElements.length;i++){
//			System.out.println(stackTraceElements[i].getClassName());
//			System.out.println(stackTraceElements[i].getLineNumber());
//		}
		
		int j=0;
		ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> ass_perm_trans=
				new ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>>();
//				new ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>>(this.getAssPerm().size());
		//		System.out.println("cols 1 "+this.getAssPerm().size());
		//		System.out.println("rows 1 "+this.getAssPerm().get(0).size());
		if(this.getAssPerm().size()!=0){
			while(j<this.getAssPerm().get(0).size()){
				ArrayList<Pair<ParametricMessage,ParametricMessage>> ass_perm_trans_temp_row=
						new ArrayList<Pair<ParametricMessage,ParametricMessage>>(this.getAssPerm().get(0).size());
				for(int i=0;i<this.getAssPerm().size();i++){
					ass_perm_trans_temp_row.add(this.getAssPerm().get(i).get(j));

				}
				//ass_perm_trans_temp_row.trimToSize();
				ass_perm_trans.add(ass_perm_trans_temp_row);
				j++;
			}
		}
		
//		System.out.println("DEBUG ok!");
		//		System.out.println("cols 2 "+ass_perm_trans.size());
		//		System.out.println("rows 2 "+ass_perm_trans.get(0).size());

		//remove lines in which the keys constants assigned to the corresponding parameters are not compliant with the constant assigned to the
//		ParametricMessage agentConst=null;
//		ParametricMessage pubConst=null;
//		ParametricMessage pvtConst=null;
//		ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> todel=new ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>>();
//		
//		for(int ass=0;ass<ass_perm_trans.size();ass++){
//			ArrayList<Pair<ParametricMessage,ParametricMessage>> currentAss=ass_perm_trans.get(ass);
			
			//search for agent and keys parameters
//			for(int param=0;param<currentAss.size();param++){
//				
//				if(currentAss.get(param).getElement0().getClass().equals(AgentParameter.class)){
//					agentConst=currentAss.get(param).getElement1();
//				}else if(currentAss.get(param).getElement0().getClass().equals(PublicKeyParameter.class)){
//					pubConst=currentAss.get(param).getElement1();
//				}else if(currentAss.get(param).getElement0().getClass().equals(PrivateKeyParameter.class)){
//					pvtConst=currentAss.get(param).getElement1();
//				}			
//			}
			
//			boolean speed=false;
//			if(agentConst!=null && pubConst!=null){
//				if(!((ParametricAgentConstant)agentConst).getPublicKey().satString().equals(((ParametricPublicKeyConstant)pubConst).satString())){
//					todel.add(ass_perm_trans.get(ass));
//					speed=true;
//				}
//			}
//			if(!speed)
//				if(agentConst!=null && pvtConst!=null){
//					if(!((ParametricAgentConstant)agentConst).getPrivateKey().satString().equals(((ParametricPrivateKeyConstant)pvtConst).satString())){
//						todel.add(ass_perm_trans.get(ass));
//					}
//				}
//		}
		
//		System.out.println("DEBUG PRIMA "+ass_perm_trans.size());
//		this.ass_perm_trans=ass_perm_trans;
//		System.out.println("DEBUG ");
//		this.printAssPermTrans();
		
//		for(int rem=0;rem<todel.size();rem++){
////			System.out.println("DEBUG delete assigment number "+todel.get(rem));
//			ass_perm_trans.remove(todel.get(rem));
//		}
		
//		System.out.println("DEBUG DOPO "+ass_perm_trans.size());
		
		this.ass_perm=ass_perm_trans;
//		System.out.println("DEBUG AssPermTrans print:");
//		this.printAssPermTrans();
	} 

	//matrix with all the possible assignments (all possible permutations)
	public ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> getAssPerm(){
//		System.out.println("DEBUG call to getassperm");
		
//		for(int i=0;i<this.ass_perm.size();i++){
//			for(int j=0;j<this.ass_perm.get(i).size();j++){
//				System.out.print(this.ass_perm.get(i).get(j).getElement0().satString()+" "+this.ass_perm.get(i).get(j).getElement1().satString()+" \t");
//			}
//			System.out.println();
//		}
//		StackTraceElement[] stackTraceElements = Thread.currentThread().getStackTrace();
//		for(int i=0;i<stackTraceElements.length;i++){
//			System.out.println(stackTraceElements[i].getClassName());
//			System.out.println(stackTraceElements[i].getLineNumber());
//		}
		return this.ass_perm;
	}


	public ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> getAssignments(){
		return this.assignments;
	}

	public ArrayList<ArrayList<ParametricMessage>> getDomainPMConstans(){
		return this.domainPMconstants;
	}

	public int howManyConstants(){
		int ret=0;
		for(int i=0;i<this.getPMConstants().size();i++){
			for(int j=0;j<this.getPMConstants().get(i).size();j++){
				ret++;
			}
		}
		
		return ret;
	}
	
	//it adds constants to the domain
	//it is used in the stdConstraintSet so if you call getDomain 
	//you have all the constants in the domain
	public Domain addConst2Dom(){
		for(int row=0;row<domainPMconstants.size();row++){
			for(int col=0;col<domainPMconstants.get(row).size();col++){
				this.add(domainPMconstants.get(row).get(col));
			}
		}		
		return this;
	}


	public void add(ParametricMessage pm,IKStdConstraint ik){
		subs.add(new Pair<IKStdConstraint,ParametricMessage>(ik,pm));
		this.domainpm.add(pm);
	}
	public ArrayList<Pair<IKStdConstraint,ParametricMessage>> getSubs(){return this.subs;}

	//1. forall c1,c2 constants. c1!=c2
	public String differentConstants(){
		String constraints="";
		for(int r1=0;r1<this.domainPMconstants.size();r1++)
			for(int c1=0;c1<this.domainPMconstants.get(r1).size();c1++)
				for(int r2=0;r2<this.domainPMconstants.size();r2++)
					for(int c2=0;c2<this.domainPMconstants.get(r2).size();c2++)
						if(!(this.domainPMconstants.get(r1).get(c1).satString().equals(this.domainPMconstants.get(r1).get(c1).satString())))
							constraints+="\n(not (= "+this.domainPMconstants.get(r1).get(c1).satString()+" "+this.domainPMconstants.get(r2).get(c2).satString()+")) \n";	

		return constraints;
	}

	//2. forall c constant,m (composed)message. c!=m
	public String constdiffMsg(){		
		String constraints="";

		for(int rowC=0;rowC<this.domainPMconstants.size();rowC++)
			for(int colC=0;colC<this.domainPMconstants.get(rowC).size();colC++){
				Iterator<ParametricMessage> pmiter1=domainpm.iterator();		
				while(pmiter1.hasNext()){
					ParametricMessage current=pmiter1.next();
					if(!this.domainPMconstants.get(rowC).get(colC).satString().equals(current.satString()))
						constraints+="(not (="+this.domainPMconstants.get(rowC).get(colC).satString()+" "+current.satString()+"))\n";
				}
			}

		return constraints;
	}


	//3. forall m pair,crypt,inv in Dom. injectivity(m) 
	public String printInj(){
		String constraints="";

		//forall pair and crypt
		Iterator<ParametricMessage> iter1=domainpm.iterator();		
		while(iter1.hasNext()){
			ParametricMessage current1=iter1.next();
			Iterator<ParametricMessage> iter2=domainpm.iterator();
			while(iter2.hasNext()){
				ParametricMessage current2=iter2.next();	
				if((current1.getClass().equals(ParametricConcatenatedMessage.class) &&
						current2.getClass().equals(ParametricConcatenatedMessage.class))){
					
					if(current1.satString().equals(current2.satString()))
					constraints+="(implies (="+current1.satString()+" "+current2.satString()+") " +
							"(and(= "+((ParametricConcatenatedMessage)current1).getFirst().satString()+" "+((ParametricConcatenatedMessage)current2).getFirst().satString()+")" +
							"(= "+((ParametricConcatenatedMessage)current1).getSecond().satString()+" "+((ParametricConcatenatedMessage)current2).getSecond().satString()+")))\n";
				}else if((current1.getClass().equals(ParametricEncryptedMessage.class) &&
						current2.getClass().equals(ParametricEncryptedMessage.class))){
					if(current1.satString().equals(current2.satString()))
					constraints+="(implies (="+current1.satString()+" "+current2.satString()+") " +
							"(and(= "+((ParametricEncryptedMessage)current1).getFirst().satString()+" "+((ParametricEncryptedMessage)current2).getFirst().satString()+")" +
							"(= "+((ParametricEncryptedMessage)current1).getSecond().satString()+" "+((ParametricEncryptedMessage)current2).getSecond().satString()+")))\n";
				}else if((current1.getClass().equals(ParametricSymEncryptedMessage.class) &&
						current2.getClass().equals(ParametricSymEncryptedMessage.class))){
					if(current1.satString().equals(current2.satString()))
					constraints+="(implies (="+current1.satString()+" "+current2.satString()+") " +
							"(and(= "+((ParametricSymEncryptedMessage)current1).getFirst().satString()+" "+((ParametricSymEncryptedMessage)current2).getFirst().satString()+")" +
							"(= "+((ParametricSymEncryptedMessage)current1).getSecond().satString()+" "+((ParametricSymEncryptedMessage)current2).getSecond().satString()+")))\n";
				}
			}	
		}

		//forall private keys
		//this injectivity is implicitly true because of how we create the Domain
		//in fact inv(pk(a)) and pk(a) are constants and the constraints we can create are of the form
		// inv(a)=inv(a)=>a=a
		//that are trivially true
		//		for(int rowC=0;rowC<this.domainPMconstants.size();rowC++)
		//			if(domainPMconstants.get(rowC).get(0).getClass().equals(ParametricPrivateKeyConstant.class))
		//			for(int colC1=0;colC1<this.domainPMconstants.get(rowC).size();colC1++)
		//				for(int colC2=0;colC2<this.domainPMconstants.get(rowC).size();colC2++)
		//					constraints+="(implies(= "+domainPMconstants.get(rowC).get(colC1).satString()+" "+domainPMconstants.get(rowC).get(colC2).satString()+") (="+((ParametricPrivateKeyConstant)domainPMconstants.get(rowC).get(colC1)).getParametricAgent().getPublicKey().satString()+" "+((ParametricPrivateKeyConstant)domainPMconstants.get(rowC).get(colC2)).getParametricAgent().getPublicKey().satString()+"))\n";

		return constraints;
	}

	//	//TODO da eliminare
	//	//4. forall pk(A). pvt(A)=inv(pk(A))
		public String keysRelation(){
			String constraints="";
			for(int rowC=0;rowC<this.domainPMconstants.size();rowC++){
				if(domainPMconstants.get(rowC).get(0).getClass().equals(ParametricPrivateKeyConstant.class)){
					for(int colC1=0;colC1<this.domainPMconstants.get(rowC).size();colC1++){			
						//constraints+="(implies(= "+domainPMconstants.get(rowC).get(colC1).satString()+" "+domainPMconstants.get(rowC).get(colC2).satString()+") (="+((ParametricPrivateKeyConstant)domainPMconstants.get(rowC).get(colC1)).getParametricAgent().getPublicKey().satString()+" "+((ParametricPrivateKeyConstant)domainPMconstants.get(rowC).get(colC2)).getParametricAgent().getPublicKey().satString()+"))\n";
						constraints+="(= (inv "+((ParametricPrivateKeyConstant)domainPMconstants.get(rowC).get(colC1)).getParametricAgent().getPublicKey().satString()+") ("+domainPMconstants.get(rowC).get(colC1).satString()+"))";
					}
					break;
				}
			}
			return constraints;
		}

	public Pair<ArrayList<ParametricMessage[]>,ParametricMessage> findConstantizedWrtAss(ParametricMessage msg, ArrayList<Pair<ParametricMessage,ParametricMessage>> ass){
		boolean equal=true;
		ArrayList<Pair<ArrayList<ParametricMessage[]>,ParametricMessage>> msgConst=this.findConstantized(msg);
		//		System.out.println("cerco il constantizzato");
		//		System.out.println(msgConst.size());

		//if it is a constant or it does not have assignments we simply return it
		if(msgConst.size()==1 && msgConst.get(0).getElement0().size()==0)
			return msgConst.get(0);

//		for(int deb0=0; deb0<msgConst.size();deb0++){
//			for(int deb1=0;deb1<msgConst.get(deb0).getElement0().size();deb1++){
//				System.out.println("DEBUGMsgConst ["+deb0+", "+deb1+"] "+msgConst.get(deb0).getElement0().get(deb1)[0].satString()+" "+msgConst.get(deb0).getElement0().get(deb1)[1].satString());
//			}
//		}
		
//		for(int deb0=0; deb0<ass.size();deb0++){
//				System.out.println("DEBUGAss ["+deb0+"] "+ass.get(deb0).getElement0().satString()+" "+ass.get(deb0).getElement1().satString());
//		}

		//forall constantized messages
		for(int i=0;i<msgConst.size();i++){

			//forall instantiations
			for(int k=0;k<msgConst.get(i).getElement0().size();k++){
				//forall constraint of the assignment
				for(int j=0;j<ass.size();j++){
//										System.out.println(ass.get(j).getElement0().satString()+" ?= "+msgConst.get(i).getElement0().get(k)[0].satString());
//										System.out.println(ass.get(j).getElement1().satString()+" ?= "+msgConst.get(i).getElement0().get(k)[1].satString());

					if(ass.get(j).getElement0().satString().equals(msgConst.get(i).getElement0().get(k)[0].satString())
							&& !(ass.get(j).getElement1().satString().equals(msgConst.get(i).getElement0().get(k)[1].satString()))){
//												System.out.println("NO!");
						equal=false;
						break;
					}
				}
			}
			if(equal){
				//				System.out.println("YES!");
				return msgConst.get(i);			
			}else{
				equal=true;
			}
			//l'else sopra non funziona!
			
		}

		//there will always be a constantized message but java is stupid
		//make the compiler happy
		return null;
	}

	//output: list of ([assignment_1]...[assignment_n],parametricMessage)
	//where assignment_* is of the form [A][a] where A is the param and a the relative constant
	public ArrayList<Pair<ArrayList<ParametricMessage[]>,ParametricMessage>> findConstantized(ParametricMessage msg){
		ArrayList<Pair<ArrayList<ParametricMessage[]>, ParametricMessage>> ret=new ArrayList<Pair<ArrayList<ParametricMessage[]>, ParametricMessage>>();
//				System.out.println("DEBUGfc "+msg.satString()+" diventa:");
//				System.out.println("PARAMS: ");
//				this.printParams();
//		System.out.println("DEBUGfc " + msg.getClass().toString());
//		System.out.println("DEBUGfc " + msg.satString());

		if(msg instanceof ParametricConstant ||
				msg instanceof Parameter //||
				//				msg instanceof SymKeyParameter||
				//				msg instanceof ParametricSymKeyConstant
				//				||
				//				msg instanceof ParametricKey
				){
			//System.out.println(msg.satString());

			//			int debug=0;


			for(int row=0;row<this.domainPMconstants.size();row++)
				for(int col=0;col<this.domainPMconstants.get(row).size();col++){
					ArrayList<ParametricMessage[]> l=new ArrayList<ParametricMessage[]>();
					Pair<Boolean, ArrayList<ParametricMessage[]>> compareRes=msg.compare(domainPMconstants.get(row).get(col), l);
					if(compareRes.getElement0()){
						//it is the constantized version of the message
//												if(compareRes.getElement1().size()!=0)
//													System.out.println("DEBUGGO "+compareRes.getElement1().get(0)[0].satString());

						ret.add(new Pair<ArrayList<ParametricMessage[]>,ParametricMessage>(compareRes.getElement1(),domainPMconstants.get(row).get(col)));
						//						if(compareRes.getElement1().size()!=0)
						//							System.out.println("DEBUG 2 "+ret.get(debug).getElement0().get(0)[0].satString());//+" = "+ret.get(0).getElement0().get(0)[1].satString());
						//						debug++;						
						//						System.out.println("DEBUG "+ret.get(0).getElement1().satString());
						//						l.clear();
					}
				}

		}else{

			//it it is not a const \/ param then it is a message
			Iterator<ParametricMessage> iter=domainpm.iterator();
			while(iter.hasNext()){
				ParametricMessage current=iter.next();
				//if the two messages are equal then I return the 
				//params assignment and the corresponding 
				//constantized message

				ArrayList<ParametricMessage[]> l=new ArrayList<ParametricMessage[]>();

				//compare method returns:
				//- (Element 0) a boolean value (if true then we have the constantized message, it is "current")
				//- (Element 1) a list of Param=const

//				System.out.println("DEBUGfc "+msg.print()+" ?= "+current.print());
				Pair<Boolean, ArrayList<ParametricMessage[]>> compareRes=msg.compare(current, l);


				if(compareRes.getElement0()){
//										System.out.println("compareRes");
//										for(int deb0=0;deb0<compareRes.getElement1().size();deb0++)
//											System.out.println("["+compareRes.getElement1().get(deb0)[0].satString()+" "+compareRes.getElement1().get(deb0)[1].satString()+"] ");
//										System.out.println("MSG= "+current.satString());

					Pair<ArrayList<ParametricMessage[]>,ParametricMessage> tmp=new Pair<ArrayList<ParametricMessage[]>,ParametricMessage>(compareRes.getElement1(),current);
//										System.out.println("tmp");
//										for(int deb0=0;deb0<tmp.getElement0().size();deb0++)
//											System.out.println("["+tmp.getElement0().get(deb0)[0].satString()+" "+tmp.getElement0().get(deb0)[1].satString()+"] ");
//										System.out.println("MSG= "+current.satString());

					ret.add(tmp);
				}

			}
		}
		//ret: < [0][1]->[0][1]->... ,m> -> < [0][1]->[0][1]->... ,m>
		//debug
//				System.out.println("DEBUG ret");
//				for(int deb0=0;deb0<ret.size();deb0++){
//					for(int deb1=0;deb1<ret.get(deb0).getElement0().size();deb1++)
//						System.out.println("["+ret.get(deb0).getElement0().get(deb1)[0].satString()+"("+ret.get(deb0).getElement0().get(deb1)[0].hashCode()+") "+ret.get(deb0).getElement0().get(deb1)[1].satString()+"] ");
//					System.out.println("MSG= "+ret.get(deb0).getElement1().satString());
//				}
//					System.out.println();

		
		return ret;
	}	

	//this method creates a domain with only constantized messages
	//but no ground constans in it
	public void constantize(){
		ArrayList<ParametricMessage> addList=new ArrayList<ParametricMessage>();

		//for each element of the domain 
		//we create the constantized list
		//and substitute it with the list
		Iterator<ParametricMessage> iter1=domainpm.iterator();
		while(iter1.hasNext()){
			ParametricMessage current=iter1.next();
			ArrayList<ParametricMessage[]> temppm=new ArrayList<ParametricMessage[]>();



			//crete the constantized version of the message of the domain

			temppm=constantize(current);

			//add to domain the constantized
			ArrayList<ParametricMessage> tmpList=new ArrayList<ParametricMessage>();
			for(int j=0;j<temppm.size();j++){				
				//I create an arraylist from the array just because it is easier to handle in Array2Msg
				//we can get rid of this transformation by changing the output type of constantize()				
				for(int atl=0;atl<temppm.get(j).length;atl++){					
					tmpList.add(temppm.get(j)[atl]);					
				}
				addList.add(this.Array2Msg(tmpList));
				tmpList.clear();
			}

		}
		//clear the entire domain and add all the constantized messages
		domainpm.clear();
		for(int i=0;i<addList.size();i++)
			domainpm.add(addList.get(i));

	}

	//this method returns an arrayList with one element where there's the parametric message
	private ParametricMessage Array2Msg(ArrayList<ParametricMessage> input){
		if(input.get(0).equals(pair)||
				input.get(0).equals(enc)||
				input.get(0).equals(scrypt)){
			int pairNum=2;
			ArrayList<ParametricMessage> first=new ArrayList<ParametricMessage>();
			ArrayList<ParametricMessage> second=new ArrayList<ParametricMessage>();
			for(int j=1;j<input.size();j++){
				if(pairNum==1){
					for(int k=j;k<input.size();k++)
						second.add(input.get(k));
					break;
				}
				if(input.get(j).equals(pair)||input.get(j).equals(enc)||input.get(j).equals(scrypt)){
					pairNum++;
					first.add(input.get(j));
				}else{						
					first.add(input.get(j));
					pairNum--;
				}					
			}

			if(input.get(0).equals(pair))
				return new ParametricConcatenatedMessage(Array2Msg(first),Array2Msg(second));
			else if(input.get(0).equals(enc))
				return new ParametricEncryptedMessage(Array2Msg(first),((ParametricPublicKeyConstant)Array2Msg(second)));
			else if(input.get(0).equals(scrypt))
				return new ParametricSymEncryptedMessage(Array2Msg(first),((ParametricSymKeyConstant)Array2Msg(second)));
			else
				System.out.println("ERROR in Domain method Array2Msg(ArraList<ParametricMessage>)");
			System.exit(0);
			return null;
		}else{
			return input.get(0);
		}
	}
	
	public ArrayList<Message> getFunVars(){return this.functionVars;}
	public void setFunctionVars(ArrayList<Message> functionVars){this.functionVars=functionVars;}
	public void addFunVar(Message m){
		boolean ok=true;
		for(int i=0;i<this.getFunVars().size();i++){
			if(this.getFunVars().get(i).equals(m)){
				ok=false;
				break;
			}
		}
			
		if(ok)
			this.getFunVars().add(m);
		
		ok=true;
	}
	//list of assignments used for functions
	//it is identical to the getAssignments but it returns a list of Var,Const instead of Param,Const
	//it is instantiated in Specification->createInterpolantString
	public ArrayList<ArrayList<Pair<Message,ParametricMessage>>> getFunAss(){return this.funAss;}
	public void addFunAss(ArrayList<Pair<Message,ParametricMessage>> funAss){
		if(!this.getFunAss().contains(funAss))
			this.getFunAss().add(funAss);
	}
	
	
	private ArrayList<ParametricMessage[]> constantize(ParametricMessage Message){
//				System.out.println("DEBUGConstantization "+Message.satString());

		int current=0;
		//		System.out.println(Message.satString());
		//M:=arrayzzamelo(Message); //this method outputs Message as array		
		ArrayList<ParametricMessage> temp=new ArrayList<ParametricMessage>();
		ArrayList<ParametricMessage> M=new ArrayList<ParametricMessage>();
		M=Message.Msg2List(temp,enc,pair,scrypt);
		M.trimToSize();

		ArrayList<ParametricMessage[]> output=new ArrayList<ParametricMessage[]>();

		//add an object because using an array I'm forced to determin the size of each component of the output list
		//the sie of each array in the output list will be the same as the message M I'm considering
		if(output.size()==0){
			ParametricMessage[] tempPM=new ParametricMessage[M.size()];			
			output.add(tempPM);
		}
		//ci sono sia pm che value, ricordatelo!
		//prima devi sistemare le costanti in value
		//perche' ci sono altre classi e non solo quelle che hai scritto
		//e devi modificare di conseguenza anche qui 

		for(int i=0;i<M.size();i++){
			//if it is not a parameter then I simply add it to output
			if(M.get(i)==pair ||
					M.get(i)==enc ||
					M.get(i)==scrypt ||
					M.get(i).getClass().equals(ParametricPrivateKeyConstant.class )||
					M.get(i).getClass().equals(ParametricPublicKeyConstant.class) ||
					M.get(i).getClass().equals(ParametricAgentConstant.class) ||
					M.get(i).getClass().equals(ParametricNonceConstant.class) ||
					M.get(i).getClass().equals(ParametricGenericConstant.class) ||
					M.get(i).getClass().equals(ParametricSymKeyConstant.class))
			{
				//				System.out.println("noPar");
				for(int j=0;j<output.size();j++){
					output.get(j)[current]=M.get(i);
				}				
			}else{
				//				System.out.println("Par:"+M.get(i));
				//otherwise it is a parameter and I have to duplicate the array 
				//one for each possible constant 				
				for(int crow=0;crow<domainPMconstants.size();crow++){					
					for(int j=0;j<output.size();j++){
						//check if the param is a superclass of the constant
						if(M.get(i).getClass().isAssignableFrom(domainPMconstants.get(crow).get(0).getClass())||
								M.get(i).getClass().getSuperclass().equals(domainPMconstants.get(crow).get(0).getClass().getSuperclass())||
								(M.get(i).getClass().equals(PublicKeyParameter.class) && domainPMconstants.get(crow).get(0).getClass().equals(ParametricPublicKeyConstant.class))||
								(M.get(i).getClass().equals(PrivateKeyParameter.class) && domainPMconstants.get(crow).get(0).getClass().equals(ParametricPrivateKeyConstant.class))||
								(M.get(i).getClass().equals(SymKeyParameter.class) && domainPMconstants.get(crow).get(0).getClass().equals(ParametricSymKeyConstant.class))
								){
							//							System.out.println("it is a superclass of the constant");
							//if it is then I put the param in output so I can 
							//create all the possible permutations afterwards 
							output.get(j)[current]=M.get(i);	
						}
						//						System.out.println("it is NOT a superclass of the constant");
						//						System.out.println(M.get(i).getClass().toString()+" ?= "+domainPMconstants.get(crow).get(0).getClass());
					}
				}

				//create all the possible permutations 
				for(int crow=0;crow<domainPMconstants.size();crow++){						
					//the class is not equal but they're one the superclass of the other
					if(output.get(0)[current].getClass().isAssignableFrom(domainPMconstants.get(crow).get(0).getClass())||
							output.get(0)[current].getClass().getSuperclass().equals(domainPMconstants.get(crow).get(0).getClass().getSuperclass()) ||
							(output.get(0)[current].getClass().equals(PublicKeyParameter.class) && domainPMconstants.get(crow).get(0).getClass().equals(ParametricPublicKeyConstant.class))||
							(output.get(0)[current].getClass().equals(PrivateKeyParameter.class) && domainPMconstants.get(crow).get(0).getClass().equals(ParametricPrivateKeyConstant.class))||
							(output.get(0)[current].getClass().equals(SymKeyParameter.class) && domainPMconstants.get(crow).get(0).getClass().equals(ParametricSymKeyConstant.class))
							){					
						if(domainPMconstants.get(crow).size()==1){
							//if there's only one constant of the considered type then we simply 
							//substitute the param with the constant
							//in each row of the output matrix
							for(int outRow=0;outRow<output.size();outRow++)
								output.get(outRow)[current]=domainPMconstants.get(crow).get(0);
						}else{
							ArrayList<ParametricMessage[]> pmstoadd=new ArrayList<ParametricMessage[]>();
							//if there are more than 1 constant we crete one row for each constants in the output matrix
							for(int outRow=0;outRow<output.size();outRow++){
								output.get(outRow)[current]=domainPMconstants.get(crow).get(0);
								for(int ccol=1;ccol<domainPMconstants.get(crow).size();ccol++){
									//create the new row that we add to the output matrix
									ParametricMessage[] row2copy=new ParametricMessage[output.get(outRow).length];
									//create the row clone
									for(int j=0;j<output.get(outRow).length;j++){
										row2copy[j]=output.get(outRow)[j];
									}
									//substitute the constant with the new one
									row2copy[current]=domainPMconstants.get(crow).get(ccol);									
									//add to a list that will be added at the end to avoi useless run of this procedure
									pmstoadd.add(row2copy);
								}
							}

							//add all the new lines to output
							for(int j=0;j<pmstoadd.size();j++)
								output.add(pmstoadd.get(j));
						}
					}
				}

			}
			current++;
		}
		output.trimToSize();


				//debug print the output
//				System.out.println("DEBUGConstantization out:= ");
//				for(int deb=0;deb<output.size();deb++){			
//					for(int deb2=0;deb2<output.get(deb).length;deb2++){
//					if(output.get(deb)[deb2]==pair){System.out.print("pair ");}
//					else if(output.get(deb)[deb2]==enc){System.out.print("crypt ");}
//					else if(output.get(deb)[deb2]==scrypt){System.out.print("scrypt ");}
//					else if(output.get(deb)[deb2]==null){System.out.print("null ");}
//					else{System.out.print(output.get(deb)[deb2].satString()+" ");}
//					}					
//					System.out.println();
//				}

		return output;
	}
	
	public void addPfunList(ParametricFunction pf){
		this.pfunList.add(pf);
	}

	public DomainParametricMessage getDomainParametricMessage(){return domainpm;}
	//classes
	public class DomainParametricMessage extends HashSet<ParametricMessage>{
		public String print(){
			String ret="";
			Iterator<ParametricMessage> iter=this.iterator();
			while(iter.hasNext()){
				ret+=iter.next().satString()+"\n";
			}
			return ret;
		}

		//list of "[constant_1,...,constant_n]" where constants are of the same type
		private ArrayList<ArrayList<ParametricMessage>> param_cons_array(){		
			ArrayList<ArrayList<ParametricMessage>> ret=new ArrayList<ArrayList<ParametricMessage>>();

			boolean nonceAlreadyPresent=false;
			boolean agentAlreadyPresent=false;
			boolean publicAlreadyPresent=false;
			boolean privateAlreadyPresent=false;
			boolean genericAlreadyPresent=false;
			boolean symAlreadyPresent=false;


			//for parametric messages domain
			Iterator<ParametricMessage> pmiter1=domainpm.iterator();		
			while(pmiter1.hasNext()){								

				ParametricMessage pm1current=pmiter1.next();
				//if SYMKEY parameter
				if(pm1current.getClass().equals(ParametricSymKeyConstant.class)&& !symAlreadyPresent){

					ArrayList<ParametricMessage> param=new ArrayList<ParametricMessage>();
					Iterator<ParametricMessage> pmiter2=domainpm.iterator();
					while(pmiter2.hasNext()){
						ParametricMessage pm2current=pmiter2.next();
						if(pm2current.getClass().equals(ParametricSymKeyConstant.class)){
							//System.out.print(pm2current.satString()+" is a NONCE constant\n");
							param.add(pm2current);
						}
					}
					ret.add(param);
					symAlreadyPresent=true;
				}


				//if NONCE parameter
				if(pm1current.getClass().equals(ParametricNonceConstant.class)&& !nonceAlreadyPresent){

					ArrayList<ParametricMessage> param=new ArrayList<ParametricMessage>();
					Iterator<ParametricMessage> pmiter2=domainpm.iterator();
					while(pmiter2.hasNext()){
						ParametricMessage pm2current=pmiter2.next();
						if(pm2current.getClass().equals(ParametricNonceConstant.class)){
							//System.out.print(pm2current.satString()+" is a NONCE constant\n");
							param.add(pm2current);
						}
					}
					ret.add(param);
					nonceAlreadyPresent=true;
				}

				//if agent param				
				else if(pm1current.getClass().equals(ParametricAgentConstant.class) && !agentAlreadyPresent){			

					ArrayList<ParametricMessage> param=new ArrayList<ParametricMessage>();
					Iterator<ParametricMessage> pmiter2=domainpm.iterator();
					while(pmiter2.hasNext()){
						ParametricMessage pm2current=pmiter2.next();
						if(pm2current.getClass().equals(ParametricAgentConstant.class)){
							//System.out.print(pm2current.satString()+" is a AGENT constant\n");
							param.add(pm2current);
						}
					}
					ret.add(param);

					agentAlreadyPresent=true;
				}

				//if public key				
				else if(pm1current.getClass().equals(ParametricPublicKeyConstant.class) && !publicAlreadyPresent){		

					ArrayList<ParametricMessage> param=new ArrayList<ParametricMessage>();						
					Iterator<ParametricMessage> pmiter2=domainpm.iterator();
					while(pmiter2.hasNext()){
						ParametricMessage pm2current=pmiter2.next();
						if(pm2current.getClass().equals(ParametricPublicKeyConstant.class)){
							//System.out.print(pm2current.satString()+" is a PUB constant\n");
							param.add(pm2current);
						}
					}
					ret.add(param);

					publicAlreadyPresent=true;
				}

				//if pvtkey
				else if(pm1current.getClass().equals(ParametricPrivateKeyConstant.class) && !privateAlreadyPresent){			

					ArrayList<ParametricMessage> param=new ArrayList<ParametricMessage>();
					Iterator<ParametricMessage> pmiter2=domainpm.iterator();
					while(pmiter2.hasNext()){
						ParametricMessage pm2current=pmiter2.next();
						if(pm2current.getClass().equals(ParametricPrivateKeyConstant.class)){
							//System.out.print(pm2current.satString()+" is a PVT constant\n");
							param.add(pm2current);
						}
					}
					ret.add(param);

					privateAlreadyPresent=true;
				}

				//if generic param
				else if(pm1current.getClass().equals(ParametricGenericConstant.class) && !genericAlreadyPresent){			

					ArrayList<ParametricMessage> param=new ArrayList<ParametricMessage>();
					Iterator<ParametricMessage> pmiter2=domainpm.iterator();
					while(pmiter2.hasNext()){
						ParametricMessage pm2current=pmiter2.next();
						if(pm2current.getClass().equals(ParametricGenericConstant.class)){
							//System.out.print(pm2current.satString()+" is a GENERIC constant\n");
							param.add(pm2current);
						}
					}
					ret.add(param);

					genericAlreadyPresent=true;
				}
				//else{System.out.print(pm1current.satString()+" is not a param or already considered\n");}				

			}


			//delete atomic params and constants from the domain
			//I can't delete them here because of concurrency problem
			Iterator<ParametricMessage> pmiterfinal=domainpm.iterator();

			while(pmiterfinal.hasNext()){
				ParametricMessage pm=pmiterfinal.next();
				if(pm.getClass().equals(GenericParameter.class)||
						pm.getClass().equals(PrivateKeyParameter.class) ||
						pm.getClass().equals(PublicKeyParameter.class) ||
						pm.getClass().equals(AgentParameter.class) ||
						pm.getClass().equals(NonceParameter.class) ||
						pm.getClass().equals(SymKeyParameter.class) ||
						pm.getClass().equals(ParametricNonceConstant.class)||
						pm.getClass().equals(ParametricAgentConstant.class)||
						pm.getClass().equals(ParametricGenericConstant.class)||
						pm.getClass().equals(ParametricPublicKeyConstant.class)||
						pm.getClass().equals(ParametricPrivateKeyConstant.class)||
						pm.getClass().equals(ParametricSymKeyConstant.class)
						){
					toRemove.add(pm);
				}				
			}

			return ret;
		}

	}


	
	
	//USELESS Value domain
	private class DomainValue extends HashSet<Value>{
		public String print(){
			String ret="";
			Iterator<Value> iter=this.iterator();
			while(iter.hasNext()){
				ret+=iter.next().satString()+"\n";
			}
			return ret;
		}

		//list of "[param][constant_1,...,constant_n]" where constant_i is the constant of the "same" type of param
		private ArrayList<ArrayList<Value>> param_cons_array(){		
			ArrayList<ArrayList<Value>> ret=new ArrayList<ArrayList<Value>>();
			//		//for value domain
			//		Iterator<Value> viter1=domainvalue.iterator();
			//		while(viter1.hasNext()){
			//			//if nonce param
			//			Value v1current=viter1.next();
			//			if(v1current instanceof NonceParameter){
			//				ArrayList<Value> param=new ArrayList<Value>();
			//				Iterator<Value> viter2=domainvalue.iterator();
			//				while(viter2.hasNext()){
			//					Value v2current=viter2.next();
			//					if(v2current instanceof ParametricNonceConstant){
			//						param.add(v2current);
			//					}
			//				}
			//				param.add(0, v1current);
			//				ret.add(param);
			//			}
			//			//if agent param
			//			if(v1current instanceof AgentParameter){
			//				ArrayList<Value> param=new ArrayList<Value>();
			//				Iterator<Value> viter2=domainvalue.iterator();
			//				while(viter2.hasNext()){
			//					Value v2current=viter2.next();
			//					if(v2current instanceof ParametricAgentConstant){
			//						param.add(v2current);
			//					}
			//				}
			//				param.add(0, v1current);
			//				ret.add(param);
			//			}
			//			//if pubkey
			//			//I've not used instanceof because "a instanceof b" returns true even if a is a subclass of b
			//			//while the getClass().equals(class) does not.
			//			//a ParametricPublicKeyConstant is subclass of ParametricPublicKey then, 
			//			//but I don't want Constants in the first if but only Parameters
			//			//the same for Private keys below
			//			if(v1current.getClass().equals(PublicKeyParameter.class)){
			//				ArrayList<Value> param=new ArrayList<Value>();
			//				Iterator<Value> viter2=domainvalue.iterator();
			//				while(viter2.hasNext()){
			//					Value v2current=viter2.next();
			//					if(v2current instanceof ParametricPublicKeyConstant){
			//						param.add(v2current);
			//					}
			//				}
			//				param.add(0, v1current);
			//				ret.add(param);
			//			}
			//			//if pvtkey
			//			if(v1current.getClass().equals(PrivateKeyParameter.class)){
			//				ArrayList<Value> param=new ArrayList<Value>();
			//				Iterator<Value> viter2=domainvalue.iterator();
			//				while(viter2.hasNext()){
			//					Value v2current=viter2.next();
			//					if(v2current instanceof ParametricPrivateKeyConstant){
			//						param.add(v2current);
			//					}
			//				}
			//				param.add(0, v1current);
			//				ret.add(param);
			//			}
			//			//if generic param
			//			if(v1current instanceof GenericParameter){
			//				ArrayList<Value> param=new ArrayList<Value>();
			//				Iterator<Value> viter2=domainvalue.iterator();
			//				while(viter2.hasNext()){
			//					Value v2current=viter2.next();
			//					if(v2current instanceof ParametricGenericConstant){
			//						param.add(v2current);
			//					}
			//				}
			//				param.add(0, v1current);
			//				ret.add(param);
			//			}
			//		}
			return ret;
		}

	}


	public String[][] createAssignments(String[] C,String[] variables){
		int numColM=variables.length;
		int numRowM=this.pow(C.length,variables.length);
		String[][] combinations=new String[numRowM][numColM];
		
		int row=0;
		for(int col=0;col<numColM;col++){
			row=0;
			while(row<numRowM)
				for(int c=0;c<C.length;c++)
					for(int i=0;i<this.pow(C.length,col);i++){
						combinations[row][col]=C[c];
						row++;
					}
		}

		return combinations;
	}
//	public String[][] createAssignments(String[] constants,String[] variables){
//		//we want a combination matrix that represents every possible combination
//		//with repetitions
//		//that has variables on columns
//		//so every rows is a combination
//
//		String[][] combinations;
//
//		if(variables.length==1){
//			combinations=new String[constants.length][1];
//			//			System.out.println("length="+constants.length);
//			for(int i=0;i<constants.length;i++)
//				combinations[i][0]=constants[i];
//		}else{
//			combinations=new String[this.pow(variables.length,constants.length)][variables.length];
//			int z=this.pow(constants.length,variables.length);
//			int index=0;
//			int k=0;
//
//			for(int j=0;j<variables.length;j++){
//				z=z/variables.length;
//
//				index=0;
//				k=1;
//				for(int i=0;i<this.pow(variables.length,constants.length);i++){
//					//System.out.print("i="+i+"\tj="+j+"\tz="+z+"\tindex="+index+"\tk="+k);
//					if(k<=z){
//						k++;
//					}else{ 
//						if(index<constants.length-1)
//							index++;
//						else
//							index=0;
//						k=2;
//					}
//					//					System.out.println("\t["+i+"]["+j+"]="+constants[index]);
//					combinations[i][j]=constants[index];	
//
//
//				}
//			}
//		}
//
//		return combinations;
//	}

	private int pow(int value, int power){
		if(power == 0){
			return 1;
		}

		int result = value;
		for(int i = 0; i < power -1; i++){
			result = result * value; 
		}
		return result;
	}

	private String[][] matrixCombine(String[][] m1,String[][] m2){
		String[][] m3=new String[(m1.length)*(m2.length)][(m1[0].length)+(m2[0].length)];

		int i3=0,j3=0;

		for(int i1=0;i1<m1.length;i1++){

			for(int i2=0;i2<m2.length;i2++){

				for(int j1=0;j1<m1[i1].length;j1++){

					m3[i3][j3]=m1[i1][j1];
					j3++;
				}
				for(int j2=0;j2<m2[i2].length;j2++){

					m3[i3][j3]=m2[i2][j2];
					j3++;
				}				
				i3++;
				j3=0;
			}
		}

		return m3;
	}


	//BEGIN DEBUG METHODS
	//prints constants of the domain
	private String printParamAL(ArrayList<ArrayList<ParametricMessage>> pca){
		String ret="----CONSTANTS----\n";		
		Iterator<ArrayList<ParametricMessage>> iter1 = pca.iterator();		
		while(iter1.hasNext()){
			ArrayList<ParametricMessage> iter1c=iter1.next();	
			ret+=iter1c.get(0).getClass()+":\t ";
			Iterator<ParametricMessage> iter2 = iter1c.iterator();			
			while(iter2.hasNext()){
				ret+=iter2.next().satString()+" ";
			}
			ret+="\n";
		}
		return ret+="----CONSTANTS----";
	}

	//print arrayzed parametric message input
	public String printARPM(ArrayList<ParametricMessage[]> input){
		String ret="";	

		for(int row=0;row<input.size();row++){			
			for(int col=0;col<input.get(row).length;col++){
				if(input.get(row)[col]==pair){
					ret+="pair ";
				}else if(input.get(row)[col]==enc){
					ret+="enc ";
				}else if(input.get(row)[col]==scrypt){
					ret+="scrypt ";
				}else{
					ret+=(input.get(row)[col]).satString()+" ";
				}
			}
			ret+="\n";
		}
		return "elem: \""+ret+"\"";
	}

	public String print(){
		String ret="";
		ret+=domainpm.print();
		return ret;
	}

	public void printSubs(){
		for(int i=0;i<this.subs.size();i++){
			System.out.println("DEBUG IK: ");
			System.out.println(subs.get(i).getElement0().satPrint(this));
			System.out.println("DEBUG m_"+i+": ");
			System.out.println(subs.get(i).getElement1().satString());
		}
	}

	public void printParams(){
		for(int i=0;i<this.getDomainPMparams().size();i++)
			System.out.println("DEBUG PARAM: "+this.getDomainPMparams().get(i).satString());
	}

	//ArrayList<Pair<ParametricMessage,ParametricMessage>>
	public void printAss(){
		for(int i=0;i<this.getAssignments().size();i++)
			for(int j=0;j<this.getAssignments().get(i).size();j++)
				System.out.println("DEBUG ASS: ["+i+","+j+"] "+this.getAssignments().get(i).get(j).getElement0().satString()+" "+this.getAssignments().get(i).get(j).getElement1().satString());
	}

	//ArrayList<Pair<ParametricMessage,ParametricMessage>>
	public void printAssPerm(){
		for(int i=0;i<this.getAssPerm().size();i++)
			for(int j=0;j<this.getAssPerm().get(i).size();j++)
				System.out.println("DEBUG ASSPERM: ["+i+","+j+"] "+this.getAssPerm().get(i).get(j).getElement0().satString()+" "+this.getAssPerm().get(i).get(j).getElement1().satString());
	}
	//ArrayList<Pair<ParametricMessage,ParametricMessage>>
	public void printAssPermMatrix(){
		int j=0;
		while(this.getAssPerm().get(0).size()>j){
			for(int i=0;i<this.getAssPerm().size();i++){
				System.out.print(this.getAssPerm().get(i).get(j).getElement0().satString()+", "+this.getAssPerm().get(i).get(j).getElement1().satString()+" \t");
			}
			j++;
			System.out.println();
		}
	}

	public void printAssPermTrans(){
		System.out.println("PRINT Trasposta");
		//		System.out.println("cols"+this.getAssPermTrans().size());
		//		System.out.println("rows"+this.getAssPermTrans().get(0).size());
		for(int i=0;i<this.getAssPermTrans().size();i++){
			for(int j=0;j<this.getAssPermTrans().get(i).size();j++){
				System.out.print(this.getAssPermTrans().get(i).get(j).getElement0().satString()+" "+this.getAssPermTrans().get(i).get(j).getElement1().satString()+" \t");
			}
			System.out.println();
		}
		System.out.println("Fine PRINT Trasposta");
	}

	public void printAssPerm_trans(){
		System.out.println("PRINT Trasposta");
		//		System.out.println("cols"+this.getAssPermTrans().size());
		//		System.out.println("rows"+this.getAssPermTrans().get(0).size());
		for(int i=0;i<this.getAssPerm().size();i++){
			for(int j=0;j<this.getAssPerm().get(i).size();j++){
				System.out.print(this.getAssPerm().get(i).get(j).getElement0().satString()+" "+this.getAssPerm().get(i).get(j).getElement1().satString()+" \t");
			}
			System.out.println();
		}
		System.out.println("Fine PRINT Trasposta");
	}

	//END DEBUG METHODS

}
