package se;

import java.util.ArrayList;


public class EncryptedMessage extends Message{
	
	Message message;
	Key key;
	
	public EncryptedMessage(Message m, Key k){
		this.message = m;
		this.key = k;
	}
	
	public EncryptedMessage(Message m, Key k, String messageString){
		this(m,k);
		this.messageString = messageString;
	}
	
	public Message getAnotherOfTheSameType(String name){
		return new EncryptedMessage(this.message.getAnotherOfTheSameType(name),(Key)this.key.getAnotherOfTheSameType(name));
	}
	
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
//		System.out.println("subs in ecnMsg "+this.messageString+" -> ");
		Message m=(Message)this.message.substitute(mex_newMex);
		Key k=(Key)this.key.substitute(mex_newMex);
//		System.out.println("{"+m.toString()+"}_"+k.toString());
		return new EncryptedMessage(m,k,"{"+m.toString()+"}_"+k.toString());
	}
	
	public ParametricEncryptedMessage eval(Environment env){
		ParametricEncryptedMessage epm = new ParametricEncryptedMessage(this.message.eval(env),this.key.eval(env));
		return epm;
	}	
	
	public String print() {
		return "EncryptedMessage "+this.hashCode()+" : {"+this.message.print()+ "}_{" + this.key.print()+"}";
	}

	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){		
		list=this.message.getVars(list);
		list=this.key.getVars(list);
		return list;
	}
	public ParametricMessage eval4Domain(Environment env){
		return new ParametricEncryptedMessage((ParametricMessage)this.message.eval4Domain(env),(ParametricKey)this.key.eval4Domain(env)); 
	}
	
	public String interpolantString(Environment env){
		return "(crypt "+this.message.interpolantString(env)+" "+this.key.interpolantString(env)+")";
	}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		return "(crypt "+this.message.interpolantString(env,assignment)+" "+this.key.interpolantString(env,assignment)+")";
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message,ParametricMessage>> assignment){		
		return "(crypt "+this.message.interpolantString(env,assignment)+" "+this.key.interpolantString(env,assignment)+")";
	}
	
	public String toString(){
		return this.messageString;
	}
}
