package se;

import java.util.HashSet;
import java.util.Iterator;

public class Environment extends HashSet<DataState> {

	public boolean addDataState(DataState dataState){
		boolean exitStatus;
		DataState currentds;
	
		Iterator<DataState> iterator=this.iterator();		
		while (iterator.hasNext()){
			currentds=iterator.next(); 
			if(currentds.getVariable() == dataState.getVariable()){
				iterator.remove();
				break;
			}
		}
		exitStatus=this.add(dataState);
		return exitStatus;
	}
	
	public boolean updateIK(DataState dataState){
		boolean exitStatus;
		DataState currentds;
		ParametricMessageSet temp = new ParametricMessageSet();
		
		Iterator<DataState> iterator=this.iterator();		
		while (iterator.hasNext()){
			currentds=iterator.next(); 
			if(currentds.getVariable() == IKVariable.getInstance()){
				temp = (ParametricMessageSet)currentds.getValue();
				iterator.remove();
				break;
			}
		}
		
		Iterator<ParametricMessage> iter=temp.iterator();		
		while (iter.hasNext()){
			((ParametricMessageSet)dataState.getValue()).add(iter.next()); 
		}
		
		exitStatus=this.add(dataState);
		return exitStatus;
	}
	
	public boolean containsDataState(DataState dataState){
				DataState currentds;
			
				Iterator<DataState> iterator=this.iterator();		
				while (iterator.hasNext()){
					currentds=iterator.next();
					if((currentds.getVariable() == dataState.getVariable()) && (currentds.getValue() == dataState.getValue())){
						return true;
					}
				}
				return false;
	}	
	
	public Environment getCopy() {
		Environment returnSet = new Environment();
		Iterator<DataState> iter=this.iterator();			
		while(iter.hasNext()){
			DataState current=iter.next();
			returnSet.add(current);
		}
		return returnSet;
	}	

// two methods used just for testing	
	public void printElements(){
		DataState currentds;
		Iterator<DataState> iterator=this.iterator();
		System.out.println();
		System.out.println("Elements of the Environment " + this.hashCode());
		while (iterator.hasNext()){
			currentds=iterator.next();
			System.out.println((currentds.getVariable()).hashCode()+"  "+(currentds.getValue()).hashCode());
		}
	}
	
	public void print(){
		int i=0;
		DataState currentds;
		Iterator<DataState> iterator=this.iterator();
		System.out.println("Elements of the Environment " + this.hashCode() + " :");
		while (iterator.hasNext()){
			i++;
			currentds=iterator.next();
			System.out.println(i+"- ("+(currentds.getVariable()).print()+" , "+(currentds.getValue()).print()+")");
		}
		System.out.println("------------end of Environment "+ this.hashCode()+" -------------");
		System.out.println();
	}

}
