package se;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class FactConditional extends OPConditional{
	FactVariable factvar;
	Tuple tuple;
	BooleanConstant booleanValue;

	//	public FactConditional(FactVariable factname,BooleanConstant tuple) {
	//		super(null,null);
	//	}

	public void add2Spec(Specification spec){
//		spec.addFact(this.factvar, this.tuple);
	}

	public FactConditional substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		Tuple tmp_tuple=(Tuple)this.tuple.substitute(mex_newMex);
		return new FactConditional(this.factvar,tmp_tuple,this.booleanValue,factvar.getName()+"("+tmp_tuple.toString()+")");
		//		this.actionString=factvar.getName()+"("+this.tuple.toString()+")";
	}
	//	public void modifyActionString(Evaluable lhs,Evaluable rhs){
	//		this.actionString=factvar.getName()+"("+this.tuple.toString()+")";
	//	}

	public FactConditional(FactVariable factvar,Tuple tuple,BooleanConstant booleanValue) {
		this.factvar=factvar;
		this.tuple=tuple;
		this.booleanValue=booleanValue;
	}

	public FactConditional(FactVariable factvar,Tuple tuple,BooleanConstant booleanValue, String actionString) {
		this(factvar,tuple,booleanValue);
		this.actionString = actionString;
	}

	/**
	 * Warning!
	 * with se() when we consider functions, we create a constraint between instances of the two functions.
	 * The check should be done on the pair (functionName, arguments) but it should be handled in ConstraintSet method satCheck (foci print). 
	 */
	public SymbolicDataState se(SymbolicDataState sds){	

		SymbolicDataState newSds;
		newSds = sds.getCopy();

		System.out.println("BEFORE");
		sds.getConstraintSet().print();

		FactConstraint factConstraint = new FactConstraint(this.factvar,this.tuple.eval(newSds.getEnvironment()),this.booleanValue.eval(newSds.getEnvironment()));
		newSds.addConstraint2ConstraintSet(factConstraint);

		System.out.println("\n\nAFTER");
		newSds.getConstraintSet().print();

		return newSds;
	}

	public FactConstraint recursiveSe(SymbolicDataState sds){
		FactConstraint factConstraint = new FactConstraint(this.factvar,this.tuple.eval(sds.getEnvironment()),this.booleanValue.eval(sds.getEnvironment()));
		return factConstraint;
	}

	public String print() {
		return "FactConditional "+this.hashCode()+ " : (" + this.factvar.getName() + " "+ this.tuple.interpolantString()+ ") == (" + this.booleanValue.print() + ")";
	}

	public String getSemantics(Domain dom, Environment env, int RPD){
		String ret="";

		//for all messages in messageSet of IK+{messageSet}
		ret+="(and ";

		//forall vars assignment (to handle functions)
		ArrayList<ArrayList<Pair<Message, ParametricMessage>>> assignments=dom.getFunAss();
		boolean funAss=false;
		if(assignments.size()!=0){
			funAss=true;
		}

		if(funAss){
			ret+="(or \n";

			//loop on assignment
			for(int ass=0;ass<assignments.size();ass++){

				//get the actual assignment
				ArrayList<Pair<Message, ParametricMessage>> currentAss=assignments.get(ass);

				ret+="(and";
				for(int var=0;var<currentAss.size();var++){
					ret+=" (= "+currentAss.get(var).getElement0().interpolantString(env, currentAss)+" "+currentAss.get(var).getElement1().satString()+")";
				}

				this.getSemantics_procedure(dom, env, RPD, currentAss);

				ret+=")";
			}
			ret+=")";
		}else{
			ret+=this.getSemantics_procedure(dom, env, RPD,  new ArrayList<Pair<Message, ParametricMessage>>());
		}

		ret+=")";
		return ret;
	}

	private String getSemantics_procedure(Domain dom, Environment env, int RPD,ArrayList<Pair<Message, ParametricMessage>> assignment){
		String ret="\n",temp="";

		temp+="(= ("+this.factvar.getName()+" "+this.tuple.interpolantString(env,assignment)+") "+this.booleanValue.interpolantString(env,assignment)+")";
		

		if(temp.contains("(pk") || temp.contains("(pvt")){

			ArrayList<String> groups=new ArrayList<String>();
			//substitute (pk AV) and/or (pvt AV) with all the 
			//possible AgentConstants from Domain
			Pattern pattern=Pattern.compile("\\(pk (AV\\d+)\\s*\\)|\\(pvt (AV\\d+)\\s*\\)");
			Matcher matcher=pattern.matcher(temp);

			//create groups that is the arraylist of all 
			//the variable of pk and pvt key
			while (matcher.find()) {

				if(!matcher.group().isEmpty()){
					if(!groups.contains(matcher.group().replaceAll("\\(pk", "").replaceAll("\\(pvt", "").replaceAll("\\)", "")))
						groups.add(matcher.group().replaceAll("\\(pk", "").replaceAll("\\(pvt", "").replaceAll("\\)", ""));
				}
			}

			//calculate size of the assignments matrix
			//add all the assignments to the matrix

			//search constant row in constant
			//we save the row of agentConstant,publickeyconstant and privatekeyconstant
			int constRow=0,constPKRow=0,constPVTRow=0;
			boolean constPKRowExist=false,constPVTRowExist=false;
			for(int k=0;k<dom.getPMConstants().size();k++){
				//				ret+="AH! "+dom.getPMConstants().get(k).get(0).getClass().toString();
				if(dom.getPMConstants().get(k).get(0).getClass().equals(ParametricAgentConstant.class)){
					constRow=k;
					//					ret+="AH1!";
				}
				if(dom.getPMConstants().get(k).get(0).getClass().equals(ParametricPublicKeyConstant.class)){
					constPKRow=k;
					//					ret+="AH2!";
					constPKRowExist=true;
				}
				if(dom.getPMConstants().get(k).get(0).getClass().equals(ParametricPrivateKeyConstant.class)){
					//					ret+="AH3!";
					constPVTRow=k;
					constPVTRowExist=true;
				}
			}

			//convert groups Arraylist to Array to call combine
			//groupsArray will be the Variable array
			groups.trimToSize();
			String[] varsArray=groups.toArray(new String[groups.size()]);
			//			System.out.println();
			//			System.out.println("VARS");
			//			for(int a=0;a<varsArray.length;a++)
			//					System.out.println("["+a+"] "+varsArray[a]);
			//			//sanitize
			//			for(int vars=0;vars<varsArray.length;vars++)
			//				varsArray[vars]=varsArray[vars].trim();

			//convert getPMConstant Arraylist to Array to call combine
			//constArray will be the Variable array			
			ParametricMessage[] constArrayP=dom.getPMConstants().get(constRow).toArray(new ParametricMessage[dom.getPMConstants().get(constRow).size()]);
			String[] constArray=new String[constArrayP.length];
			for(int c=0;c<constArrayP.length;c++)
				constArray[c]=constArrayP[c].satString();

			//			System.out.println();
			//			System.out.println("CONST");
			//			for(int a=0;a<constArray.length;a++)
			//					System.out.println("["+a+"] "+constArray[a]);


			String[][] combinations=this.combine(constArray, varsArray);
			//			//sanitize
			//			for(int combs=0;combs<combinations.length;combs++)
			//				for(int combs2=0;combs2<combinations[combs].length;combs2++)
			//				combinations[combs][combs2]=combinations[combs][combs2].trim();

			//here we write
			// (or
			//  (and (assignments) (temp wrt assgnments))
			//  ...
			// )

			String currentemp="";
			//we copy temp so we don't directly modify it
//			currentemp="("+this.factvar.getName()+" "+temp+")";
			currentemp=temp;


			//			System.out.println("MSG="+currentemp);
			String toModify=currentemp;

			//			System.out.println();
			//			System.out.println("MATRIX");
			//			for(int a=0;a<combinations.length;a++)
			//				for(int b=0;b<combinations[a].length;b++)
			//					System.out.println("["+a+" "+b+"] "+combinations[a][b]);
			//			System.out.println();
			//			System.out.println("PKS");
			//			for(int a=0;a<dom.getPMConstants().get(constPKRow).size();a++)
			//					System.out.println("["+constPKRow+" "+a+"] "+((ParametricPublicKeyConstant)dom.getPMConstants().get(constPKRow).get(a)).satString());			
			//			System.out.println();


			//			boolean stopCond=false;
			ret+="(or\n";
			for(int row=0;row<combinations.length;row++){
				ret+="(and \n";
				for(int col=0;col<combinations[row].length;col++){
					ret+="(=\n"+varsArray[col]+"\n "+combinations[row][col]+"\n)\n";
					//we search for the public key of the agent (constant)
					if(constPKRowExist)
						for(int pk=0;pk<dom.getPMConstants().get(constPKRow).size();pk++){

							//						System.out.println("TEST: "+((ParametricPublicKeyConstant)dom.getPMConstants().get(constPKRow).get(pk)).getParametricAgent().satString()+
							//						" =? "+combinations[row][col]);
							if(((ParametricPublicKeyConstant)dom.getPMConstants().get(constPKRow).get(pk)).getParametricAgent().satString().
									equals(combinations[row][col])){
								//								currentemp="(IK"+RPD+" "+temp+")";

								//								DEBUG
								//								System.out.println("\n\n**********REGEX**********\n");
								//								System.out.println("VAR:"+varsArray[col]+"f");
								//								System.out.println("CONS:"+combinations[row][col]+"f");								
								//								System.out.println("STRING:"+currentemp+"f");
								//								System.out.println("NEW STRING:"+currentemp.replaceAll("\\(pk\\s*"+varsArray[col]+"\\s*\\)",combinations[row][col])+"f");
								//								System.out.println("\n\n**********REGEX**********");

								//								currentemp=currentemp.replaceAll("\\(pk\\s*"+varsArray[col]+"\\s*\\)",combinations[row][col]);
								currentemp=currentemp.replaceAll("\\(pk\\s*"+varsArray[col]+"\\s*\\)",
										((ParametricPublicKeyConstant)dom.getPMConstants().get(constPKRow).get(pk)).satString());
								//								stopCond=true;
								break;
							}
							//							if(stopCond){
							//								break;
							//							}
						}
					//we search for the private key of the agent (constant)
					if(constPVTRowExist)
						for(int pvt=0;pvt<dom.getPMConstants().get(constPVTRow).size();pvt++)
							if(((ParametricPrivateKeyConstant)dom.getPMConstants().get(constPVTRow).get(pvt)).getParametricAgent().satString().
									equals(combinations[row][col])){
								//								currentemp=currentemp.replaceAll("\\(\\s*pvt\\s*"+varsArray[col]+"\\s*\\)",combinations[row][col]);	
								currentemp=currentemp.replaceAll("\\(\\s*pvt\\s*"+varsArray[col]+"\\s*\\)",
										((ParametricPrivateKeyConstant)dom.getPMConstants().get(constPVTRow).get(pvt)).satString());}
				}
				ret+=currentemp+" )\n";
				currentemp=toModify;
			}
			ret+=")\n";
		}
		else{

			ret+="\n("+this.factvar.getName()+" "+temp+")\n";

		}




		//forall x in Var x'=x
		Iterator<Variable> iterV=dom.getDomainVars().iterator();
		while(iterV.hasNext()){
			Variable currentV=iterV.next();			
			ret+="(= "+currentV.prime()+"  "+currentV.interpolantString()+" )\n";			
		}
		Iterator<InputVariable> iterInput=dom.getDomainInputVars().iterator();
		while(iterInput.hasNext()){
			InputVariable current=iterInput.next();
			ret+="(= "+current.prime()+" "+current.interpolantString()+" )\n";
		}
		//forall m in groundMsgs IK'(m)=IK(m)
		Iterator<ParametricMessage> iterGRIK=dom.getDomain().iterator();
		while(iterGRIK.hasNext()){
			ParametricMessage currentGRIK=iterGRIK.next();
			ret+="(= (IK' "+currentGRIK.satString()+") (IK "+currentGRIK.satString()+") )\n";			
		}
		//forall f:facts forall t:tuple f(t)=f'(t)
		ret+=dom.f_eq_fp(env);

		return ret;

	}

	public String toString(){
		return this.actionString;
	}
	
	public String[][] combine(String[] constants,String[] variables){
		//we want a combination matrix that represents every possible combination
		//with repetitions
		//that has variables on columns
		//so every rows is a combination
		
		String[][] combinations;
		
		if(variables.length==1){
			combinations=new String[constants.length][1];
//			System.out.println("length="+constants.length);
			for(int i=0;i<constants.length;i++)
				combinations[i][0]=constants[i];
		}else{
			combinations=new String[this.pow(variables.length,constants.length)][variables.length];
			int z=this.pow(constants.length,variables.length);
			int index=0;
			int k=0;

			for(int j=0;j<variables.length;j++){
				z=z/variables.length;

				index=0;
				k=1;
				for(int i=0;i<this.pow(variables.length,constants.length);i++){
//					System.out.print("i="+i+"\tj="+j+"\tz="+z+"\tindex="+index+"\tk="+k);
					if(k<=z){
						k++;
					}else{ 
						if(index<constants.length-1)
							index++;
						else
							index=0;
						k=2;
					}
//					System.out.println("\t["+i+"]["+j+"]="+constants[index]);
					combinations[i][j]=constants[index];	


				}
			}
		}

		return combinations;
	}
	private int pow(int value, int power){
		if(power == 0){
			return 1;
		}

		int result = value;
		for(int i = 0; i < power -1; i++){
			result = result * value; 
		}
		return result;
	}

}