package se;

import java.util.ArrayList;

/** singleton false
 * this because we want that only one instance of this class.
 * In fact, id does not make sense to have different instances of
 * the constraint False.
 * 
 * To create an instance... or better THE instance of this class:
 * False flaseObj=False.getInstance(); OR directly False.getInstance()
 */

public class False extends StdConstraint{ 

		 
		  /**
		   * Private constructor because we want to control the creation of an instance.
		   */
		  private False() {}
		 
		  /**
		   * The TrueWrapper class is initialized at the first exection of the method getInstance()
		   * (at the very first access to TrueWrapper.TrueInstance, in a thread-safe way)
		   */
		  private static class FalseWrapper { 
		    private final static False FalseInstance = new False();
		  }
		 
		  public static False getInstance() {
		    return FalseWrapper.FalseInstance;
		  }
		  
		  public boolean equalTo(StdConstraint stdConstraint){
			  if(stdConstraint instanceof True) 
			  {return true;}
			  return false;
		  }

		  public String satPrint(Domain dom){
			  return "false \n";
		  }
		  public String satPrint(Pair<ParametricMessage, ParametricMessage> assignment,Domain dom){return "false\n";}
		  public String satPrint(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment,Domain dom){return "false\n";}
		  public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){return params;}
			public String print() {
				return "FALSE";
			}		  
			public String getConstantsFromConstraint(){return "false ";}
			public String getFunctionNameFromConstraint(){return "";}
			public String print(int i) {
				int j;
				String string="";
				for (j=0;j<i;j++){
					string = string + "\t";
				}
				return string+"FALSE";
			}
			public void createDomain(Domain domain){}
}