package se;

import java.util.ArrayList;


public class FalseConstant extends BooleanConstant{ 

	 
	  /**
	   * Private constructor because we want to control the creation of an instance.
	   */
	  private FalseConstant() {}
	 
	  /**
	   * The FalseWrapper class is initialized at the first exection of the method getInstance()
	   * (at the very first access to FalseWrapper.FalseInstance, in a thread-safe way)
	   */
	  private static class FalseConstantWrapper { 
	    private final static FalseConstant FalseConstantInstance = new FalseConstant();
		private final static ParametricFalseConstant parametricFalseConstant = ParametricFalseConstant.getInstance();
	  }
	 
	  public static FalseConstant getInstance() {
	    return FalseConstantWrapper.FalseConstantInstance;
	  }
	  
	  public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){return this;}
	  
	  public String interpolantString(Environment env){
		  return "false";
	  }
	  public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment) {
		  return "false";
	  }
	  public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		  return "false";
	  }
	  
	  public ParametricMessage eval4Domain(){return null;}

	  public ParametricFalseConstant eval(Environment env) {
		  return FalseConstantWrapper.parametricFalseConstant;
	  }
	  
		public String print() {
			return "FALSE_Constant";
		}		  	  
	  
}