package se;

import java.util.ArrayList;
import java.util.Iterator;

public class GenericVariable extends GenericMessage implements Variable{
	private GenericMessageParameter fakeParam=new GenericMessageParameter();
	public GenericVariable(){
		Message.addVar2VariablesList(interpolantString());
	}
	
	public GenericVariable(String messageString){
		this();
		this.messageString = messageString;
	}
	public Message getAnotherOfTheSameType(String name){
		return new GenericVariable(name);
	}
	
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		for(int i=0;i<mex_newMex.size();i++){
			if(mex_newMex.get(i).getElement0().equals(this))
				return mex_newMex.get(i).getElement1();
		}
		return this;
	}
	/**
	 * Evaluation of a GenericVariable.
	 * It takes a NonceVariable and returns the corresponding value (a ParametricGenericMessage)
	 * 
	 * we create an iterator on the environment set env
	 * then we search in env if there's the GenericVariable we're searching for 
	 * if so, we returns it's associated value (env is a set of pairs (variable,value))
	 * otherwise we're tring to evaluate a variable that is not present in env
	 * then the iterator points to null and we catch the exception
	 */
	public ParametricMessage eval4Domain(Environment env){return this.getFakeParam();}
	public GenericParameter eval(Environment env) {
		DataState ds;
		Iterator<DataState> iter = env.iterator();
		
		try{
			if(env.isEmpty()){
				throw new NullPointerException("You are tring to evaluate an object GenericVariable on an empty Environment");
			}else{
				while (iter.hasNext()){
		
					ds = iter.next();
					if (ds.getVariable() == this){
						//return (ParametricGenericMessage)(ds.getValue());}				
						return (GenericParameter)(ds.getValue());}
				}
			}
		}catch(NullPointerException e){
			e.printStackTrace();
			System.exit(0);
		}
		
		//this return makes the compiler happy :) and this is its only purpose
		return null;
	}

	
	public Variable getDataState(Environment env){return this;}

	private int uid=getNewUID();
	private String name="GenericVariable"+this.getUID();
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	
	public String print() {
		return this.getName();
	}

	public String print(int i) {
		int j;
		String string="";
		for (j=0;j<i;j++){
			string = string + "\t";
		}
		return string+this.hashCode();
	}
	public String prime(){
		Message.addVar2VariablesList("GV'"+getUID());
		return "GV'"+getUID();		
	}
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){
		for(int i=0;i<list.size();i++)
			if(list.get(i).get(0).getClass().equals(this.getClass())){
				list.get(i).add(this);
				return list;
			}
				
		ArrayList<Message> tmp=new ArrayList<Message>();
		tmp.add(this);
		list.add(tmp);
		return list;
	}
	
	public ParametricMessage getFakeParam(){
		return this.fakeParam;
	}
	
	//interpolant Strings
	public String interpolantString(Environment env){
		return "GV"+getUID();
	}
	public String interpolantString(){
		return "GV"+getUID();
	}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		
		if(assignment.getElement0().interpolantString(env).equals(this.interpolantString(env))){
			return assignment.getElement1().satString();
		}
		
		return this.interpolantString(env);
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment){
		
		for(int i=0;i<assignment.size();i++){
			if(assignment.get(i).getElement0().interpolantString(env).equals(this.interpolantString(env))){
				return assignment.get(i).getElement1().satString();
			}
		}
		
		return this.interpolantString(env);
	}
	
	public String toString(){
		return this.messageString;
	}
}