package se;
import java.util.ArrayList;
import java.util.Iterator;

public class IKConstraint extends Constraint{ 
	
	private ParametricMessageSet ik;
	private ParametricMessage message;
	
	public IKConstraint(ParametricMessageSet ik,ParametricMessage message){
		this.setIK(ik);
		this.setMessage(message);
	}
	
	//public String getConstantsFromConstraint(){return "";}
	public String getFunctionNameFromConstraint(){return "";}
	public ParametricMessageSet getIK(){return this.ik;};
	public ParametricMessage getMessage(){return this.message;};
	public void setIK(ParametricMessageSet ik){this.ik=ik;}
	public void setMessage(ParametricMessage message){this.message=message;}

	
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		return ik.getParameters(this.message.getParameters(params));
	}
	
	// converts this IKConstraint into a StdConstraint
	public StdConstraint standardize() {
		
		//IKSet ikS = new IKSet(this.ik);
		//(DEBUG) System.out.println("IKSet before closure");
		//(DEBUG) ikS.printElements();
		//ikS.closure();
		//(DEBUG) System.out.println("IKSet after closure");
		//(DEBUG) ikS.printElements();
		//return this.message.getStdConstraint(ikS);
//		System.out.println("BEFORE "+this.print());
//		Iterator<ParametricMessage> iter=this.ik.iterator();
//		while(iter.hasNext()){System.out.println(iter.next().satString());}
		
		IKStdConstraint ikstdconstraint=new IKStdConstraint(this);
		//System.out.println("AFTER "+ikstdconstraint.print());
		return ikstdconstraint;
	}
	
	/*
	public String fociPrint(StdConstraintSet cs,String[] constansSet){
		return "= "+this.getIK().hashCode()+" "+this.getMessage().hashCode();
	}
	*/
	public String print() {
		return "IKConstraint "+this.hashCode()+" : IK="+getIK().hashCode()+" , message="+getMessage().print();
	}
	
	public String print(int i) {
//		int j;
String string="";
//		for (j=0;j<i;j++){
//			string = string + "\t";
//		}
		return string+"IKConstraint "+this.hashCode()+" : IK="+getIK().hashCode()+" , message="+getMessage().print();
	}
	
}
