package se;

import java.util.ArrayList;
import java.util.Iterator;

/** singleton IKVariable
 * this because we want that only one instance of this class.
 * 
 * To create an instance... or better THE instance of this class:
 * IKVariable IKVariableInstance=IKVariable.getInstance(); OR directly IKVariable.getInstance()
 */

public class IKVariable implements Variable{ 
	public ParametricMessage eval4Domain(Environment env){return this.getFakeParam();}
	  /**
	   * Private constructor because we want to control the creation of an instance.
	   */
	  private IKVariable() {}
	 
	  /**
	   * The IKVariableWrapper class is initialized at the first execution of the method getInstance()
	   * (at the very first access to IKVariablWrapper.IKVariableInstance, in a thread-safe way)
	   */
	  private static class IKVariableWrapper { 
	    private final static IKVariable IKVariableInstance = new IKVariable();
	  }
	 
	  public static IKVariable getInstance() {
	    return IKVariableWrapper.IKVariableInstance;
	  }
	  public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){return this;}

	  public Variable getDataState(Environment env){return this;}
	  public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		  ArrayList<Pair<Message,ParametricMessage>> ass=new ArrayList<Pair<Message,ParametricMessage>>();
		  ass.add(assignment);
		  return this.interpolantString(env,ass);
	  }
	/** the DataState that contains IKVarible is a pair (IKVarible,MessageSet).
	 * In MessageSet there's the method eval that returns a ParametricMessageSet.
	 * That's why the method eval implemented below search for IKVar in the environment and cast the return
	 * of the eval of the getValue to ParametricMessageSet.
	 */
	public ParametricMessageSet eval(Environment env){
		
		DataState ds;
//		ParametricMessageSet pms;
		
		Iterator<DataState> iter = env.iterator();
		ParametricMessageSet newpms=new ParametricMessageSet();
		while (iter.hasNext()){
			ds = iter.next();
			if (ds.getVariable() == this) {
				Iterator<ParametricMessage> iterPM = ((ParametricMessageSet)ds.getValue()).iterator();
				while (iterPM.hasNext())
					newpms.add(iterPM.next());
				return newpms;
			}
		}
		/*
		Iterator<DataState> iter = env.iterator();
		while (iter.hasNext()){
			ds = iter.next();
			if (ds.getVariable() == this) 
				return (ParametricMessageSet)(ds.getValue());				
		}*/
		return null;	
		
	}
	
//	public MessageSet getElements(){
//		
//		
//		
//		return null;
//	}
	
	//the following methods aren't used. 
	private int uid=640;
	private String name="IKVariable";
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	
	public String interpolantString(){
		return "IK";
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment) {
		return this.interpolantString(env);
	}
	public String interpolantString(Environment env){
		return "IK";
	}
	
	public String print() {
		return this.getName();
	}

	public String prime(){
		Message.addVar2VariablesList("IK'");
		return "IK'";
	}
	
	public ParametricMessage getFakeParam(){
		System.out.println("WARNING - ik variables do not have a corresponding parameter");
		System.exit(0);
		return null;
	}
	
}