package se;

import java.util.ArrayList;
	
	// represents input variables determining intruder choices inside a single session
public class InputChoiceIntruderVariable extends InputIntruderVariable {

	public InputChoiceIntruderVariable() {
		Message.addVar2VariablesList("ICIV"+getUID());
		Message.addVar2VariablesList("ICIV'"+getUID());
		parameter = new ChoiceParameter();
	}
	
	public InputChoiceIntruderVariable(String messageString){
		this();
		this.messageString = messageString;
	}
	
	public ParametricMessage getFakeParam(){
		System.out.println("WARNING - input intruder variables cannot be added to the domain");
		return null;
	}
	public ChoiceParameter eval(Environment env){
		return (ChoiceParameter)(super.eval(env));	
	}
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		return this;
	}
	public Variable getDataState(Environment env){return this;}
	
	public String print() {
		return this.getName()+" (with Parameter "+parameter.print()+")";
	}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		
		if(assignment.getElement0().interpolantString(env).equals(this.interpolantString(env))){
			return assignment.getElement1().satString();
		}
		
		return this.interpolantString(env);
	}
	private int uid=100;
	private String name="InputChoiceIntruderVariable"+this.getUID();
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	
	public String interpolantString(){
		return "ICIV"+getUID();
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment) {
		return this.interpolantString(env);
	}
	public String interpolantString(Environment env){
		return "ICIV"+getUID();
	}
	public String prime(){
		Message.addVar2VariablesList("ICIV'"+getUID());
		return "ICIV'"+getUID();		
	}
	
	public String toString(){
		return this.messageString;
	}
}