package se;

import java.util.ArrayList;

public class InputGenericVariable extends GenericMessage implements InputVariable {

	GenericMessageParameter genericParameter;
	
	public InputGenericVariable() {
		Message.addVar2VariablesList(this.interpolantString());
		Message.addVar2VariablesList("IGV'"+getUID());
		genericParameter = new GenericMessageParameter();
	}
	
	public InputGenericVariable(String messageString){
		this();
		this.messageString = messageString;
	}
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		for(int i=0;i<mex_newMex.size();i++){
			if(mex_newMex.get(i).getElement0().equals(this))
				return mex_newMex.get(i).getElement1();
		}
		return this;
	}
	public ParametricMessage eval4Domain(Environment env){return this.getFakeParam();}
	public GenericMessageParameter eval(Environment env) {
		return genericParameter;
	}

	public ParametricMessage getFakeParam(){
		return this.genericParameter;
	}
	public Variable getDataState(Environment env){return this;}
	
	public String print() {
		return this.getName()+" (with GenericMessageParameter "+genericParameter.print()+")";
	}

	private int uid=getNewUID();
	private String name="InputGenericVariable"+this.getUID();
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	
	
	public String prime(){
		Message.addVar2VariablesList("IGV'"+getUID());
		return "IGV'"+getUID();		
	}
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){
		for(int i=0;i<list.size();i++)
			if(list.get(i).get(0).getClass().equals(this.getClass())){
				list.get(i).add(this);
				return list;
			}
				
		ArrayList<Message> tmp=new ArrayList<Message>();
		tmp.add(this);
		list.add(tmp);
		return list;
	}
	
	public Message getAnotherOfTheSameType(String name){
		return new InputGenericVariable(name);
	}
	
	//interpolant strings
	public String interpolantString(Environment env){return "IGV"+getUID();}
	public String interpolantString(){return "IGV"+getUID();}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		
		if(assignment.getElement0().interpolantString(env).equals(this.interpolantString(env))){
			return assignment.getElement1().satString();
		}
		
		return this.interpolantString(env);
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment){
		
		for(int i=0;i<assignment.size();i++){
			if(assignment.get(i).getElement0().interpolantString(env).equals(this.interpolantString(env))){
				return assignment.get(i).getElement1().satString();
			}
		}
		
		return this.interpolantString(env);
	}
	
	public String toString(){
		return this.messageString;
	}
}