package se;

import java.util.ArrayList;

public class InputNonceVariable extends Nonce implements InputVariable {

	NonceParameter nonceParameter;
	
	public InputNonceVariable() {
		Message.addVar2VariablesList(this.interpolantString());
		Message.addVar2VariablesList("INV'"+getUID());
		nonceParameter = new NonceParameter();
	} 

	public InputNonceVariable(String messageString){
		this();
		this.messageString = messageString;
	}
	
	public NonceParameter eval(Environment env) {
		return nonceParameter;
	}
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
//		System.out.print("subs in InputNonceVar "+this.messageString+ "-> ");
		for(int i=0;i<mex_newMex.size();i++){
			if(mex_newMex.get(i).getElement0().equals(this)){
//				System.out.println(mex_newMex.get(i).getElement1().toString()+" FOUND! :) ");
				return mex_newMex.get(i).getElement1();
			}
		}
		return this;
	}
	public Message getAnotherOfTheSameType(String name){
		return new InputNonceVariable(name);
	}
	
	public Variable getDataState(Environment env){return this;}
	
	public String print() {
		return this.getName()+" (with NonceParameter "+nonceParameter.print()+")";
	}

	public ParametricMessage getFakeParam(){
		return this.nonceParameter;
	}
	public ParametricMessage eval4Domain(Environment env){return this.getFakeParam();}
	private int uid=getNewUID();
	private String name="InputNonceVariable"+this.getUID();
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	

//	public void add2Domain(Domain domain){domain.add(this);}
//	public void add2Domain(Domain domain,IKStdConstraint ik){domain.add(this,ik);}
	public String prime(){
		Message.addVar2VariablesList("INV'"+getUID());
		return "INV'"+getUID();		
	}
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){
		for(int i=0;i<list.size();i++)
			if(list.get(i).get(0).getClass().equals(this.getClass())){
				list.get(i).add(this);
				return list;
			}
				
		ArrayList<Message> tmp=new ArrayList<Message>();
		tmp.add(this);
		list.add(tmp);
		return list;
	}
	
	//interpolant strings
	public String interpolantString(Environment env){return "INV"+getUID();}
	public String interpolantString(){return "INV"+getUID();}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		
		if(assignment.getElement0().interpolantString(env).equals(this.interpolantString(env))){
			return assignment.getElement1().satString();
		}
		
		return this.interpolantString(env);
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment){
		
		for(int i=0;i<assignment.size();i++){
			if(assignment.get(i).getElement0().interpolantString(env).equals(this.interpolantString(env))){
				return assignment.get(i).getElement1().satString();
			}
		}
		
		return this.interpolantString(env);
	}
	
	public String toString(){
		return this.messageString;
	}
}