package se;

import java.util.ArrayList;
	
	// represents input variables determining how to switch between sessions
public class InputSwitchIntruderVariable extends InputIntruderVariable {

	public InputSwitchIntruderVariable() {
		Message.addVar2VariablesList("ISIV"+getUID());
		Message.addVar2VariablesList("ISIV'"+getUID());
		parameter = new SwitchParameter();
	}
	
	public InputSwitchIntruderVariable(String messageString){
		this();
		this.messageString = messageString;
	}
	
	public ParametricMessage getFakeParam(){
		System.out.println("WARNING - input intruder variables cannot be added to the domain");
		return null;
	}
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		return this;
	}
	public SwitchParameter eval(Environment env){
		return (SwitchParameter)(super.eval(env));	
	}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		
		if(assignment.getElement0().interpolantString(env).equals(this.interpolantString(env))){
			return assignment.getElement1().satString();
		}
		
		return this.interpolantString(env);
	}
	public Variable getDataState(Environment env){return this;}
	
	public String print() {
		return this.getName()+" (with Parameter "+parameter.print()+")";
	}
	
	private int uid=31415;
	private String name="InputSwitchIntruderVariable"+this.getUID();
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	
	public String interpolantString(){
		return "ISIV"+getUID();
	}
	public String interpolantString(Environment env){
		return "ISIV"+getUID();
	}
	public String prime(){
		Message.addVar2VariablesList("ISIV'"+getUID());
		return "ISIV'"+getUID();		
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment) {
		return this.interpolantString(env);
	}
	
	public String toString(){
		return this.messageString;
	}
}
