package se;

import java.util.ArrayList;

public class InputSymKeyVariable extends SymKey implements InputVariable {

	SymKeyParameter symKeyParameter;
	
	public InputSymKeyVariable() {
		Message.addVar2VariablesList(this.interpolantString());
		Message.addVar2VariablesList("ISKV'"+getUID());
		symKeyParameter = new SymKeyParameter();
	} 
	
	public InputSymKeyVariable(String messageString){
		this();
		this.messageString = messageString;
	}

	public Message getAnotherOfTheSameType(String name){
		return new InputSymKeyVariable(name);
	}
	
	public SymKeyParameter eval(Environment env) {
		return symKeyParameter;
	}
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		for(int i=0;i<mex_newMex.size();i++){
			if(mex_newMex.get(i).getElement0().equals(this))
				return mex_newMex.get(i).getElement1();
		}
		return this;
	}
	public Variable getDataState(Environment env){return this;}
	
	public String print() {
		return this.getName()+" (with SymKeyParameter "+symKeyParameter.print()+")";
	}
	public ParametricMessage getFakeParam(){
		return this.symKeyParameter;
	}
	public ParametricMessage eval4Domain(Environment env){return this.getFakeParam();}
	private int uid=getNewUID();
	private String name="InputSymKeyVariable"+this.getUID();
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	

	public String prime(){
		Message.addVar2VariablesList("ISKV'"+getUID());
		return "ISKV'"+getUID();		
	}
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){
		for(int i=0;i<list.size();i++)
			if(list.get(i).get(0).getClass().equals(this.getClass())){
				list.get(i).add(this);
				return list;
			}
				
		ArrayList<Message> tmp=new ArrayList<Message>();
		tmp.add(this);
		list.add(tmp);
		return list;
	}
	
	
	//interpolant strings
	public String interpolantString(Environment env){return "ISKV"+getUID();}
	public String interpolantString(){return "ISKV"+getUID();}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		
		if(assignment.getElement0().interpolantString(env).equals(this.interpolantString(env))){
			return assignment.getElement1().satString();
		}
		
		return this.interpolantString(env);
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment){
		
		for(int i=0;i<assignment.size();i++){
			if(assignment.get(i).getElement0().interpolantString(env).equals(this.interpolantString(env))){
				return assignment.get(i).getElement1().satString();
			}
		}
		
		return this.interpolantString(env);
	}
	
	public String toString(){
		return this.messageString;
	}
}