package se;
import org.jgrapht.*;
import org.jgrapht.graph.*;
import java.util.regex.Pattern;
import java.util.regex.Matcher;

public class Location implements Annotable {
	
	private Formula annotation;
	String name;

    public Location(String name){
        this.annotation = new FalseFormula();
        this.name = name;
    }
	
	public Formula getAnnotation(){
		return annotation;
	}
	
	public void setAnnotation(Formula formula){ 
		this.annotation = formula;
	}	
	
	public boolean isGoal(){
		return false;
	}
	
	public String print(){
		return ""+this.name;
	}
	
	public String getPrimedAnnotation(){
		
		String stringAnnotation=this.getAnnotation().translate();
		
		stringAnnotation=stringAnnotation.replaceAll("AV", "AV'");
		stringAnnotation=stringAnnotation.replaceAll("SKV", "SKV'");
		stringAnnotation=stringAnnotation.replaceAll("NV", "NV'");
		stringAnnotation=stringAnnotation.replaceAll("GV", "GV'");
		//stringAnnotation=stringAnnotation.replaceAll("IAV", "IAV'"); --> part of AV regex
		stringAnnotation=stringAnnotation.replaceAll("ICIV", "ICIV'");
		//stringAnnotation=stringAnnotation.replaceAll("INV", "INV'"); --> part of NV regex
		stringAnnotation=stringAnnotation.replaceAll("ISIV", "ISIV'");
		stringAnnotation=stringAnnotation.replaceAll("IK", "IK'");
		
		//add primed vars to Message.varList
		Pattern pattern=Pattern.compile("AV'\\d+|SKV'\\d+|NV'\\d+|GV'\\d+|IAV'\\d+|ICIV'\\d+|INV'\\d+ISIV'\\d+|IK'\\d+");
		Matcher matcher=pattern.matcher(stringAnnotation);
		
		while (matcher.find()) {
			if(!matcher.group().isEmpty()){
//			System.out.println("group "+matcher.group());
//			System.out.print(" start "+matcher.start());
//			System.out.print(" end "+matcher.end());
			Message.addVar2VariablesList(matcher.group());
			}
		}
		
		return stringAnnotation;
	}
	
	/*main just for testing
	public static void main(String[] args){
		Formula formula=new Formula();
		formula.setTranslatedFormula("(and (AV123 1) (NV88 2) (AV55 3) (IAV76 8))");
		
		Location test=new Location();
		test.setAnnotation(formula);
		
		test.getPrimedAnnotation();
		
	}*/
}
