package se;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;

public class MessageSet extends HashSet<Message> implements Evaluable {

	public ParametricMessageSet eval(Environment env){
		ParametricMessageSet set = new ParametricMessageSet();
		Iterator<Message> iterator = this.iterator();		
		while (iterator.hasNext()){
			set.add((iterator.next()).eval(env));
		}
		return set;
	}
	public String interpolantString(Environment env){
		return "MSGSET";
	}
	
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		MessageSet newmsgset=new MessageSet();
		Iterator<Message> iter=this.iterator();
		while(iter.hasNext()){
			Message current=iter.next();
			newmsgset.add((Message)current.substitute(mex_newMex));
		}
			
		return newmsgset;
	}
	
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment) {
		return this.interpolantString(env);
	}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		ArrayList<Pair<Message,ParametricMessage>> ass=new ArrayList<Pair<Message,ParametricMessage>>();
		ass.add(assignment);
		return this.interpolantString(env,ass);
	}
	public String print() {
		int i=0;
		String string="MessageSet "+this.hashCode() + " with elements:";
		Iterator<Message> iterator = this.iterator();		
		while (iterator.hasNext()){
			i++;
			string = string+System.getProperty("line.separator")+"   "+i+". "+iterator.next().print();
		}
//		string = string +System.getProperty("line.separator");
		return string;
	}
	
	public String toString() {
		int i=0;
		String string="{";
		Iterator<Message> iterator = this.iterator();		
		while (iterator.hasNext()){
			i++;
			if(i==1) string = string + iterator.next().toString();
			else string = string + ", " + iterator.next().toString();
		}
		string = string + "}";
		return string;
	}
}
