package se;

import java.util.ArrayList;

public class NonceConstant extends Nonce implements Constant {

	private ParametricNonceConstant constant;

	public NonceConstant() {
		constant = new ParametricNonceConstant();
	}	
	
	public NonceConstant(String messageString) {
		this();
		this.messageString = messageString;
	}
	
	public ParametricMessage eval4Domain(){return this.constant;}

	public ParametricNonceConstant getParametricNonceConstant(){
		return constant;
	}
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		for(int i=0;i<mex_newMex.size();i++){
			if(mex_newMex.get(i).getElement0().equals(this))
				return mex_newMex.get(i).getElement1();
		}
		return this;
	}
	public Message getAnotherOfTheSameType(String name){
		return new NonceConstant(name);
	}
	
	public ParametricNonceConstant eval(Environment env) {
		return constant;
	}
	
	public String print() {
		return "NonceConstant "+this.hashCode() + " (with ParametricNonceConstant " + this.constant.print();
	}		
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){
		return list;
	}
	
	//interpolantString
	public String interpolantString(Environment env){
		return this.constant.satString();
	}
	
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		return this.constant.satString();
	}
	
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment){
		return this.constant.satString();
	}
	
	public String toString(){
		return this.messageString;
	}
}
