package se;

import java.util.*;

public class NonceVariable extends Nonce implements Variable {
	private NonceParameter fakeParam=new NonceParameter();
	public NonceVariable(){
		Message.addVar2VariablesList(interpolantString());
	}
	
	public NonceVariable(String messageString){
		this();
		this.messageString = messageString;
	}
	
	private int uid=getNewUID();
	private String name="NonceVariable"+this.getUID();
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}

	public Message getAnotherOfTheSameType(String name){
		return new NonceVariable(name);
	}
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
//		System.out.print("subs in nonceVar "+this.messageString+ "-> ");
		
		for(int i=0;i<mex_newMex.size();i++){
			if(mex_newMex.get(i).getElement0().equals(this)){
//				System.out.println(mex_newMex.get(i).getElement1().toString()+" FOUND! :) ");
				return mex_newMex.get(i).getElement1();
			}
		}
//		System.out.println("NOT FOUND :( ");
		return this;
	}
	public ParametricMessage eval4Domain(Environment env){return this.getFakeParam();}
	public String print() {
		return this.getName();
	}

	/**
	 * Evaluation of a parametric Nonce.
	 * It takes a NonceVariable and returns the corresponding value (a parametricNonce)
	 * 
	 * we create an iterator on the environment set env
	 * then we search in env if there's the nonceVariable we're searching for 
	 * if so, we returns it's associated value (env is a set of pairs (variable,value))
	 * otherwise we're tring to evaluate a variable that is not present in env
	 * then the iterator points to null and we catch the exception
	 */
	public ParametricNonce eval(Environment env) {
		DataState ds;
		Iterator<DataState> iter = env.iterator();
		
		try{
			if(env.isEmpty()){
				throw new NullPointerException("You are tring to evaluate an object NonceVariable on an empty Environment");
			}else{
				while (iter.hasNext()){
		
					ds = iter.next();
					if (ds.getVariable() == this){
						return (ParametricNonce)(ds.getValue());
						}				
				}
			}
		}catch(NullPointerException e){
			e.printStackTrace();
			System.exit(0);
		}
		System.out.println("ERROR, a Nonce is NULL :( "+this.interpolantString());
		//this return makes the compiler happy :) and this is its only purpose
		return null;
	}

	public Variable getDataState(Environment env){return this;}
	
	public String prime(){
		Message.addVar2VariablesList("NV'"+getUID());
		return "NV'"+getUID();
	}
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){
		for(int i=0;i<list.size();i++)
			if(list.get(i).get(0).getClass().equals(this.getClass())){
				list.get(i).add(this);
				return list;
			}
				
		ArrayList<Message> tmp=new ArrayList<Message>();
		tmp.add(this);
		list.add(tmp);
		return list;
	}
	public ParametricMessage getFakeParam(){
		return this.fakeParam;
	}
	
	//inerpolant Strings
	public String interpolantString(Environment env){
		return "NV"+getUID();
	}
	public String interpolantString(){
		return "NV"+getUID();
	}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		
		if(assignment.getElement0().interpolantString(env).equals(this.interpolantString(env))){
			return assignment.getElement1().satString();
		}
		
		return this.interpolantString(env);
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment){
		
		for(int i=0;i<assignment.size();i++){
			if(assignment.get(i).getElement0().interpolantString(env).equals(this.interpolantString(env))){
				return assignment.get(i).getElement1().satString();
			}
		}
		
		return this.interpolantString(env);
	}
	
	public String toString(){
		return this.messageString;
	}
}
