package se;
import java.util.*; 

public abstract class OPConstraint extends StdConstraint{
	private Value lhs;
	private Value rhs;
	
	public OPConstraint(Value lhs,Value rhs){
		this.setLhs(lhs);
		this.setRhs(rhs);
	}
	
	//make the compiler happy with factsConstraint :)
	public OPConstraint(){}
	
	public String getConstantsFromConstraint(){
		return this.getLhs().satString()+" "+this.getRhs().satString();
	}
	
	public Value getLhs(){return this.lhs;}
	public Value getRhs(){return this.rhs;}
	public void setLhs(Value lhs){this.lhs=lhs;}
	public void setRhs(Value rhs){this.rhs=rhs;}
	
	public boolean equalTo(StdConstraint stdConstraint){ 
		boolean lhsEvaluation=false;
		boolean rhsEvaluation=false;
		
		if(stdConstraint instanceof OPConstraint){
			if((this.getLhs() instanceof ParametricFunction) &&
					(((OPConstraint)stdConstraint).getLhs() instanceof ParametricFunction) &&
					(((ParametricFunction)(this.getLhs())).getFunctionName().equals(((ParametricFunction)(((OPConstraint)stdConstraint).getLhs())).getFunctionName()))){				
				String[] paramsArrayFunction1=((ParametricFunction)(this.getLhs())).satString().split(" ");
				String[] paramsArrayFunction2=((ParametricFunction)(((OPConstraint)stdConstraint).getLhs())).satString().split(" ");
				for(int j=0;j<paramsArrayFunction1.length;j++)					
						if(paramsArrayFunction1[j]!=paramsArrayFunction1[j])
							return false;
					
				lhsEvaluation=true;
			}else if(this.getLhs()==((OPConstraint)stdConstraint).getLhs()){
				lhsEvaluation=true;
			}

			if(this.getRhs() instanceof ParametricFunction &&
					((OPConstraint)stdConstraint).getRhs() instanceof ParametricFunction){
				String[] paramsArrayFunction1=((ParametricFunction)(this.getRhs())).satString().split(" ");
				String[] paramsArrayFunction2=((ParametricFunction)(((OPConstraint)stdConstraint).getRhs())).satString().split(" ");
				for(int j=0;j<paramsArrayFunction1.length;j++)
					
						if(paramsArrayFunction1[j]!=paramsArrayFunction1[j])
							return false;
					
				rhsEvaluation=true;
			}else if(this.getRhs()==((OPConstraint)stdConstraint).getRhs()){
				rhsEvaluation=true;
			}
			
			if(lhsEvaluation && rhsEvaluation)
				return true;
			else
				return false;
		}
		 return false;
	}
	
	public void createDomain(Domain domain){
//		this.getLhs().add2Domain(domain);						
//		this.getRhs().add2Domain(domain);	
	}
	
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		return this.rhs.getParameters(this.lhs.getParameters(params));
	}
	
}
