package se;


public abstract class ParametricAgent extends ParametricMessage{

	protected ParametricPublicKey publicKey;
	protected ParametricPrivateKey privateKey;
	
	public ParametricAgent(){
		this.publicKey=new ParametricPublicKey(this);
		this.privateKey=new ParametricPrivateKey(this);
	}
	
	public ParametricPublicKey getPublicKey(){
		return publicKey;		
	}

	public ParametricPrivateKey getPrivateKey(){
		return privateKey;		
	}	
	
	// returns the constraint obtained by trying to let this parametric message
	// match with m (no matter which IKSet is being considered)
	public StdConstraint matches(ParametricMessage m){
		if (m instanceof ParametricAgent){
			return new EqOPConstraint(m,this);
		}
		else
			return False.getInstance();			
	}
	
}
