package se;

import java.util.ArrayList;

public class ParametricAgentConstant extends ParametricAgent implements ParametricConstant {
	
	private int uid=getNewUID();
	private String name="ParametricAgentConstant"+this.getUID();
	
	
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	
	public String print() {
		return this.getName();
	}
	public String getConstant(){
		return this.satString();
	}
	public String print(int i) {
		int j;
		String string="";
		for (j=0;j<i;j++){
			string = string + "\t";
		}
		return string+this.getName();
	}
	public void add2Domain(Domain domain){domain.add(this);}
	public void add2Domain(Domain domain,IKStdConstraint ik){domain.add(this,ik);}
	
	private ParametricPublicKeyConstant publicKey;
	private ParametricPrivateKeyConstant privateKey;
	
	public ParametricAgentConstant(){
		this.publicKey=new ParametricPublicKeyConstant(this);
		this.privateKey=new ParametricPrivateKeyConstant(this);
	}
	
	public ParametricPublicKeyConstant getPublicKey(){
		return this.publicKey;		
	}

	public ParametricPrivateKeyConstant getPrivateKey(){
		return this.privateKey;		
	}	
	
	//is the following method useful? 
	public ArrayList<ParametricMessage> getPvtKey(ArrayList<ParametricMessage> pm_list){return pm_list;}
	
	public ArrayList<ParametricMessage> Msg2List(ArrayList<ParametricMessage> list,ParametricEncryptedMessage enc,ParametricConcatenatedMessage pair,ParametricSymEncryptedMessage scrypt){
		list.add(this);
		return list;
	}
	public Pair<Boolean,ArrayList<ParametricMessage[]>> compare(ParametricMessage m,ArrayList<ParametricMessage[]> l){
//		System.out.println(this.satString()+" =? "+m.satString());
//		System.out.println(this.equals(m));
		if(this.equals(m)){			
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(true,l);
		}else{
			//they're not equal
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(false,null);
		}
	}
	public boolean equals(ParametricMessage pm){
		if(pm==null){return false;}
		if(pm==this){return true;}
		if(!pm.getClass().equals(ParametricAgentConstant.class)){return false;}
		else if(this.satString().equals(((ParametricAgentConstant)pm).satString())){return true;}
		
		return false;
	}

	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		return params;
	}
	
	//sat strings
	public String satString(){
		return ""+getUID();
	}
	public String satString(Pair<ParametricMessage, ParametricMessage> assignment){
		return ""+getUID();	
	}
	public String satString(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment){
		return ""+getUID();
	}
}
