package se;

import java.util.ArrayList;

public class ParametricConcatenatedMessage extends ParametricMessage{
	private int uid=getNewUID();
	private String name="ParametricConcatenatedMessage"+this.getUID();
	private ParametricMessage message1;
	private ParametricMessage message2;
	
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	

	
	public String print() {
		return this.getName()+": {"+this.message1.print()+ "}{" + this.message2.print()+"}";
	}
	
	public String print(int i) {
		return "error: called print(int) in ParametricConcatenatedMessage";
	}
	
	public ParametricConcatenatedMessage(){} // method used only for Domain construction
	public ParametricConcatenatedMessage(ParametricMessage message1, ParametricMessage message2){
		this.setFirst(message1);
		this.setSecond(message2);
	}

	public ParametricMessage getFirst(){return this.message1;}
	public ParametricMessage getSecond(){return this.message2;}
	public void setFirst(ParametricMessage message1){this.message1=message1;}
	public void setSecond(ParametricMessage message2){this.message2=message2;}
	
	public String getConstant(){
		return this.getFirst().getConstant()+" "+this.getSecond().getConstant();
	}
	
	public int getNumberOfArgs(){return this.message1.getNumberOfArgs()+this.message2.getNumberOfArgs();}

	public ArrayList<ParametricMessage> getPvtKey(ArrayList<ParametricMessage> pm_list){
		ArrayList<ParametricMessage> new_list=new ArrayList<ParametricMessage>();
		pm_list.addAll(message1.getPvtKey(new_list));
		pm_list.addAll(message2.getPvtKey(new_list));
		return pm_list;		
	}
	public void add2Domain(Domain domain){
		domain.add(this);
		this.message1.add2Domain(domain);
		this.message2.add2Domain(domain);
	}
	public void add2Domain(Domain domain,IKStdConstraint ik){
		domain.add(this,ik);
		this.message1.add2Domain(domain,ik);
		this.message2.add2Domain(domain,ik);
	}
	
	public ArrayList<ParametricMessage> Msg2List(ArrayList<ParametricMessage> list,ParametricEncryptedMessage enc,ParametricConcatenatedMessage pair,ParametricSymEncryptedMessage scrypt){
		list.add(pair);
		this.getFirst().Msg2List(list, enc, pair, scrypt);
		this.getSecond().Msg2List(list, enc, pair, scrypt);
		return list;
	}
	public Pair<Boolean,ArrayList<ParametricMessage[]>> compare(ParametricMessage m,ArrayList<ParametricMessage[]> l){
		//System.out.println(this.satString()+" ?= "+m.satString());
		if(m.getClass().equals(ParametricConcatenatedMessage.class)){
			//System.out.println("both pair");
			//they're similar
			//check its parts
			Pair<Boolean, ArrayList<ParametricMessage[]>> res=this.getFirst().compare(((ParametricConcatenatedMessage) m).getFirst(), l);
			//System.out.println("its parts are:");
			//System.out.println("PAIR "+this.getFirst().satString()+" ?= "+((ParametricConcatenatedMessage) m).getFirst().satString());
			//System.out.println("PAIR "+res.getElement0());
			if(res.getElement0())
				res=this.getSecond().compare(((ParametricConcatenatedMessage) m).getSecond(), res.getElement1());
			//System.out.println("PAIR "+this.getSecond().satString()+" ?= "+((ParametricConcatenatedMessage) m).getSecond().satString());
			//System.out.println("PAIR "+res.getElement0());
			return res;			
		}else{
			//they're not equal
			//System.out.println("NO");
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(false,null);
		}
	}
	public boolean equals(Object pm){
		boolean ret=false;
		if(pm==null){return false;}
		if(pm==this){return true;}
		
		if(pm.getClass().equals(ParametricConcatenatedMessage.class)){
//			System.out.println("in enc "+this.satString()+" ?= "+((ParametricConcatenatedMessage)pm).satString());
//			System.out.println("SAME type");
			if(this.getFirst().equals(((ParametricConcatenatedMessage)pm).getFirst()) &&
					this.getSecond().equals(((ParametricConcatenatedMessage)pm).getSecond())){
//				System.out.println("same parts");
				ret=true;
			}else{
//				System.out.println("uno:"+this.getFirst().hashCode()+" != "+((ParametricConcatenatedMessage)pm).getFirst().satString());
//				System.out.println("due:"+this.getSecond().hashCode()+" != "+((ParametricConcatenatedMessage)pm).getSecond().satString());
//				System.out.println("different parts");
			}
		}
		return ret;
	}
	
	public boolean sameEquivalenceClass(ParametricMessage pm){
		
		if(this.getClass().equals(pm.getClass()) &&
				this.getFirst().sameEquivalenceClass(((ParametricConcatenatedMessage)pm).getFirst()) &&
				this.getSecond().sameEquivalenceClass(((ParametricConcatenatedMessage)pm).getSecond())){
			return true;
		}
		
		return false;
			
	}
	
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		return this.message1.getParameters(this.message2.getParameters(params));
	}
	
	//sat strings
	public String satString(){
		return "(pair "+this.getFirst().satString()+" "+this.getSecond().satString()+")";
	}
	public String satString(Pair<ParametricMessage, ParametricMessage> assignment){
		return "(pair "+this.getFirst().satString(assignment)+" "+this.getSecond().satString(assignment)+")";
	}
	public String satString(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment){
		return "(pair "+this.getFirst().satString(assignment)+" "+this.getSecond().satString(assignment)+")";
	}
}
