package se;
import java.util.*;


public class ParametricFalseConstant extends ParametricBooleanConstant implements ParametricConstant{
	  /**
	   * Private constructor because we want to control the creation of an instance.
	   */
	  private ParametricFalseConstant() {}
	 
	  /**
	   * The ParametricFalseConstantWrapper class is initialized at the first exection of the method getInstance()
	   * (at the very first access to ParametricFalseConstantWrapper.ParametricFalseConstantInstance, in a thread-safe way)
	   */
	  private static class ParametricFalseConstantWrapper { 
	    private final static ParametricFalseConstant ParametricFalseConstantInstance = new ParametricFalseConstant();
	  }
	 
	  public static ParametricFalseConstant getInstance() {
	    return ParametricFalseConstantWrapper.ParametricFalseConstantInstance;
	  }
	  public int getUID(){return 00000;}
		public String satString(){
			return "false";
		}
		public String satString(Pair<ParametricMessage, ParametricMessage> assignment){
			return "false";
		}
		public String satString(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment){
			return "false";
		}

		public String print() {
			return "ParametricFalseConstant FALSE";
		}	  
	  
		public String print(int i) {
			int j;
			String string="";
			for (j=0;j<i;j++){
				string = string + "\t";
			}
			return string+"ParametricFalseConstant FALSE";
		}

		//it does not return false because it's not part of the domain
		public void add2Domain(Domain domain){} //domain.add(this);}
		
}
