package se;

import java.util.ArrayList;

public abstract class ParametricMessage implements Value {

	private static int uid=0;
	private static String variableList="";
	
	protected static final int getNewUID(){
		uid++;
		return uid;} 
	
	protected static String getVarsList(){
		return variableList;} 
	
	
	public abstract int getUID();

	
	//returns the String for the smtsolver
	public abstract String satString();	
	public abstract String satString(Pair<ParametricMessage, ParametricMessage> assignment);
		
	public static void addVar2VariablesList(String var){
		variableList+=" ("+var+" Int)";
	}
	
	public int getNumberOfArgs(){return 1;}
	public abstract String getConstant();
	public abstract ArrayList<ParametricMessage> getPvtKey(ArrayList<ParametricMessage> pm_list);
	public abstract void add2Domain(Domain domain,IKStdConstraint ik);
	public abstract ArrayList<ParametricMessage> Msg2List(ArrayList<ParametricMessage> list,ParametricEncryptedMessage enc,ParametricConcatenatedMessage pair,ParametricSymEncryptedMessage scrypt);
	
	//returns: true/false if the 2 messages (this and m) are equal or not resp
	//and a list of [A][a] where A is the param and a the corresponding constant
	public abstract Pair<Boolean, ArrayList<ParametricMessage[]>> compare(ParametricMessage m, ArrayList<ParametricMessage[]> l);
	
	public ArrayList<ArrayList<ParametricMessage>> getParams(ArrayList<ArrayList<ParametricMessage>> params){
		return params;
	}
	
	public boolean sameEquivalenceClass(ParametricMessage pm){
		return false;
	}
}
