package se;


import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.BitSet;

public class ParametricMessageSet extends HashSet<ParametricMessage> implements Value {

	/**
	 * if there are problems with IK :
	 * - comment line: 		180 ArrayList<ParametricMessage> msgs=new ArrayList<ParametricMessage>();
	 * - uncomment line: 	176 ArrayList<ParametricMessage> msgs=new ArrayList<ParametricMessage>()
	 * - comment line:		192 msgs.add(constantM.getElement1());
	 * - uncomment line: 	191 msgs.add(currentIK_m);
	 * in method ret_e_eq_EOfv
	 **/
	
	private int uid=ParametricMessage.getNewUID();
	private String name="ParametricMessageSet"+this.getUID();
//	private ArrayList<ParametricMessage> params;
	
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	
//	public ParametricMessageSet(){
//		this.params=new ArrayList<ParametricMessage>();
//	}

	public String ikSatString(){
		//this is used to print the IKConstraint 
		return "IK";
	}
	
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		Iterator<ParametricMessage> iter=this.iterator();
		while(iter.hasNext()){
			params=iter.next().getParameters(params);
		}
		return params;
	}
	
	/**
	 * 
	 * @return < parameters , <{messagesThatContainParameters} , {messagesThatDoNOTContainParameters} > >
	 */
	public Pair<ArrayList<ParametricMessage>, Pair<HashSet<ParametricMessage>,ArrayList<ParametricMessage>>> getParametersAndMessages(){
		ArrayList<ParametricMessage> params=new ArrayList<ParametricMessage>();
		ArrayList<ParametricMessage> messagesWithoutParams=new ArrayList<ParametricMessage>();
		boolean eq=false;
		Iterator<ParametricMessage> iter=this.iterator();
		HashSet<ParametricMessage> mexWithParams=new HashSet<ParametricMessage>();

		while(iter.hasNext()){
			ParametricMessage current=iter.next();
			ArrayList<ParametricMessage> temp_params=new ArrayList<ParametricMessage>();
			temp_params=current.getParameters(temp_params);
			if(!temp_params.isEmpty()){
				if(!mexWithParams.contains(current))
					mexWithParams.add(current);

				for(int i=0;i<temp_params.size();i++){
					for(int j=0;j<params.size();j++)
						if(params.get(j).satString().equals(temp_params.get(i).satString())){
							eq=true;
							break;
						}

					if(!eq)
						params.add(temp_params.get(i));
					else
						eq=false;
				}
			}else
				messagesWithoutParams.add(current);
			
		}
		return new Pair<ArrayList<ParametricMessage>, Pair<HashSet<ParametricMessage>, ArrayList<ParametricMessage>>>(params,new Pair<HashSet<ParametricMessage>, ArrayList<ParametricMessage>>(mexWithParams,messagesWithoutParams));
	}
	
	public String print() {
		int i=0;
		String string="ParametricMessageSet "+this.getUID()+ " with elements:";
		Iterator<ParametricMessage> iterator = this.iterator();		
		while (iterator.hasNext()){
			i++;
			string = string+System.getProperty("line.separator")+"   "+i+". "+iterator.next().print();
		}
//		string = string +System.getProperty("line.separator");
		return string;
	}
	
	public String print(int i) {
		return "error: called print(int) in ParametricMessageSet";
	}
	
	//I think the following is never used
	public void add2Domain(Domain domain){
		Iterator<ParametricMessage> iterator=this.iterator();	
		while (iterator.hasNext()){
			ParametricMessage current=iterator.next();
			current.add2Domain(domain);			
		}
	}
	
	
	public void add2Domain(Domain domain,IKStdConstraint ik){
		Iterator<ParametricMessage> iterator=this.iterator();	
		while (iterator.hasNext()){
			
			ParametricMessage current=iterator.next();
//			System.out.println("M="+current.satString());
			current.add2Domain(domain,ik);
			if(current instanceof ParametricConcatenatedMessage){
				//System.out.println("M="+current.satString());
				((ParametricConcatenatedMessage)current).getFirst().add2Domain(domain, ik);
				((ParametricConcatenatedMessage)current).getSecond().add2Domain(domain, ik);
			}
			else if(current instanceof ParametricSymEncryptedMessage){
//				System.out.println("M="+current.satString());
				((ParametricSymEncryptedMessage)current).getFirst().add2Domain(domain, ik);
				((ParametricSymEncryptedMessage)current).getSecond().add2Domain(domain, ik);
			}
			else if(current instanceof ParametricEncryptedMessage){
//				System.out.println("M="+current.satString());
				((ParametricEncryptedMessage)current).getFirst().add2Domain(domain, ik);
				((ParametricEncryptedMessage)current).getSecond().add2Domain(domain, ik);
			}
			
		}
	}
	
	public String ret_e_eq_EOfv(Domain dom){
		ArrayList<ParametricMessage> params=new ArrayList<ParametricMessage>();

		String ret="(and true\n";

		//if IK is empty then every message of the domain is not in IK
		if(this.isEmpty()){

			if(!dom.getDomain().isEmpty()){				
				Iterator<ParametricMessage> iterD=dom.getDomain().iterator();
				while(iterD.hasNext()){
					ret+="(not (IK "+iterD.next().satString()+"))";
				}
			}

		}else{

			ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> assignments=dom.getAssPermTrans();
			ArrayList<ArrayList<Pair<ArrayList<ParametricMessage[]>,ParametricMessage>>> IKPM=new ArrayList<ArrayList<Pair<ArrayList<ParametricMessage[]>,ParametricMessage>>>();

			//if assignements is empty there are no params in the domain
			if(assignments.isEmpty()){

				Iterator<ParametricMessage> iterIK=this.iterator();
				while(iterIK.hasNext()){
					ParametricMessage currentIK=iterIK.next();
					ret+="(IK "+currentIK.satString()+")";
				}

				if(!dom.getDomain().isEmpty()){
					Iterator<ParametricMessage> iterD=dom.getDomain().iterator();
					while(iterD.hasNext()){
						ParametricMessage currentD=iterD.next();

						Iterator<ParametricMessage> iterIK2=this.iterator();
						boolean checkIKDom=false;
						while(iterIK2.hasNext()){
							ParametricMessage currentIK2=iterIK2.next();

							if(currentIK2.equals(currentD)){
								checkIKDom=true;
								break;
							}
						}
						if(!checkIKDom){
							ret+="(not (IK "+currentD.satString()+"))\n";
						}else{
							ret+="(IK "+currentD.satString()+")\n";
							checkIKDom=false;
						}

					}
				}


			}else{

				ArrayList<ParametricMessage> IKConst=new ArrayList<ParametricMessage>();
				boolean eq=false;
				ArrayList<ParametricMessage> msgs_pre=new ArrayList<ParametricMessage>();

				Iterator<ParametricMessage> iterIK=this.iterator();
				while(iterIK.hasNext()){
					ParametricMessage currentIK=iterIK.next();
					ArrayList<Pair<ArrayList<ParametricMessage[]>,ParametricMessage>> msgConst=dom.findConstantized(currentIK);

					//if it is a constant or it does not have assignments we add to IKConst subset
					if(msgConst.size()==1 && msgConst.get(0).getElement0().size()==0)
						IKConst.add(msgConst.get(0).getElement1());
					else //if it is not a constant and it has assignments we add it to IKPM subset together with the assignment
						IKPM.add(msgConst);
				}

				Iterator<ParametricMessage> iterD=dom.getDomain().iterator();
				while(iterD.hasNext()){
					ParametricMessage currentD=iterD.next();
					for(int i=0;i<IKConst.size();i++){
						if(currentD.equals(IKConst.get(i))){
							eq=true;
							msgs_pre.add(IKConst.get(i));
							break;
						}
					}
					if(eq){
						ret+="(IK "+currentD.satString()+")\n";
						eq=false;
					}else{
						for(int j=0; j<IKPM.size();j++){
							for(int j2=0; j2<IKPM.get(j).size();j2++)
								if(currentD.equals(IKPM.get(j).get(j2).getElement1())){
									eq=true;
									break;
								}
							if(eq)
								break;
						}
						if(!eq)
							ret+="(not(IK "+currentD.satString()+"))\n";
						else
							eq=false;
					}
				}

				if(!IKPM.isEmpty()){
//					for(int deb=0;deb<IKPM.size();deb++){
//						for(int deb2=0;deb2<IKPM.size();deb2++){
//							System.out.println("DEBUG IKPM["+deb+" "+deb2+"] = "+IKPM.get(deb).get(deb2).getElement1().satString());
//							for(int deb3=0;deb3<IKPM.get(deb).get(deb2).getElement0().size();deb3++)
//								System.out.println("DEBUG PARAM "+IKPM.get(deb).get(deb2).getElement0().get(deb3)[0].satString()+" = "
//							+IKPM.get(deb).get(deb2).getElement0().get(deb3)[1].satString());
//						}
//					}

					//add params start
					for(int j=0; j<IKPM.size();j++)
						for(int p=0;p<IKPM.get(j).get(0).getElement0().size();p++){
							if(IKPM.get(j).get(0).getElement0().get(p)[0].getClass().equals(PublicKeyParameter.class)){
								params.add(((ParametricPublicKey)(IKPM.get(j).get(0).getElement0().get(p)[0])).getParametricAgent());
								params.add(((ParametricPublicKey)(IKPM.get(j).get(0).getElement0().get(p)[0])).getParametricAgent().getPrivateKey());
							}
							if(IKPM.get(j).get(0).getElement0().get(p)[0].getClass().equals(PrivateKeyParameter.class)){
								params.add(((PrivateKeyParameter)(IKPM.get(j).get(0).getElement0().get(p)[0])).getParametricAgent());
								params.add(((ParametricPublicKey)(IKPM.get(j).get(0).getElement0().get(p)[0])).getParametricAgent().getPublicKey());
							}
							params.add(IKPM.get(j).get(0).getElement0().get(p)[0]);
						}
					
//					for(int deb=0;deb<params.size();deb++)
//						System.out.println("DEBUG "+params.get(deb).satString());
					
					//add params end
					Pair<Boolean[],Integer[]> assignments_bool_pair=dom.getAssPerm(params);
					Boolean[] assignments_bool=assignments_bool_pair.getElement0();
					Integer[] assignments_cols=assignments_bool_pair.getElement1();

					ret+="(or \n";

					for(int ass=0;ass<assignments_bool.length;ass++){

						if(assignments_bool[ass]){
							ArrayList<ParametricMessage> msgs=msgs_pre;
							//we print the assignment ass
							ret+="(and \n";
							ArrayList<Pair<ParametricMessage,ParametricMessage>> currentAss=new ArrayList<Pair<ParametricMessage,ParametricMessage>>(assignments_cols.length);
							for(int ass_i=0;ass_i<assignments_cols.length;ass_i++){
								currentAss.add(assignments.get(ass).get(assignments_cols[ass_i]));
								ret+="(= "+assignments.get(ass).get(assignments_cols[ass_i]).getElement0().satString()+" "+assignments.get(ass).get(assignments_cols[ass_i]).getElement1().satString()+")";
							}


							for(int i=0;i<IKPM.size();i++)
								for(int j=0;j<IKPM.get(i).size();j++){
									Pair<ArrayList<ParametricMessage[]>,ParametricMessage> constantM=dom.findConstantizedWrtAss(IKPM.get(i).get(j).getElement1(), currentAss);// assignments.get(ass));
									msgs.add(constantM.getElement1());
									ret+="(IK "+constantM.getElement1().satString()+")\n";
								}

							//write not(IK m) for any other constantization of that message
							boolean itIsInIK=false;
							Iterator<ParametricMessage> iterDomNotIK=dom.getDomain().iterator();
							while(iterDomNotIK.hasNext()){
								ParametricMessage domcurrent=iterDomNotIK.next();
								for(int msg_count=0;msg_count<msgs.size();msg_count++){
									if(msgs.get(msg_count).satString().equals(domcurrent.satString())){
										itIsInIK=true;
										break;
									}
								}
								if(!itIsInIK)
									ret+="(not (IK "+domcurrent.satString()+"))\n";
								itIsInIK=false;
							}

							ret+=")\n";//end of AND
						}
					}
					ret+=")";//end of OR
//					}
				}
			}
		}

		ret+=")\n"; //close big AND
		return ret;
	}
	
	//sat strings
	public String satString(){
		//this is used to print the IKConstraint 
		return "DY0_"+this.getUID();
	}
	public String satString(Pair<ParametricMessage, ParametricMessage> assignment){
		return "DY0_"+this.getUID();
	}
	public String satString(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment){
		return "DY0_"+this.getUID();
	}
}