package se;

import java.util.*;

public class ParametricNonceFunction extends ParametricFunction {
	private int uid=getNewUID();
	private String name="ParametricNonceFunction"+this.getUID();
	private String functionName;
//	private ParametricTuple args;
	private boolean invertibleFunction=false;
	private boolean publicFunction=true;
	private NonceFunction caller;
	//structure with
	//[ ((assignment1,constantizedTuple1),constant1) ;...; ((assignmentN,constantizedTupleN),constantN) ]
	private ArrayList<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,ParametricConstant>> constantiz=
			new ArrayList<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,ParametricConstant>>();
	
	public ParametricNonceFunction(NonceFunction caller){
		this.functionName=caller.getName();
		this.invertibleFunction=caller.isInvertible();
		this.publicFunction=caller.isPublic();
		this.caller=caller;
	}
	
	//this method should return true if the constant m is assignable to this object
	public Pair<Boolean, ArrayList<ParametricMessage[]>> compare(ParametricMessage m, ArrayList<ParametricMessage[]> l){
//		ArrayList<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,ParametricConstant>>
		if(this.constantiz.size()!=0)
			for(int i=0;i<this.constantiz.size();i++)
				if(m.satString().equals(this.constantiz.get(i).getElement1().satString()))
					new Pair<Boolean, ArrayList<ParametricMessage[]>>(true,l);
							
		return new Pair<Boolean, ArrayList<ParametricMessage[]>>(false,null);
	}
	
	public String satString(ArrayList<Pair<ParametricMessage,ParametricMessage>> assignment) {
		String ret="";
		if(assignment.isEmpty()){

			ret=this.constantiz.get(0).getElement1().satString();
			
			return ret;

		}else
		for(int ass=0;ass<assignment.size();ass++){
		
		for(int i=0;i<this.constantiz.size();i++){
			for(int j=0;j<this.constantiz.get(i).getElement0().getElement0().size();j++){
				if(assignment.get(ass).getElement0().satString().equals(
						this.constantiz.get(i).getElement0().getElement0().get(j)[0].satString()) &&
						assignment.get(ass).getElement1().satString().equals(
								this.constantiz.get(i).getElement0().getElement0().get(j)[1].satString())){
					ret=this.constantiz.get(i).getElement1().satString();
					return ret;
				}
			}
		}
		
		}
		
		if(ret.equals("")){
			System.out.println("(AgentFunction->interpolantString(env,assignment) - in this object there's no assignment like the one you're searching for");
			System.exit(0);
		}
			
		
		return ret;
	}
	
	//this method relies on a structure (constantiz) that is set up by Specification (initDomain method)
	public ArrayList<Pair<String,String>> satFunctionString(){
		ArrayList<Pair<String,String>> ret=new ArrayList<Pair<String,String>>();
		String tmp="";
		
		for(int i=0;i<this.constantiz.size();i++){
			
			for(int j=0;j<this.constantiz.get(i).getElement0().getElement0().size();j++){
				tmp+="(= "+this.constantiz.get(i).getElement0().getElement0().get(j)[0].satString()+" "+
						this.constantiz.get(i).getElement0().getElement0().get(j)[1].satString();
			}
			
			ret.add(new Pair<String,String>(tmp,this.constantiz.get(i).getElement1().satString()));	
		}
		
		return ret;
	}
	
	public ParametricNonceConstant getCons(Pair<ArrayList<ParametricMessage[]>,ParametricTuple> assignment,Domain dom){
//		System.out.println("DEBUG_PGF check same functions");
		
			ArrayList<Pair<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,String>,ParametricConstant>> ass_ptuple_fnam_const=dom.getAss_ptuple_fname_const();
			for(int i=0;i<ass_ptuple_fnam_const.size();i++){
				ParametricConstant constant2check=ass_ptuple_fnam_const.get(i).getElement1();
				
				String fname2check=ass_ptuple_fnam_const.get(i).getElement0().getElement1();
				ParametricTuple ptuple2check=ass_ptuple_fnam_const.get(i).getElement0().getElement0().getElement1();

				//same function name, now we check if there exist a tuple in constantiz struct that is equal to ptuple2check.if so, they're equal!
				if(fname2check.equals(this.getFunctionName())){
//					System.out.println("DEBUG_PGF names are equals: "+this.getFunctionName()+" = "+fname2check);
					
							ParametricTuple tupleInConstantiz=assignment.getElement1();
							if(tupleInConstantiz.equals(ptuple2check)){
//								System.out.println("DEBUG_PGF ptuple equals");
									return (ParametricNonceConstant)constant2check;
							}
				
				}

			}

//		System.out.println("DEBUG_PGF they DIFFER somehow");
		return new ParametricNonceConstant();
	}
	
	public String print(){return this.getName()+"("+this.caller.getArgs().print()+")";}
	public String print(int i){return this.print();}
	
	public ArrayList<ParametricMessage> Msg2List(ArrayList<ParametricMessage> list,ParametricEncryptedMessage enc,ParametricConcatenatedMessage pair,ParametricSymEncryptedMessage scrypt){
		list.add(this);
		return list;
	}
	
	public ArrayList<ParametricMessage> getPvtKey(ArrayList<ParametricMessage> pm_list){
		return pm_list;
	}
	
	//gets and sets
	public String getFunctionName(){return this.functionName;}
	public ParametricTuple getArgs(Environment env){return this.caller.getArgs().eval(env);}
	public boolean isInvertible(){return this.invertibleFunction;}
	public boolean isPublic(){return this.publicFunction;}
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	public ArrayList<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,ParametricConstant>> getConstantiz(){return this.constantiz;}
	public void setConstantiz(ArrayList<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,ParametricConstant>> constantiz){
		this.constantiz=constantiz;
	}
	
	/*******************************
	 * UNUSED METHODS
	 *******************************/
	public String getConstant(){return null;}
	public void add2Domain(Domain domain,IKStdConstraint ik){}
	public void add2Domain(Domain domain){}
	public ArrayList<Pair<Pair<ArrayList<ParametricMessage[]>, ParametricTuple>, ParametricConstant>> getContantiz() {return this.constantiz;}
}
