package se;

import java.util.ArrayList;


public class ParametricPrivateKeyConstant extends ParametricPrivateKey implements ParametricConstant {
	
	private int uid=getNewUID();
	private String name="ParametricPrivateKeyConstant"+this.getUID();
	
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	
	public String getConstant(){
		return this.satString();
	}
	
	public String print() {
		return this.getName() + " (of " + this.getParametricAgent().print()+")";
	}
	
	public String print(int i) {
		int j;
		String string="";
		for (j=0;j<i;j++){
			string = string + "\t";
		}
		return string+this.getName()+ " (of " + this.getParametricAgent().print()+")";
	}
	
	public ParametricPrivateKeyConstant(ParametricAgent parametricAgent){
		super(parametricAgent);
//		ParametricMessage.addVar2VariablesList(""+getUID());
	}
	
	
	// resume this method in case the one in the superclass does not work properly 
/*	public StdConstraint matches(ParametricMessage m){
		if (m instanceof ParametricPublicKey){
			ParametricKey em = (ParametricKey)m;
			return new OPConstraint(em.getParametricAgent(),this.getParametricAgent());
		}
		else
			return False.getInstance();			
	}*/
	
	public ArrayList<ParametricMessage> getPvtKey(ArrayList<ParametricMessage> pm_list){
		pm_list.add(this);
		return pm_list;
		}

	public void add2Domain(Domain domain){domain.add(this);}
	public void add2Domain(Domain domain,IKStdConstraint ik){
		domain.add(this,ik);}
	public Pair<Boolean,ArrayList<ParametricMessage[]>> compare(ParametricMessage m,ArrayList<ParametricMessage[]> l){
		if(this.equals(m)){
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(true,l);
		}else{
			//they're not equal
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(false,null);
		}
	}
	
	
	//sat strings
	public String satString(){
		return ""+getUID();
	}
	public String satString(Pair<ParametricMessage, ParametricMessage> assignment){
		return ""+getUID();	
	}
	public String satString(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment){
		return ""+getUID();
	}
}	
