package se;

import java.util.ArrayList;


public class ParametricPublicKey extends ParametricKey {
	
	private int uid=getNewUID();
	private String name="ParametricPublicKey"+this.getUID();
	
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	

	public String print() {
		return this.getName()+ " (of " + this.getParametricAgent().print()+")";
	}
	public String getConstant(){
		return this.satString();
	}
	
	public String print(int i) {
		int j;
		String string="";
		for (j=0;j<i;j++){
			string = string + "\t";
		}
		return string+this.getName()+ " (of " + this.getParametricAgent().print()+")";
	}
	
	public ParametricPublicKey(ParametricAgent parametricAgent){
		super(parametricAgent);
//		ParametricMessage.addVar2VariablesList("PPubK"+getUID());
	}
	
	// resume this method in case the one in the superclass does not work properly
/*	public StdConstraint matches(ParametricMessage m){
		if (m instanceof ParametricPublicKey){
			ParametricKey em = (ParametricKey)m;
			return new OPConstraint(em.getParametricAgent(),this.getParametricAgent());
		}
		else
			return False.getInstance();			
	}*/
	
	
	public ArrayList<ParametricMessage> getPvtKey(ArrayList<ParametricMessage> pm_list){return pm_list;}
	

	public void add2Domain(Domain domain){
		domain.add(this);
		domain.add(this.getParametricAgent().getPrivateKey());
	}
	public void add2Domain(Domain domain,IKStdConstraint ik){
		domain.add2DomainPMparams(this);
		domain.add2DomainPMparams(this.getParametricAgent().getPrivateKey());
		domain.add(this,ik);
		domain.add(this.getParametricAgent().getPrivateKey(),ik);	
	}
	
	public ArrayList<ParametricMessage> Msg2List(ArrayList<ParametricMessage> list,ParametricEncryptedMessage enc,ParametricConcatenatedMessage pair,ParametricSymEncryptedMessage scrypt){
		list.add(this);
		return list;
	}
	public Pair<Boolean,ArrayList<ParametricMessage[]>> compare(ParametricMessage m,ArrayList<ParametricMessage[]> l){
		if(m.getClass().equals(ParametricPublicKeyConstant.class)){
			//they're similar
			//add the assignment to l
			ParametricMessage[] ret=new ParametricMessage[2];
			ret[0]=this;
			ret[1]=m;
			l.add(ret);
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(true,l);
		}else if(this.equals(m)){
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(true,l);
		}else{
			//they're not equal
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(false,null);
		}
	}
	
	
	public String satString(){
		String ret="";

		//two cases: key(constant) \/ key(variable)

		//if key(constant)
		if(this.getParametricAgent().getClass().equals(AgentConstant.class)){
			ret+=((ParametricAgentConstant)(this.getParametricAgent())).getPublicKey().satString();
		}else if(this.getParametricAgent().getClass().equals(AgentVariable.class)){
			ret+=this.getParametricAgent().satString();
		}

		return ret;
	}	
	
	public String satString(Pair<ParametricMessage,ParametricMessage> assignment){
		ArrayList<Pair<ParametricMessage,ParametricMessage>> ass=new ArrayList<Pair<ParametricMessage,ParametricMessage>>();
		ass.add(assignment);
		return this.satString(ass);
	}
	public String satString(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment){
		String ret="";
		
		if(this.getParametricAgent().getClass().equals(AgentConstant.class)){
			ret+=((ParametricAgentConstant)(this.getParametricAgent())).getPublicKey().satString(assignment);
		}else if(this.getParametricAgent().getClass().equals(AgentVariable.class)){
			ret+=this.getParametricAgent().satString();
		}
		
		return ret;
	}
	
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		return params;
	}
}
