package se;

import java.util.*;

public class ParametricTrueConstant extends ParametricBooleanConstant{
	  /**
	   * Private constructor because we want to control the creation of an instance.
	   */
	  private ParametricTrueConstant() {}
	 
	  /**
	   * The ParametricTrueConstantWrapper class is initialized at the first exection of the method getInstance()
	   * (at the very first access to ParametricTrueConstantWrapper.ParametricTrueConstantInstance, in a thread-safe way)
	   */
	  private static class ParametricTrueConstantWrapper { 
	    private final static ParametricTrueConstant ParametricTrueConstantInstance = new ParametricTrueConstant();
	  }
	 
	  public static ParametricTrueConstant getInstance() {
	    return ParametricTrueConstantWrapper.ParametricTrueConstantInstance;
	  }
	  	public int getUID(){return 11111;}
		
		public String satString(){
			return "true";
		}
		public String satString(Pair<ParametricMessage, ParametricMessage> assignment){
			return "true";
		}
		public String satString(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment){
			return "true";
		}
		public String print() {
			return "ParametricTrueConstant TRUE";
		}	  

		public String print(int i) {
			int j;
			String string="";
			for (j=0;j<i;j++){
				string = string + "\t";
			}
			return string+"ParametricPrivateKey TRUE";
		}
		
		//it does not return false because it's not part of the domain
		public void add2Domain(Domain domain){} //domain.add(this);}
}
