package se;
import java.util.*;

public class ParametricTuple implements Value {
	
	private ParametricMessage[] parametricArgs;
	
	public ParametricTuple(ParametricMessage[] parametricArgs){
//		for(int deb=0;deb<parametricArgs.length;deb++)
//			System.out.println(parametricArgs[deb].satString());
		this.parametricArgs=parametricArgs;
	}
	
	public ParametricMessage[] getArgs(){
		return this.parametricArgs;
	}
	
	
	public String print() {
		String ret="";
		for(int i=0;i<this.getArgs().length;i++)
			ret+=this.getArgs()[i].print()+" ";
		return "<"+ret+">";
	}
	
	public String getConstant(){
		String ret="";
		for(int i=0;i<this.getArgs().length;i++)
			ret+=this.getArgs()[i].getConstant();
		return ret;
	}
	
	public String print(int i) {
		return this.print();
	}
	

	//we need the entire tuple in the domain
	public void add2Domain(Domain domain){
		domain.addPTuple(this);
	}
	
	
	public boolean equals(ParametricTuple pt){
		if(pt==null){return false;}
		if(pt==this){return true;}
		if(this.getArgs().length!=pt.getArgs().length){return false;}
		
		for(int i=0;i<this.getArgs().length;i++){
			if(!(this.getArgs()[i].equals(pt.getArgs()[i]))){				
				return false;
			}
		}
		return true;
	}
	
//	public void add2Domain(Domain domain,IKStdConstraint ik){
//		domain.add(this,ik);
//	}
	
//	public Pair<Boolean,ArrayList<ParametricMessage[]>> compare(ParametricMessage m,ArrayList<ParametricMessage[]> l){
//		
//		if(this.equals(m)){			
//			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(true,l);
//		}else{
//			//they're not equal
//			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(false,null);
//		}
//	}
	
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		for(int i=0;i<this.parametricArgs.length;i++)
			params=this.parametricArgs[i].getParameters(params);
		return params;
	}
	
	//sat strings
	public String satString(){
		String ret="";
		for(int i=0;i<this.getArgs().length;i++)
			ret+=this.getArgs()[i].satString()+" ";
		return ret;
	}
	public String satString(Pair<ParametricMessage, ParametricMessage> assignment){
		String ret="";
		for(int i=0;i<this.getArgs().length;i++)
			ret+=this.getArgs()[i].satString(assignment)+" ";
		return ret;
	}
	public String satString(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment){
		String ret="";
		if(assignment.isEmpty()){
			return this.satString();
		}else
		for(int i=0;i<this.getArgs().length;i++)
			ret+=this.getArgs()[i].satString(assignment)+" ";
		return ret;
	}
	public String satWithDYString(ArrayList<ParametricMessage[]> assignment, String dy){
		ArrayList<Pair<ParametricMessage, ParametricMessage>> assign=new ArrayList<Pair<ParametricMessage, ParametricMessage>>(); 
		
		for(int i=0;i<assignment.size();i++){
			assign.add(new Pair<ParametricMessage,ParametricMessage>(assignment.get(i)[0],assignment.get(i)[0]));			
		}
		
		return this.satWithDYString2(assign,dy);
	}
	public String satWithDYString2(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment, String dy){
		String ret="";
		for(int i=0;i<this.getArgs().length;i++)
			ret+="("+dy+" "+this.getArgs()[i].satString(assignment)+" ) ";
//			ret+="(IK "+this.getArgs()[i].satString(assignment)+" ) ";
		return ret;
	}
}
