package se;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;

public class ParametricTupleSet extends HashSet<ParametricTuple> implements Value{

	public String interpolantString(Environment env){
		String ret="";

		Iterator<ParametricTuple> iterTuple=this.iterator();
		while(iterTuple.hasNext()){
			ParametricTuple currentTuple=iterTuple.next();
			ret+=currentTuple.satString();
		}

		return ret;
	}

	public String print(){
		String ret="";

		Iterator<ParametricTuple> iterTuple=this.iterator();
		while(iterTuple.hasNext()){
			ParametricTuple currentTuple=iterTuple.next();
			ret+=currentTuple.print()+"\n";
		}

		return "{"+ret+"}";
	}

	public void add2Domain(Domain domain){
		Iterator<ParametricTuple> iterTuple=this.iterator();
		while(iterTuple.hasNext()){
			iterTuple.next().add2Domain(domain);
		}
	}


	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		Iterator<ParametricTuple> iter=this.iterator();
		while(iter.hasNext()){
			params=iter.next().getParameters(params);
		}
		return params;
	}
	
	public String print(int i){
		return this.print();
	}
	

	public String ret_e_eq_EOfv(Domain dom, FactVariable fact){
		String ret="\n(and true ;ptset \n";

		//if parametricTupleSet is empty then every message of the tuple set in the domain is not in the fact
		if(this.isEmpty()){
			Iterator<ParametricTuple> iterD=dom.getPTuple().iterator();
			while(iterD.hasNext()){
				ret+="(not ("+fact.getName()+" "+iterD.next().satString()+"))";
			}

		}else{

			ArrayList<ArrayList<Pair<ParametricMessage,ParametricMessage>>> assignments=dom.getAssPermTrans();
			
			//for each tuple
			Iterator<ParametricTuple> iterTuple=this.iterator();
			while(iterTuple.hasNext()){

				ParametricTuple currentTuple=iterTuple.next();
				ArrayList<ArrayList<Pair<ArrayList<ParametricMessage[]>,ParametricMessage>>> tuplePM=
						new ArrayList<ArrayList<Pair<ArrayList<ParametricMessage[]>,ParametricMessage>>>();

				//int debug=0;
				//for each message in the current tuple
				for(int tupleM=0;tupleM<currentTuple.getArgs().length;tupleM++){
					ParametricMessage currentM=currentTuple.getArgs()[tupleM];
					//System.out.println("DEBUG check:"+currentM.satString());
					ArrayList<Pair<ArrayList<ParametricMessage[]>,ParametricMessage>> msgConst=dom.findConstantized(currentM);

					//for(int a=0;a<msgConst.size();a++){
					//	for(int b=0;b<msgConst.get(a).getElement0().size();b++){
					//		System.out.println("ASS0 "+msgConst.get(a).getElement0().get(b)[0].satString()+" = "+msgConst.get(a).getElement0().get(b)[1].satString());
					//	}
					//}


					//if it is not a constant or it has assignments we add to tuplePM
					if(!(msgConst.size()==1 && msgConst.get(0).getElement0().size()==0)){						
						tuplePM.add(msgConst);
					}
				}


				//debug
//								System.out.println("SIZE:"+tuplePM.size());
//								for(int a=0;a<tuplePM.size();a++){
//									for(int b=0;b<tuplePM.get(a).size();b++){
//										for(int c=0;c<tuplePM.get(a).get(b).getElement0().size();c++){
//											System.out.println("a="+a+" b="+b+" c="+c);
//											System.out.println("ASS "+tuplePM.get(a).get(b).getElement0().get(c)[0].satString()+" = "+tuplePM.get(a).get(b).getElement0().get(c)[1].satString());
//											System.out.println("MEX "+tuplePM.get(a).get(b).getElement1().satString()+"\n");
//										}
//																
//									}
//								}
//				
//								debug++;
//								System.out.println();
				//end debug



				if(tuplePM.size()==0){
					//there are no parameters in the tuple
					//assignments.clear();

					boolean flag=true;
					ArrayList<ParametricMessage> msgs=new ArrayList<ParametricMessage>();

					//for each message in the current tuple
					int check=0;
					ParametricTupleSet tuples=new ParametricTupleSet();
					for(int tupleM=0;tupleM<currentTuple.getArgs().length;tupleM++){
						ParametricMessage currentTuple_m=currentTuple.getArgs()[tupleM];

						msgs.add(currentTuple_m);

						if(check==0){
							ret+="("+fact.getName()+" "+currentTuple_m.satString();//+")\n";
						}else if(check==currentTuple.getArgs().length-1){
							ret+=" "+currentTuple_m.satString()+" )\n";
							tuples.add(new ParametricTuple(msgs.toArray(new ParametricMessage[msgs.size()])));

						}else if(check<currentTuple.getArgs().length && check!=0){
							ret+=" "+currentTuple_m.satString()+" ";

						}
						check++;

					}
					check=0;

					//for each tuple in the domain
					//ret+="\n; domain elements="+dom.getPTupleConstantized().size()+"\n";
					Iterator<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>> iterD=dom.getPTupleConstantized(currentTuple).iterator();
					while(iterD.hasNext()){

						ParametricTuple currentD=iterD.next().getElement1();
						for(int msg=0;msg<msgs.size();msg++){
							
//							System.out.println(((ParametricMessage)currentD.getArgs()[msg]).satString()+" ?= "+msgs.get(msg).satString());
							if(!((ParametricMessage)currentD.getArgs()[msg]).equals((ParametricMessage)(msgs.get(msg)))){
//								System.out.println("NOO!");
								flag=false;
								break;
							}
						}
						if(!flag){
							ret+="(not("+fact.getName()+" "+currentD.satString()+"))\n";
						}

						flag=true;

					}


				}else{
					ArrayList<ParametricMessage> params=new ArrayList<ParametricMessage>();
					//add params for agents start
					for(int j=0; j<tuplePM.size();j++)
						for(int p=0;p<tuplePM.get(j).get(0).getElement0().size();p++){
							if(tuplePM.get(j).get(0).getElement0().get(p)[0].getClass().equals(PublicKeyParameter.class)){
								params.add(((ParametricPublicKey)(tuplePM.get(j).get(0).getElement0().get(p)[0])).getParametricAgent());
								params.add(((ParametricPublicKey)(tuplePM.get(j).get(0).getElement0().get(p)[0])).getParametricAgent().getPrivateKey());
							}
							if(tuplePM.get(j).get(0).getElement0().get(p)[0].getClass().equals(PrivateKeyParameter.class)){
								params.add(((PrivateKeyParameter)(tuplePM.get(j).get(0).getElement0().get(p)[0])).getParametricAgent());
								params.add(((ParametricPublicKey)(tuplePM.get(j).get(0).getElement0().get(p)[0])).getParametricAgent().getPublicKey());
							}
							params.add(tuplePM.get(j).get(0).getElement0().get(p)[0]);
						}
					
					Pair<Boolean[],Integer[]> assignments_bool_pair=dom.getAssPerm(params);
					Boolean[] assignments_bool=assignments_bool_pair.getElement0();
					Integer[] assignments_cols=assignments_bool_pair.getElement1();
					
					boolean flag=false;
					ret+="\n(or \n";

					for(int ass=0;ass<assignments_bool.length;ass++){
						if(assignments_bool[ass]){
							
						ArrayList<ParametricMessage> msgs=new ArrayList<ParametricMessage>();
						//we print the assignment ass
						ret+="(and \n";
						ArrayList<Pair<ParametricMessage,ParametricMessage>> currentAss=new ArrayList<Pair<ParametricMessage,ParametricMessage>>(assignments_cols.length);
						for(int ass_i=0;ass_i<assignments_cols.length;ass_i++){
							currentAss.add(assignments.get(ass).get(assignments_cols[ass_i]));
							ret+="(= "+assignments.get(ass).get(assignments_cols[ass_i]).getElement0().satString()+" " +
									""+assignments.get(ass).get(assignments_cols[ass_i]).getElement1().satString()+")";
						}

						//for each message in the current tuple
						int check=0;
						ParametricTupleSet tuples=new ParametricTupleSet();
						for(int tupleM=0;tupleM<currentTuple.getArgs().length;tupleM++){
							ParametricMessage currentTuple_m=currentTuple.getArgs()[tupleM];
							Pair<ArrayList<ParametricMessage[]>,ParametricMessage> constantM=
									dom.findConstantizedWrtAss(currentTuple_m, currentAss);
							//System.out.println("\n currentTuple_m="+currentTuple_m.satString());
							//System.out.println("constantM="+constantM.getElement1().satString());
							msgs.add(constantM.getElement1());

							if(check==0){
								ret+="("+fact.getName()+" "+constantM.getElement1().satString();
							}else if(check==currentTuple.getArgs().length-1){
								ret+=" "+constantM.getElement1().satString()+" )\n";
								tuples.add(new ParametricTuple(msgs.toArray(new ParametricMessage[msgs.size()])));

							}else{
								ret+=" "+constantM.getElement1().satString()+" ";

							}
							check++;

						}
						check=0;

						Iterator<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>> iterD=dom.getPTupleConstantized(tuples.iterator().next()).iterator();
						flag=true;

						//Idebug
						//System.out.println("DEBUG isEmpty? ..."+dom.getPTupleConstantized().size());						
						//int debug=0;
						//Edebug

						while(iterD.hasNext()){


							ParametricTuple currentD=iterD.next().getElement1();
							//Idebug
							//System.out.println("DOM ["+debug+"] "+currentD.satString()+" ("+currentD.hashCode()+")");
							//
							//System.out.println("dom size="+currentD.getArgs().length);
							//System.out.println("msg size="+msgs.size());
							//Edebug
							for(int msg=0;msg<msgs.size();msg++){
								//Idebug
								//System.out.println(((ParametricMessage)currentD.getArgs()[msg]).satString()+" ?= "+msgs.get(msg).satString());
								//Edebug
								if(!((ParametricMessage)currentD.getArgs()[msg]).equals((ParametricMessage)(msgs.get(msg)))){
									//Idebug
									//System.out.println("NOO!");
									//Edebug
									flag=false;
									break;
								}
							}
							if(!flag){
								ret+="(not("+fact.getName()+" "+currentD.satString()+"))\n";
							}

							flag=true;
							//Idebug
							//debug++;
							//System.out.println();
							//Edebug
						}

						ret+=")\n";//end of AND
						}
					}
					ret+=")";//end of OR
				}//end of else

			}//end of while

			ret+=")"; //close big AND

		}//close for each tuple

		return ret;
	}
	
	//sat strings
	public String satString(){
		String ret="(and";
		Iterator<ParametricTuple> iter=this.iterator();
		while(iter.hasNext()){
			ret+=iter.next().satString()+" ";
		}
		ret+=");uno\n";
		return ret;
	}
	public String satString(Pair<ParametricMessage, ParametricMessage> assignment){
		String ret="(and";
		Iterator<ParametricTuple> iter=this.iterator();
		while(iter.hasNext()){
			ret+=iter.next().satString(assignment)+" ";
		}
		ret+=");due\n";
		return ret;
	}
	public String satString(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment){
		String ret="";
		if(assignment.isEmpty()){
			return this.satString();
		}else{
			ret="(and";
			Iterator<ParametricTuple> iter=this.iterator();
			while(iter.hasNext()){
				ret+=iter.next().satString(assignment)+" ";
			}
			ret+=")";
		}
		return ret+";tre\n";
	}
}