package se;
import java.util.*;

public class PrivateKey extends Key {
	
	public PrivateKey(Agent agent){
		super(agent);
	}
	
	public PrivateKey(Agent agent, String messageString){
		this(agent);
		this.messageString = messageString;
	}
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		for(int i=0;i<mex_newMex.size();i++){
			if(mex_newMex.get(i).getElement0().equals(this))
				return mex_newMex.get(i).getElement1();
			if(mex_newMex.get(i).getElement0() instanceof AgentVariable &&
					((AgentVariable)mex_newMex.get(i).getElement0()).equals(this.getAgent()))
				return ((AgentVariable)mex_newMex.get(i).getElement1()).getPrivateKey();
			if(mex_newMex.get(i).getElement0() instanceof AgentConstant &&
					((AgentConstant)mex_newMex.get(i).getElement0()).equals(this.getAgent()))
				return ((AgentConstant)mex_newMex.get(i).getElement1()).getPrivateKey();
		}
		return this;
	}
	public Message getAnotherOfTheSameType(String name){
		return new PrivateKey(this.getAgent(),name);
	}
	
	public ParametricPrivateKey eval(Environment env) {
		//Debugging purpose
		//System.out.println("this is the PvtKey: "+((ParametricAgent)((this.getAgent()).eval(env))).getPrivateKey());
		return ((ParametricAgent)((this.getAgent()).eval(env))).getPrivateKey();
	}
	
	public String print() {
		return "PrivateKey "+this.hashCode()+" of "+this.getAgent().print();
	}
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){
		return this.getAgent().getVars(list);
	}
	
	public String interpolantString(Environment env){
		String ret="";

		//two cases: key(constant) \/ key(variable)

		//if key(constant)
		if(this.getAgent().getClass().equals(AgentConstant.class)){
			ret+=((ParametricAgentConstant)(this.getAgent().eval(env))).getPublicKey().satString();
		}else if(this.getAgent().getClass().equals(AgentVariable.class)){
			ret+="(pvt "+this.getAgent().interpolantString(env)+")";
		}

		return ret;
	}	
	
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		ArrayList<Pair<Message,ParametricMessage>> ass=new ArrayList<Pair<Message,ParametricMessage>>();
		ass.add(assignment);
		return this.interpolantString(env,ass);
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment){
		String ret="";
		
		if(this.getAgent().getClass().equals(AgentConstant.class)){
			ret+=((ParametricAgentConstant)(this.getAgent().eval(env))).getPublicKey().satString();
		}else if(this.getAgent().getClass().equals(AgentVariable.class)){
			ret+="(pvt "+this.getAgent().interpolantString(env,assignment)+")";
		}
		
		return ret;
	}
	
	public String toString(){
		return "inv(pk("+ this.getAgent().toString() +"))";
	}
}