package se;
import org.jgrapht.graph.*;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.*;

public class Program extends DefaultDirectedGraph<Location,ActionEdge> {
	
	private Location root;
	private Domain dom;
	private int RPD=5;
//	private HashSet<GoalLocation> goalLocationSet;
	private double z3satTime,z3unsatTime,iz3time,Z3totalsatTime,Z3totalunsatTime,iZ3totalTime;
	private int z3sattotnum=0,z3unsattotnum=0,iz3totnum=0;
	
	public void setZ3satTime(double z3satTime){this.z3satTime=z3satTime;}
	public void setZ3unsatTime(double z3unsatTime){this.z3unsatTime=z3unsatTime;}
	public void setiZ3time(double iz3time){this.iz3time=iz3time;}
	public double getZ3satTime(){return this.z3satTime;}
	public double getZ3unsatTime(){return this.z3unsatTime;}
	public double getiZ3time(){return this.iz3time;}
	
	public void addZ3satExecTime(double z3satTime){this.Z3totalsatTime+=z3satTime;this.z3sattotnum++;}
	public void addZ3unsatExecTime(double z3unsatTime){this.Z3totalunsatTime+=z3unsatTime;this.z3unsattotnum++;}
	public void addiZ3execTime(double iz3time){this.iZ3totalTime+=iz3time;this.iz3totnum++;}	
	public double getZ3averageSatTime(){return this.Z3totalsatTime/this.z3sattotnum;}
	public double getZ3averageUnsatTime(){return this.Z3totalunsatTime/this.z3unsattotnum;}
	public double getiZ3averageTime(){return this.iZ3totalTime/this.iz3totnum;}
	
	public Program() {
		super(ActionEdge.class);
	}
	
	public Program(Location root) {
		super(ActionEdge.class);
		addVertex(root);
		this.root = root;		
	}
	
	public Location getRoot(){
		return root;
	}

	public HashSet<GoalLocation> getGoalLocationSet(){
		HashSet<GoalLocation> goalLocationSet = new HashSet<GoalLocation>();
		Location current;
		Iterator<Location> iter = vertexSet().iterator();
		while(iter.hasNext()){
			current=iter.next();
			if (current.isGoal())
				goalLocationSet.add((GoalLocation)current);
		}
		return goalLocationSet;
	}

	public Domain getDomain(){return this.dom;}
	public int getRPD(){return this.RPD;}
	
	
	 //returns void for the moment
public void intraLA(Domain dom, Environment env) {
	boolean moreAttacks = true; // 'true' if we want to search for more attacks for each goal 
	this.dom=dom;
	Query currentQuery, lastQuery, nextQuery;
	Location currentLocation=new Location("test");
	Location locationToBeFound;
	ActionEdge currentEdge=null;
	Iterator<ActionEdge> iterEdges;
	Iterator<Query> iterQuery;
	Set<ActionEdge> outgoingEdges;
	SymbolicDataState sds;
	Formula annotation;//, interpolant;
	int counterIsBlocked=0;
	boolean ruleApplied=false, dlApplied=false, learn=false, goalFound = false;
	
	// 0 stands for DECIDE/LEARN, 1 for CONJOIN
	int lastRule;
	
	Scanner input=new Scanner(System.in); 
	
	AlgorithmState algorithmState = new AlgorithmState(this);
	
	int counter=0;
	lastRule = 0;
	iterQuery = (algorithmState.getQuerySet()).iterator();
	currentQuery=iterQuery.next();
	//TIME
	double startTime=0,endTime=0,interpolateStart=0,interpolateEnd=0,decideStart=0,decideEnd=0,conjoinStart=0,conjoinEnd=0;
	double totDecide=0,totLearn=0,totConjoin=0;
	double timeDecide=0,timeLearn=0,timeConjoin=0;
	double numDecide=0,numLearn=0;
	double averageDecide=0,averageLearn=0;
	double currentRule=0;
	double total=0,stepTime=0;
	//TIME
//	Location next = this.getRoot();

	while (!((algorithmState.getQuerySet()).isEmpty())) {
		
		ruleApplied = false;
		//TIME
		startTime = System.nanoTime();
		//TIME
		counter++;
		System.out.println("\n\n******************     STEP "+counter+"     ******************");
		this.setiZ3time(0);
		this.setZ3satTime(0);
		this.setZ3unsatTime(0);
		algorithmState.print();
		
		System.out.print("\n currentQuery is: ");
		currentQuery.print();
		
		currentLocation = currentQuery.getLocation();
		outgoingEdges = (Set<ActionEdge>)this.outgoingEdgesOf(currentLocation);
//		System.out.println("DEBUG currentLocation "+currentLocation.print()+" hashcode "+currentLocation.hashCode());
//		System.out.println("DEBUG current ConstraintSet ");
//		currentQuery.getSymbolicDataState().getConstraintSet().print();
//		System.out.println("DEBUG outgoingedges isEmpty "+outgoingEdges.isEmpty());
		iterEdges = outgoingEdges.iterator();
		
//		System.out.println("DEBUG 1");
		// if the current Query does not need to be annotated
		if (!(currentQuery.needsToBeAnnotated())){
//			System.out.println("DEBUG 2");
			lastQuery=currentQuery.getPreviousQuery();
			nextQuery=lastQuery;
		
//			System.out.println("DEBUG iterEdges hasNext "+iterEdges.hasNext());
			
			while(iterEdges.hasNext()){
//				System.out.println("DEBUG 3");
				currentEdge=iterEdges.next();
				//TIME
				decideStart=System.nanoTime();
				//TIME
				
				// symbolic execution step
				sds = (currentEdge.getAction()).se(currentQuery.getSymbolicDataState());
				System.out.println("Trying to apply DECIDE on edge:" + currentEdge.print());
				
				
				// if the resulting state is not blocked... 
//				if (!(sds.isBlocked((currentEdge.getTarget()).getAnnotation().translate(),dom,env))){
				if (!(sds.isBlocked((currentEdge.getTarget()).getAnnotation().translate(),dom,env,this))){
						// then apply DECIDE
						System.out.print("DECIDE applied to ");
						currentQuery.print();
						System.out.print("with annotation ");
						System.out.println((currentEdge.getTarget()).getAnnotation().translate());
						boolean toBeAnnotated;
							// this might be improved 
						if ((this.incomingEdgesOf(currentEdge.getTarget()).size() > 1) && ((algorithmState.getQuerySet()).size() > 1)) {
							toBeAnnotated=true;
						}
						else{
							toBeAnnotated=false;	
						}
						Query newQuery = new Query(currentEdge.getTarget(),sds,lastQuery,currentQuery,null,toBeAnnotated,false,false);
						System.out.print("with respect to edge " + currentEdge.print());
						if((currentEdge.getTarget()).isGoal()){
							System.out.println("\n\nGOAL! (Location: "+(currentEdge.getTarget()).print()+")");
							if (moreAttacks){
								goalFound = true;											
							}
							else {
								// beware: in case you have more goals, this line needs to be modified
								return;
							}
						}
						algorithmState.addQuery(newQuery);
						lastQuery = newQuery;
						nextQuery = newQuery;
						
						//TIME
						decideEnd=System.nanoTime();
						timeDecide=((decideEnd-decideStart)/(double)Math.pow(10,6));
						totDecide+=timeDecide;
						currentRule=timeDecide;
						numDecide++;
						averageDecide=(totDecide/numDecide);
						//TIME
				}
//				else{
//					//the resulting state is blocked		
//				}
			}
			(algorithmState.getQuerySet()).remove(currentQuery);
			currentQuery = nextQuery;
			lastRule = 0;
		}
		
		// if the current Query needs to be annotated
		else {	
//			System.out.println("DEBUG 4");
			// if (lastRule applied is DECIDE/LEARN)
			if (lastRule==0 || (!learn)){
				dlApplied = false;
				annotation = new TrueFormula();
				// if DECIDE/LEARN can be applied
					while(iterEdges.hasNext()){
						currentEdge=iterEdges.next();
						annotation = new AndFormula(annotation,currentEdge.getAnnotation());
						if (!((currentQuery.getExecuted()).contains(currentEdge))){
							// execute the edge symbolically
							
							//TIME
							decideStart=System.nanoTime();
							//TIME
							
							sds = (currentEdge.getAction()).se(currentQuery.getSymbolicDataState());
							// if the resulting state is not blocked... 
							if (!(sds.isBlocked((currentEdge.getTarget()).getAnnotation().translate(),dom,env,this))){
									// then apply DECIDE
									System.out.print("DECIDE applied to ");
									currentQuery.print();
									Query newQuery = new Query(currentEdge.getTarget(),sds,currentQuery,currentQuery,currentEdge,true,true,false);
									System.out.print("with respect to edge " + currentEdge.print());
									System.out.println("annotated with " + currentEdge.getAnnotation().translate());
									if((currentEdge.getTarget()).isGoal()){
										System.out.println("\n\nGOAL! (Location: "+(currentEdge.getTarget()).print()+")");
										if (moreAttacks){
											goalFound = true;											
										}
										else {
											// beware: in case you have more goals, this line needs to be modified
											return;
										}
									}
									algorithmState.addQuery(newQuery);
									currentQuery.setExecuted(currentEdge);
									lastRule = 0;
									dlApplied = true;
									currentQuery = newQuery;
									
									//TIME
									decideEnd=System.nanoTime();
									timeDecide=((decideEnd-decideStart)/(double)Math.pow(10,6));
									totDecide+=timeDecide;
									currentRule=timeDecide;
									numDecide++;
									averageDecide=(totDecide/numDecide);
									//TIME
									
									break;
							}
							// else apply LEARN
							else {
//								System.out.println("DEBUG 5");
								//TIME
								interpolateStart=System.nanoTime();
								//TIME
								Formula i=this.interpolate(currentQuery.getSymbolicDataState().getConstraintSetFile(dom,env), currentQuery.getSymbolicDataState().getEnvironment(), this.RPD,currentQuery.getSymbolicDataState().getConstantSet(),currentEdge.getAction(),currentEdge.getTarget());
								// if the result of interpolate is UNSAT
								
								//TIME
								interpolateEnd=System.nanoTime();
								timeLearn=((interpolateEnd-interpolateStart)/(double)Math.pow(10,6));
								currentRule=timeLearn;
								totLearn+=timeLearn;
								numLearn++;
								averageLearn=(totLearn/numLearn);
								//TIME
								
								currentEdge.setAnnotation(i);
								System.out.print("LEARN applied to ");
								currentQuery.print();
								System.out.print("with respect to edge " + currentEdge.print());
								System.out.println(" now annotated with: "+i.translate());
								currentQuery.setExecuted(currentEdge);
								dlApplied = true;
								lastRule = 0;
								break;
							}
						}
					}
	
					if (!dlApplied) {						
						annotation = new OrFormula(currentLocation.getAnnotation(),annotation);	
						currentLocation.setAnnotation(annotation);
						System.out.print("CONJOIN applied to ");
						currentQuery.print();
						System.out.println(" with annotation: "+annotation.translate());
						lastRule = 1;
						if (currentQuery.needsLearn()) {
							learn=true;
						}
						Query auxQuery = currentQuery.getPreviousQuery();
						ActionEdge auxEdge = currentQuery.getPreviousEdge();
						if (!moreAttacks) {
							(algorithmState.getGoalLocationSet()).remove(currentLocation);
						}
						else {
							if ((currentQuery.getLocation()).isGoal()) {
								currentQuery.setGoalFound();
							}
								if (currentQuery.goalHasBeenFound()) {
									(currentQuery.getFatherQuery()).setGoalFound();
									goalFound = true;
								}								
						}
						(algorithmState.getQuerySet()).remove(currentQuery);
						currentQuery = auxQuery;
						currentEdge = auxEdge;
					}
			}
			// else if (lastRule is CONJOIN and LEARN needs to be applied)
			else {
//				System.out.println("DEBUG 6");
				if (goalFound) {
					System.out.print("(fake)LEARN applied to ");
					goalFound = false;
				}
				else {
				//TIME
				interpolateStart=System.nanoTime();
				//TIME
				
				Formula i=this.interpolate(currentQuery.getSymbolicDataState().getConstraintSetFile(dom,env), currentQuery.getSymbolicDataState().getEnvironment(), this.RPD, currentQuery.getSymbolicDataState().getConstantSet(),currentEdge.getAction(),currentEdge.getTarget());
				
				//TIME
				interpolateEnd=System.nanoTime();
				timeLearn=((interpolateEnd-interpolateStart)/(double)Math.pow(10,6));
				currentRule=timeLearn;
				totLearn+=timeLearn;
				numLearn++;
				averageLearn=(totLearn/numLearn);
				//TIME
				
				currentEdge.setAnnotation(i);
				System.out.print("LEARN applied to ");
				}
				currentQuery.print();
				System.out.print("with respect to edge " + currentEdge.print());
				System.out.println(" now annotated with: "+(currentEdge.getAnnotation()).translate());
				//currentQuery.setExecuted(currentEdge);
				lastRule = 0;
				learn = false;
			}

		}
		//TIME
		endTime = System.nanoTime();
		stepTime=(endTime-startTime)/(1000000000.0);
		total+=stepTime;
		System.out.println("\n\n ****TIME****");
		System.out.println("Step Execution time: "+stepTime+" ms");
		System.out.println("Rule Execution time: "+currentRule+" ms");
		System.out.println("Decide average time up to now: "+averageDecide+" ms");
		System.out.println("Learn average time up to now: "+averageLearn+" ms");
		System.out.println("Total up to now: "+total+" ms");
		System.out.println("Decide rule applications: "+numDecide);
		System.out.println("Learn rule applications: "+numLearn);
		System.out.println("Z3 sat time: "+this.getZ3satTime()+" ms");
		System.out.println("Z3 unsat time: "+this.getZ3unsatTime()+" ms");
		System.out.println("iZ3 time: "+this.getiZ3time()+" ms");
		System.out.println("Z3 average sat time: "+this.getZ3averageSatTime()+ "ms");
		System.out.println("Z3 average unsat time: "+this.getZ3averageUnsatTime()+ "ms");
		System.out.println("iZ3 average time: "+this.getiZ3averageTime()+" ms");
		System.out.println();
		//TIME
		}
}
	

public void fullExplore(Domain dom, Environment env) {
	this.dom=dom;
	Query currentQuery;
	Location currentLocation=new Location("test");
	Location locationToBeFound;
	ActionEdge currentEdge=null;
	Iterator<ActionEdge> iterEdges;
	Iterator<Query> iterQuery;
	Set<ActionEdge> outgoingEdges;
	SymbolicDataState sds;
	Formula annotation;//, interpolant;
	int counterIsBlocked=0;
	int counter=0;
	boolean moreAttacks = true; // 'true' if we want to search for more attacks for each goal
	AlgorithmState algorithmState = new AlgorithmState(this);
	
	iterQuery = (algorithmState.getQuerySet()).iterator();
	currentQuery=iterQuery.next();
	//TIME
	double startTime=0,endTime=0,decideStart=0,decideEnd=0;
	double totDecide=0;
	double timeDecide=0;
	double numDecide=0;
	double averageDecide=0;
	double currentRule=0;
	double total=0,stepTime=0;
	//TIME
//	Location next = this.getRoot();

	while (!((algorithmState.getQuerySet()).isEmpty())) {
		//TIME
		startTime = System.nanoTime();
		//TIME
		iterQuery = (algorithmState.getQuerySet()).iterator();
		currentQuery=iterQuery.next();
		
		System.out.println("\n\n******************     STEP "+counter+"     ******************");
		counter++;
		
		algorithmState.print();
		
		System.out.print("\n currentQuery is: ");
		currentQuery.print();

		currentLocation = currentQuery.getLocation();
		outgoingEdges = (Set<ActionEdge>)this.outgoingEdgesOf(currentLocation);
		iterEdges = outgoingEdges.iterator();
		while(iterEdges.hasNext()){
					//TIME
					decideStart=System.nanoTime();
					//TIME
					
					currentEdge=iterEdges.next();
					// execute the edge symbolically
					sds = (currentEdge.getAction()).se(currentQuery.getSymbolicDataState());
					// if the resulting state is not blocked... 
					if (!(sds.isBlocked((currentEdge.getTarget()).getAnnotation().translate(),dom,env,this))){
							// then apply DECIDE

							System.out.print("DECIDE applied to ");
							currentQuery.print();
							Query newQuery = new Query(currentEdge.getTarget(),sds,currentQuery,null,currentEdge,true,true,false);
							if((currentEdge.getTarget()).isGoal()){
								System.out.println("\n\nGOAL!");
								if (!moreAttacks){ 
									return;
								}
							}
							System.out.print("with respect to edge " + currentEdge.print());
							algorithmState.addQuery(newQuery);
							//TIME
							decideEnd=System.nanoTime();
							timeDecide=((decideEnd-decideStart)/(double)Math.pow(10,6));
							totDecide+=timeDecide;
							currentRule=timeDecide;
							numDecide++;
							averageDecide=(totDecide/numDecide);
							//TIME
					}
		}
		
		(algorithmState.getQuerySet()).remove(currentQuery);
		//TIME
		endTime = System.nanoTime();
		stepTime=(endTime-startTime)/(double)Math.pow(10,6);
		total+=stepTime;
		System.out.println("\n\n ****TIME****");
		System.out.println("Step Execution time: "+stepTime+" s");
		System.out.println("Rule Execution time: "+currentRule+" s");
		System.out.println("Decide average time up to now: "+averageDecide+" s");
		System.out.println("Total up to now: "+total+" s");
		System.out.println("Decide rule applications: "+numDecide);
		System.out.println();
		//TIME
	}
	

}


	public Formula interpolate(File Constraints, Environment env, int intruderSteps,String[] constantSet,Action lastAction,Location location){
		
		String lastActionSemantics=lastAction.getSemantics(dom, env,this.getRPD());
		String initIZ3Benchmark="\n \n:extrafuns((pair Int Int Int)(crypt Int Int Int) "+Message.getVarsList()+" )\n:extrapreds (";//((DY0 Int) (DY1 Int))";
		
		
		for(int intStepCount=0;intStepCount<=intruderSteps;intStepCount++){
			if(intStepCount==0)
				initIZ3Benchmark+="(IK Int)(IK' Int)";//+"_ Int)";
			else
				initIZ3Benchmark+="(IK"+intStepCount+" Int)";//+"_ Int)";
		}
		
		initIZ3Benchmark+=")";
			
		try{

			File intTmp = File.createTempFile("iZ3_input",".tmp");
			//intTmp.deleteOnExit();
	        BufferedWriter iz3File = new BufferedWriter(new FileWriter(intTmp));
	        BufferedReader b = new BufferedReader(new FileReader(Constraints));
	        String line=""; 
			
	        /**
	         * A partition
	         */
	        
	        //add constraints set C
	        //plus intruder
			while ((line=b.readLine()) != null) {
				if(line.startsWith(" :logic AUFLIA")){
					iz3File.write(line);
					iz3File.write(initIZ3Benchmark+"\n");
					
				}else if(line.startsWith(":formula")){				
					iz3File.write(line.replaceAll("formula","formula (and "));
					iz3File.write("\n");
				}else if(line.endsWith("EOF")){
					iz3File.write(line.replaceAll("\\);EOF",""));
				}else{
					iz3File.write(line+"\n");
				}
			}
			
			//add v=E(v)
			//in Environment there are only variables			
			Iterator<DataState> iterator=env.iterator();	
			
			while (iterator.hasNext()){
				DataState currentds=iterator.next(); 
				if(!(currentds.getVariable() instanceof IKVariable) && !(currentds.getVariable() instanceof FactVariable))
					iz3File.write(" ( = "+currentds.getVariable().interpolantString()+"  "+currentds.getValue().satString()+" ) \n");
				else if(currentds.getVariable() instanceof IKVariable)
					iz3File.write(((ParametricMessageSet)currentds.getValue()).ret_e_eq_EOfv(dom));
				else if(currentds.getVariable() instanceof FactVariable)
					iz3File.write(((ParametricTupleSet)currentds.getValue()).ret_e_eq_EOfv(dom, (FactVariable)currentds.getVariable()));
				
			}
			iz3File.write(" )\n"); //close the big AND
			
	        /**
	         * B partition
	         * 
	         * adding Sem(a)
	         * not A(location_2)'
	         * 
	         */
			iz3File.write(" :formula \n");
			iz3File.write(" (and ;added \n"); //init of the second big AND
			iz3File.write(lastActionSemantics+"\n");
			//print (not A(l_2)')
			iz3File.write(" (not "+location.getPrimedAnnotation()+" )");			
			iz3File.write(" ) ;close and\n"); //close the second big AND
			
			
			iz3File.write(" ) ;close benchmark\n"); //benchmark
			iz3File.flush();
			iz3File.close();
			b.close();			
			
			String interpolant=this.iZ3Check(intTmp);			
			Formula formula_interpolant=new Formula();
			formula_interpolant.setTranslatedFormula(interpolant);
			return formula_interpolant;

			
		}catch(Exception e){
			e.printStackTrace();
			System.exit(0);
		}
		return null;
	}
	
	
	public String iZ3Check(File temp){
		String ret="";
		try{

			if(temp.length()==0){
				System.out.println("WARNING - you are checking an empty file");
			}else{

				String cmd="iz3 -f "+ temp;
				System.out.println(cmd);
//				Process satProcess=Runtime.getRuntime().exec(cmd);
				
				double startTime=System.nanoTime();
				Process satProcess=Runtime.getRuntime().exec(cmd);
				
				//BeginOf: evaluation of sat output
				BufferedReader b = new BufferedReader(new InputStreamReader(satProcess.getInputStream()));
				String line = null;
				boolean interpolant_result=false;
				while ( ((line=b.readLine()) != null)) {
					if(interpolant_result){
						
						ret+=line+"\n";
//						System.out.println(ret);
					}
					if(line.startsWith("interpolant:")){
						double stopTime=System.nanoTime();	
						this.setiZ3time((stopTime-startTime)/(double)Math.pow(10,6));
						this.addiZ3execTime((stopTime-startTime)/(double)Math.pow(10,6));
						interpolant_result=true;
					}
						
				}
				satProcess.destroy();
				satProcess.waitFor();

				b.close();

				//endOf: evaluation of sat output
			}//endOf check length of file
		}	catch (Exception e){ 
			//System.err.println("Error: " + e.getMessage());
			e.printStackTrace();
		}
		
		return ret;
	}
	
	
 // only for printing
	public void print(){
		Set<Location> locationSet=vertexSet();
		Set<ActionEdge> edgeSet=edgeSet();
		
		System.out.println("------------ Program "+this.hashCode()+" ------------");
		System.out.println();
		System.out.println("Set of locations:");
		Iterator<Location> iter=locationSet.iterator();
		int i=1;
		while(iter.hasNext()){
			Location current=iter.next();
			System.out.println(i+". "+current.print());
			i++;
		}
		System.out.println();
		System.out.println("Initial location: "+root.print());
		System.out.println();
		System.out.println("Set of edges:");
		Iterator<ActionEdge> iterE=edgeSet.iterator();
		int iE=1;
		while(iterE.hasNext()){
			ActionEdge current=iterE.next();
			System.out.println("("+iE+") "+current.print());
			iE++;
		}
		System.out.println();
		System.out.println("--------- end of Program "+this.hashCode()+" ---------");
	}
	
}
