package se;

import java.util.ArrayList;


public class PublicKey extends Key {
	
	public PublicKey(Agent agent){
		super(agent);
	}
	
	public PublicKey(Agent agent, String messageString){
		this(agent);
		this.messageString = messageString;
	}
	
	public Message getAnotherOfTheSameType(String name){
		return new PublicKey(this.getAgent(),name);
	}
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		for(int i=0;i<mex_newMex.size();i++){
			if(mex_newMex.get(i).getElement0().equals(this))
				return mex_newMex.get(i).getElement1();
			if(mex_newMex.get(i).getElement0() instanceof AgentVariable &&
					((AgentVariable)mex_newMex.get(i).getElement0()).equals(this.getAgent()))
				return ((AgentVariable)mex_newMex.get(i).getElement1()).getPublicKey();
			if(mex_newMex.get(i).getElement0() instanceof AgentConstant &&
					((AgentConstant)mex_newMex.get(i).getElement0()).equals(this.getAgent()))
				return ((AgentConstant)mex_newMex.get(i).getElement1()).getPublicKey();
		}
		return this;
	}
	public ParametricPublicKey eval(Environment env) {
		//Debugging purpose
		//System.out.println("this is the PubKey: "+((ParametricAgent)((this.getAgent()).eval(env))).getPublicKey());
		return ((ParametricAgent)((this.getAgent()).eval(env))).getPublicKey();
	}

	public ParametricMessage eval4Domain(Environment env) {
		return ((ParametricAgent)((this.getAgent()).eval4Domain(env))).getPublicKey();
	}
	
	public String print() {
		return "PublicKey "+this.hashCode()+" of "+this.getAgent().print();
	}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		ArrayList<Pair<Message,ParametricMessage>> ass=new ArrayList<Pair<Message,ParametricMessage>>();
		ass.add(assignment);
		return this.interpolantString(env,ass);
	}
	
	public String interpolantString(Environment env){
		String ret="";

		//two cases: key(constant) \/ key(variable)

		//if key(constant)
		if(this.getAgent().getClass().equals(AgentConstant.class)){
			ret+=((ParametricAgentConstant)(this.getAgent().eval(env))).getPublicKey().satString();
		}else if(this.getAgent().getClass().equals(AgentVariable.class)){
			ret+="(pk "+this.getAgent().interpolantString(env)+")";
		}

		return ret;
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment){
		String ret="";
		
		if(this.getAgent().getClass().equals(AgentConstant.class)){
			ret+=((ParametricAgentConstant)(this.getAgent().eval(env))).getPublicKey().satString();
		}else if(this.getAgent().getClass().equals(AgentVariable.class)){
			ret+="(pk "+this.getAgent().interpolantString(env,assignment)+")";
		}
		
		return ret;
	}
	
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){
		return this.getAgent().getVars(list);
	}
	
	public String toString(){
		return "pk("+ this.getAgent().toString() +")";
	}
}