package se;

import java.util.ArrayList;


public class PublicKeyParameter extends ParametricPublicKey implements Parameter {
	
	private int uid=getNewUID();
	private String name="ParametricPublicKey"+this.getUID();
	
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}

	
	public String print() {
		return this.getName()+ " (of " + this.getParametricAgent().print()+")";
	}
	public String getConstant(){
		return this.satString();
	}
	
	public String print(int i) {
		int j;
		String string="";
		for (j=0;j<i;j++){
			string = string + "\t";
		}
		return string+this.getName()+ " (of " + this.getParametricAgent().print()+")";
	}
	
	public PublicKeyParameter(ParametricAgent parametricAgent){
		super(parametricAgent);
		ParametricMessage.addVar2VariablesList("PPubK"+getUID());
	}	
	
	public ArrayList<ParametricMessage> getPvtKey(ArrayList<ParametricMessage> pm_list){return pm_list;}
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		params=this.getParametricAgent().getParameters(params);
		return params;
	}

	public void add2Domain(Domain domain){domain.add(this);}
	public void add2Domain(Domain domain,IKStdConstraint ik){
		domain.add2DomainPMparams(this);
		domain.add2DomainPMparams(this.getParametricAgent().getPrivateKey());
		domain.add(this,ik);
		domain.add(this.getParametricAgent().getPrivateKey(),ik);	
	}
	
	public ArrayList<ParametricMessage> Msg2List(ArrayList<ParametricMessage> list,ParametricEncryptedMessage enc,ParametricConcatenatedMessage pair){
		list.add(this);
		return list;
	}
	public Pair<Boolean,ArrayList<ParametricMessage[]>> compare(ParametricMessage m,ArrayList<ParametricMessage[]> l){
		if(m.getClass().equals(ParametricPublicKeyConstant.class)){
			//they're similar
			//add the assignment to l
			ParametricMessage[] ret=new ParametricMessage[2];
			ret[0]=this;
			ret[1]=m;
			l.add(ret);
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(true,l);
		}else if(this.equals(m)){
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(true,l);
		}else{
			//they're not equal
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(false,null);
		}
	}
	public ArrayList<ArrayList<ParametricMessage>> getParams(ArrayList<ArrayList<ParametricMessage>> params){
		boolean added=false;
		
		for(int i=0;i<params.size();i++)
			if(params.get(i).get(0).getClass().equals(this.getClass())){
				params.get(i).add(this);
				added=true;
			}
		
		if(!added){
			ArrayList<ParametricMessage> temp=new ArrayList<ParametricMessage>();
			temp.add(this);
			params.add(temp);
		}
		return params;
	}
	public boolean sameEquivalenceClass(ParametricMessage pm){
		if(this.getClass().equals(pm.getClass())){
			return true;
		}else 
			return false;
	}
	
	//sat strings
	public String satString(){
		return "PPubK"+getUID();
	}
	public String satString(Pair<ParametricMessage, ParametricMessage> assignment){
		if(assignment.getElement0() instanceof ParametricAgent){
			if(assignment.getElement0().satString().equals(this.getParametricAgent().satString())){
				return ((ParametricAgentConstant)assignment.getElement1()).getPrivateKey().satString();
			}
		}
		return this.satString();
	}
	public String satString(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment){
				for(int i=0;i<assignment.size();i++){
			if(assignment.get(i).getElement0().satString().equals(this.satString())){
				return assignment.get(i).getElement1().satString();
			}
		}

		return this.satString();
	}
}
