package se;
import java.util.HashSet;

public class Query {
	
	private Location location;
	private SymbolicDataState symbolicDataState;
	private HashSet<ActionEdge> executed;
	private Query previousQuery;
	private Query fatherQuery;
	private ActionEdge previousEdge;
	private boolean annotate;
	private boolean learn;
	private boolean goalFound;
	
		// constructor
	public Query(Location l, SymbolicDataState sds, Query prevQuery, Query fathQuery, ActionEdge edge, boolean toBeAnnotated, boolean learn, boolean gFound) {
		location = l;
		symbolicDataState = sds;
		executed = new HashSet<ActionEdge>();
		previousQuery = prevQuery;
		fatherQuery = fathQuery;
		previousEdge = edge;
		annotate = toBeAnnotated;
		this.learn = learn;
		goalFound = gFound;
	}
	
	public boolean needsToBeAnnotated() {
		return annotate;
	}
	
	public Location getLocation() {
		return location;
	}

	public boolean needsLearn() {
		return learn;
	}

	public boolean goalHasBeenFound() {
		return goalFound;
	}
	
	public void setLearn(boolean learn) {
		this.learn=learn;
	}		
	
	public Query getPreviousQuery() {
		return previousQuery;
	}
	
	public void setPreviousQuery(Query query) {
		previousQuery=query;
	}	
	
	public Query getFatherQuery() {
		return fatherQuery;
	}
	
	public void setFatherQuery(Query query) {
		fatherQuery=query;
	}	
	
	public ActionEdge getPreviousEdge() {
		return previousEdge;
	}
	
	public void setPreviousEdge(ActionEdge edge) {
		previousEdge=edge;
	}	
	
	public SymbolicDataState getSymbolicDataState() {
		return symbolicDataState;
	}

	public HashSet<ActionEdge> getExecuted() {
		return executed;
	}	

	public void setExecuted(ActionEdge actionEdge) {
		executed.add(actionEdge);
	}
	
	public void setGoalFound() {
		goalFound = true;
	}
	
		// to be defined
	public boolean isBlocked(Formula phi){
		return true;
	}
	
	public void print() {
		System.out.println("Query "+this.hashCode()+" : Location= "+this.location.print()+", SymbolicDataState= "+symbolicDataState.hashCode());
//		symbolicDataState.print();
	}
	
	public void printShort() {
		System.out.println("Query "+this.hashCode()+" : Location= "+this.location.print()+", SymbolicDataState= "+symbolicDataState.hashCode());
		symbolicDataState.hashCode();
	}
	
}
