package se;

import java.util.ArrayList;


public class SymEncryptedMessage extends Message{
	
	Message message;
	SymKey key;
	
	public SymEncryptedMessage(Message m, SymKey k){
		this.message = m;
		this.key = k;
	}
	
	public Message getAnotherOfTheSameType(String name){
		return new SymEncryptedMessage(this.message.getAnotherOfTheSameType(name),(SymKey)this.key.getAnotherOfTheSameType(name));
	}
	
	public SymEncryptedMessage(Message m, SymKey k, String messageString){
		this(m, k);
		this.messageString = messageString;
	}
	
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		return new SymEncryptedMessage((Message)this.message.substitute(mex_newMex),(SymKey)this.key.substitute(mex_newMex));
	}

	public ParametricSymEncryptedMessage eval(Environment env){
//		System.out.println("M= "+this.message.print()+" & K="+this.key.print());
		ParametricSymEncryptedMessage epm = new ParametricSymEncryptedMessage(this.message.eval(env),((SymKey)this.key).eval(env));
		return epm;
	}	

	public String print() {
		return "SymEncryptedMessage "+this.hashCode()+" : {"+this.message.print()+ "}_{" + this.key.print()+"}";
	}

	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){		
		list=this.message.getVars(list);
		list=this.key.getVars(list);
		return list;
	}
	
	public ParametricMessage eval4Domain(Environment env){
//		System.out.println("DEBUG Eval4Dom prima: "+this.print());
		ParametricSymEncryptedMessage a=new ParametricSymEncryptedMessage((ParametricMessage)this.message.eval4Domain(env),(ParametricSymKey)this.key.eval4Domain(env));
//		System.out.println("DEBUG Eval4Dom dopo: "+a.satString());
		return a;
	}
	
	//interpolant strings
	public String interpolantString(Environment env){
		return "(scrypt "+this.message.interpolantString(env)+" "+this.key.interpolantString(env)+")";
	}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		return "(scrypt "+this.message.interpolantString(env,assignment)+" "+this.key.interpolantString(env,assignment)+")";
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message,ParametricMessage>> assignment){		
		return "(scrypt "+this.message.interpolantString(env,assignment)+" "+this.key.interpolantString(env,assignment)+")";
	}
	
	public String toString(){
		return this.messageString;
	}
	
	public Message getMessage(){return this.message;}
	public Message getKey(){return this.key;}
	
//	public boolean equals(Object m){
////		if(m.getClass().equals(SymEncryptedMessage.class))
////			System.out.println("CIAO! \n"+((Message)m).print()+" != \n"+this.print()+"\n");
//		boolean ret=false;
////		if(m==null){return false;}
//////		if(m==this){return true;}
////		
////		if(m.getClass().equals(SymEncryptedMessage.class)){
////
////			if(this.getMessage().equals(((SymEncryptedMessage)m).getMessage()) &&
////					this.getKey().equals(((SymEncryptedMessage)m).getKey())){
////				ret=true;
////			}
////		}
//		return ret;
//	}
}
