package se;

import java.util.ArrayList;

public class SymKeyConstant extends SymKey implements Constant {
	private ParametricSymKeyConstant skc;
	
	public SymKeyConstant(){
		this.skc = new ParametricSymKeyConstant();
	}
	public Message getAnotherOfTheSameType(String name){
		return new SymKeyConstant(name);
	}
	
	public SymKeyConstant(String messageString){
		this();
		this.messageString = messageString;
	}
	
	public ParametricMessage eval4Domain(){return this.skc;}

	public ParametricSymKeyConstant getParametricSymKeyConstant(){
		return this.skc;
	}
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		for(int i=0;i<mex_newMex.size();i++){
			if(mex_newMex.get(i).getElement0().equals(this))
				return mex_newMex.get(i).getElement1();
		}
		return this;
	}
	public ParametricSymKeyConstant eval(Environment env) {
		return this.getParametricSymKeyConstant();
	}
	
	public String print() {
		return "SymKeyConstant "+this.hashCode()+ " (with ParametricSymKeyConstant " + this.skc.print()+")";
	}	
	
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){return list;}

	//interpolantString
	public String interpolantString(Environment env){
		return this.getParametricSymKeyConstant().satString();
	}
	
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		return this.getParametricSymKeyConstant().satString();
	}
	
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment){
		return this.getParametricSymKeyConstant().satString();
	}
	
	public String toString(){
		return this.messageString;
	}
}
