package se;

import java.util.*;

public class SymKeyVariable extends SymKey implements Variable {
	
	
	public SymKeyVariable(){
		Message.addVar2VariablesList(this.interpolantString());
	}
	
	public Message getAnotherOfTheSameType(String name){
		return new SymKeyVariable(name);
	}
	
	public SymKeyVariable(String messageString){
		this();
		this.messageString = messageString;
	}
	
	private SymKeyParameter fakeParam=new SymKeyParameter();
	public ParametricMessage eval4Domain(Environment env){return this.getFakeParam();}
	private int uid=getNewUID();
	private String name="SymKeyVariable"+this.getUID();
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		for(int i=0;i<mex_newMex.size();i++){
			if(mex_newMex.get(i).getElement0().equals(this))
				return mex_newMex.get(i).getElement1();
		}
		return this;
	}
	public String print() {
		return this.getName();
	}
	
	public ParametricSymKey eval(Environment env) {
		
		DataState ds;
		
		Iterator<DataState> iter = env.iterator();
		while (iter.hasNext()){
			ds = iter.next();
			if (ds.getVariable() == this) 
				return (ParametricSymKey)(ds.getValue());				
		}
		return null;		
	}

	public Variable getDataState(Environment env){return this;}
	
	public String prime(){
		Message.addVar2VariablesList("SKV'"+getUID());
		return "SKV'"+getUID();
	}
	
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){
		for(int i=0;i<list.size();i++)
			if(list.get(i).get(0).getClass().equals(this.getClass())){
				list.get(i).add(this);
				return list;
			}
				
		ArrayList<Message> tmp=new ArrayList<Message>();
		tmp.add(this);
		list.add(tmp);
		return list;
	}
	public ParametricMessage getFakeParam(){
		return this.fakeParam;
	}

	//interpolant strings
	public String interpolantString(Environment env){
		return "SKV"+getUID();
	}
	public String interpolantString(){
		return "SKV"+getUID();
	}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		
		if(assignment.getElement0().interpolantString(env).equals(this.interpolantString(env))){
			return assignment.getElement1().satString();
		}
		
		return this.interpolantString(env);
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment){
		
		for(int i=0;i<assignment.size();i++){
			if(assignment.get(i).getElement0().interpolantString(env).equals(this.interpolantString(env))){
				return assignment.get(i).getElement1().satString();
			}
		}
		
		return this.interpolantString(env);
	}
	
	public String toString(){
		return this.messageString;
	}
}
