package se;

import java.util.ArrayList;

/** singleton true
 * this because we want only one instance of this class.
 * In fact, iT does not make sense to have different istances of
 * the constraint True.
 * 
 * To create an instance... or better THE instance of this class:
 * True trueObj=True.getInstance(); OR directly True.getInstance()
 */

public class True extends StdConstraint{ 

		 
		  /**
		   * Private constructor because we want to control the creation of an instance.
		   */
		  private True() {}
		 
		  /**
		   * The TrueWrapper class is initialized at the first exection of the method getInstance()
		   * (at the very first access to TrueWrapper.TrueInstance, in a thread-safe way)
		   */
		  private static class TrueWrapper { 
		    private final static True TrueInstance = new True();
		  }
		 
		  public static True getInstance() {
		    return TrueWrapper.TrueInstance;
		  }
		
		  public boolean equalTo(StdConstraint stdConstraint){
			  if(stdConstraint instanceof True) 
			  {return true;}
			  return false;
		  }
		  
		  public String satPrint(Domain dom){
			  return "true\n";
		  }
		  public String satPrint(Pair<ParametricMessage, ParametricMessage> assignment,Domain dom){return "true\n";}
		  public String satPrint(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment,Domain dom){return "true\n";}
		  

		  public String getConstantsFromConstraint(){return "true ";}
		  public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){return params;}
		  
		  public String getFunctionNameFromConstraint(){return "";}
			public String print() {
				return "TRUE";
			}			  

			public String print(int i) {
				int j;
				String string="";
				for (j=0;j<i;j++){
					string = string + "\t";
				}
				return string+"TRUE";
			}
			public void createDomain(Domain domain){}
}