package se;

import java.util.ArrayList;




public class TrueConstant extends BooleanConstant{ 


	/**
	 * Private constructor because we want to control the creation of an instance.
	 */
	private TrueConstant() {}

	/**
	 * The TrueWrapper class is initialized at the first exection of the method getInstance()
	 * (at the very first access to TrueWrapper.TrueInstance, in a thread-safe way)
	 */
	private static class TrueConstantWrapper { 
		private final static TrueConstant TrueConstantInstance = new TrueConstant();
		private final static ParametricTrueConstant parametricTrueConstant = ParametricTrueConstant.getInstance();
	}
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){return this;}
	public String interpolantString(Environment env){
		return "true";
	}
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment) {
		return "true";
	}
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		return "true";
	}
	public static TrueConstant getInstance() {
		return TrueConstantWrapper.TrueConstantInstance;
	}
	
	public ParametricMessage eval4Domain(){return null;}
	
	public ParametricTrueConstant eval(Environment env) {
		return TrueConstantWrapper.parametricTrueConstant;
	}

	public String print() {
		return "TRUE_Constant";
	}	

}