package se;

import java.util.ArrayList;

public class Tuple implements Evaluable {

	private Message[] args;
	String actionString="";
	
	public Tuple(Message[] args){
		this.args=args;
	}
	public Tuple(Message[] args, String actionString){
		this.args=args;
		this.actionString = actionString;
	}

	public Message[] getArgs(){return this.args;}
	
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		String tmp_actionString="<";
		Message[] tmp_args=new Message[this.args.length];
		
		for(int i=0;i<args.length-1;i++){
			tmp_args[i]=(Message)args[i].substitute(mex_newMex);
			tmp_actionString+=tmp_args[i].toString()+", ";
		}
		tmp_args[args.length-1]=(Message)args[args.length-1].substitute(mex_newMex);
		tmp_actionString+=tmp_args[args.length-1].toString()+"";
		tmp_actionString+=">";
		//this.args=tmp_args;
		//this.actionString=tmp_actionString;
		return new Tuple(tmp_args,tmp_actionString);
	}

//	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
//		
//		this.actionString="<";
////		System.out.println("args length="+args.length);
////		for(int j=0;j<mex_newMex.size();j++)
////			System.out.println("mex_newMex["+j+"] = "+mex_newMex.get(j).getElement0().toString()+" HC "+mex_newMex.get(j).getElement0().hashCode());
////		System.out.println();
//		
//		for(int i=0;i<args.length-1;i++){
////			System.out.println("DEBUG args["+i+"] = "+args[i].toString()+" HC "+args[i].hashCode());
//			args[i]=(Message)args[i].substitute(mex_newMex);
//			this.actionString+=args[i].toString()+", ";
//		}
//		args[args.length-1]=(Message)args[args.length-1].substitute(mex_newMex);
//		this.actionString+=args[args.length-1].toString()+"";
//		this.actionString+=">";
//		return this;
//	}
	
	public ParametricTuple eval(Environment env) {
		ParametricMessage[] parametricArgs=new ParametricMessage[this.getArgs().length];
		for(int i=0;i<this.getArgs().length;i++){
			parametricArgs[i]=this.getArgs()[i].eval(env);
		}
		return new ParametricTuple(parametricArgs);
	}

	public String print() {
		String ret="";
		for(int i=0;i<this.getArgs().length;i++)
			ret+=this.getArgs()[i].print();
		return "<"+ret+">";
	}	

	public String interpolantString(Environment env){
		String ret="";
		for(int i=0;i<this.getArgs().length;i++)
			ret+=this.getArgs()[i].interpolantString(env)+" ";
		return ret;
	}
	
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment) {
		String ret="";
		for(int i=0;i<this.getArgs().length;i++)
			ret+=this.getArgs()[i].interpolantString(env,assignment)+" ";
		return ret;
	}

	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		ArrayList<Pair<Message,ParametricMessage>> ass=new ArrayList<Pair<Message,ParametricMessage>>();
		ass.add(assignment);
		return this.interpolantString(env,ass);
	}

	public String interpolantString(){
		String ret="";
		for(int i=0;i<this.getArgs().length;i++)
			ret+=this.getArgs()[i].print();
		return "<"+ret+">";
	}

	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){return list;}
	public String toString(){
		return this.actionString;
	}
}
