package translator;
import java.io.File;
import javax.swing.filechooser.*;

/**
 * Filter class for the file chooser to filter ASLan++ files.
 * 
 * @author Fabio Pettenuzzo
 * @author Marco Palamà
 * @version 1.0, 12/13
 */
public class ASLanppFilter extends FileFilter {
 
   /**
	 * Accept only ASLan++ files.
	 * @param file Input file
	 * @return true if accepted false otherwise
	 */
    public boolean accept(File file) {
        if (file.isDirectory()) {
            return true;
        }
 
        String path = file.getAbsolutePath().toLowerCase();
        String extension = "aslan++";
        if ((path.endsWith(extension) && (path.charAt(path.length() - extension.length() - 1)) == '.')) {
          return true;
        }
 
        return false;
    }
 
    /**
     *  The description of this filter
     *  @return ASLan++
     */
    public String getDescription() {
        return "ASLan++";
    }
}